#include "Boy.h"
#include "Girl.h"
#include "AssaultRifle01.h"

using namespace EnemyBase;
using namespace AssaultRifle01;

C_AssaultRifle01::C_AssaultRifle01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.0, 0.8, 0.4);
	body.getMaterial()->setShininess(100.0);

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_ASSAULT_RIFLE01].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_AssaultRifle01::~C_AssaultRifle01()
{
}

// ړ
void C_AssaultRifle01::move()
{
	spd.init();				// ړx0ɖ߂
	updateDistToPlayer();	// vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		lockTarget = lockGirl();		// {Igirl_

		// ړ̃^C}[JEgĂ
		timer.at(MOVE_TIMER).setTime(timer.at(MOVE_TIMER).getTime() + 1, false);

		// lockTargetɉčsς
		if(lockTarget == BOY)
		{
			turnToBoy(TURN_SPEED);	// 

			// Ə͍Ă邯ǁAKȂČĂȂ܂ܒԌoOɌ
			if(getIsLock() && timer.at(MOVE_TIMER).getTime() >= 120)
			{
				timer.at(ATTACK_TIMER).setTime(RIFLE_TIME + RIFLE_DELAY);
				timer.at(RIFLE_TIMER).setTime(RIFLE_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
			// Ă
			else if(distToBoy > ATTACK_DIST + ALLOW_DIST)
			{
				spd.z = -SPEED;	// ߂Â
			}
			// ߂
			else if(distToBoy < ATTACK_DIST - ALLOW_DIST)
			{
				spd.z = SPEED;	// 
			}
			else if(getIsLock())	// KɋāAƏĂ΍U
			{
				timer.at(ATTACK_TIMER).setTime(RIFLE_TIME + RIFLE_DELAY);
				timer.at(RIFLE_TIMER).setTime(RIFLE_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
		}
		else if(lockTarget == GIRL)
		{
			turnToGirl(TURN_SPEED);	// 

			// Ə͍Ă邯ǁAKȂČĂȂ܂ܒԌoOɌ
			if(getIsLock() && timer.at(MOVE_TIMER).getTime() >= 120)
			{
				timer.at(ATTACK_TIMER).setTime(RIFLE_TIME + RIFLE_DELAY);
				timer.at(RIFLE_TIMER).setTime(RIFLE_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
			// Ă
			else if(distToGirl > ATTACK_DIST + ALLOW_DIST)
			{
				spd.z = -SPEED;	// ߂Â
			}
			// ߂
			else if(distToGirl < ATTACK_DIST - ALLOW_DIST)
			{
				spd.z = SPEED;
			}
			else if(getIsLock())	// KɋāAƏĂ΍U
			{
				timer.at(ATTACK_TIMER).setTime(RIFLE_TIME + RIFLE_DELAY);
				timer.at(RIFLE_TIMER).setTime(RIFLE_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_AssaultRifle01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		if(timer.at(RIFLE_TIMER).getTime() != 0 && timer.at(RIFLE_TIMER).getTime() % RIFLE_INTERVAL == 0)
		{
			atkSphere.push_back(new C_HitSphereModel(RIFLE_RAD, RIFLE_POWER, RIFLE_LIMIT, RIFLE_SPEED, false));
			atkSphere.back()->setMaterial(Purple);
			atkSphere.back()->glMoveTo(pos);
			atkSphere.back()->glVec(body.getVec());
			atkSphere.back()->loTranslate(0.0, 0.0, -60.0);
			atkSphere.back()->loFocus(GetRand(-2, 2) * 0.1, 0.0, -1.0);	// ΂
			scene->entryModel(atkSphere.back());
		}
	}

	// ëړƏŏ
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		atkSphere.at(i)->move();	// ëړ

		// ŎԂɂȂ邩AǂɓĂ
		if(atkSphere.at(i)->cntLimit() || map->isHit(atkSphere.at(i)))
		{
			scene->removeModel(atkSphere.at(i));
			SAFE_DELETE(atkSphere.at(i));
			itSphere = atkSphere.begin();
			itSphere += i;
			itSphere = atkSphere.erase(itSphere);
		}
	}
}