#include "Boy.h"
#include "Girl.h"
#include "Bomb01.h"

using namespace EnemyBase;
using namespace Bomb01;

C_Bomb01::C_Bomb01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 20.0);
	body.glMoveTo(0.0, 20.0, 0.0);
	//body.setMaterial(LavaRed);
	body.setMaterial(White);
	body.getMaterial()->setSpecular(0.8, 0.2, 0.2);
	body.getMaterial()->setShininess(100.0);

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_BOMB01].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(30.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Bomb01::~C_Bomb01()
{
}

// ړ
void C_Bomb01::move()
{
	spd.init();				// ړx0ɖ߂
	updateDistToPlayer();	// vC[Ƃ̋XV
	
	// {Iboy_
	lockTarget = lockBoy();
	//lockTarget = BOY;
	//if(boy->getDeath_flag() && !girl->getDeath_flag())	lockTarget = GIRL;

	// Ȃ
	if(timer.at(EXPLOSION_TIMER).getTime() == -1)
	{
		// 1_[WłH炦Δ
		if(hp < HP_MAX)						timer.at(EXPLOSION_TIMER).setTime(EXPLOSION_TIME);

		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);
			// ꂷĂ
			if(distToBoy > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// Kɂ甚
			else							timer.at(EXPLOSION_TIMER).setTime(EXPLOSION_TIME);

			// girl߂Ă
			if(distToGirl < ATTACK_DIST * 0.5 && !girl->getDeath_flag())	timer.at(EXPLOSION_TIMER).setTime(EXPLOSION_TIME);
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// ꂷĂ
			if(distToGirl > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// Kɂ甚
			else							timer.at(EXPLOSION_TIMER).setTime(EXPLOSION_TIME);
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Bomb01::attack()
{
	if(timer.at(EXPLOSION_TIMER).getTime() > 0)
	{
		// ̏uԂɋ̂𐶐
		if(timer.at(EXPLOSION_TIMER).getTime() == EXPLOSION_TIME - TRIGGER_TIME)
		{
			atkSphere.push_back(new C_HitSphereModel(EXPLOSION_PRIMAL_SIZE, EXPLOSION_POWER, EXPLOSION_TIME - TRIGGER_TIME, true, ENEMY_SINGLE_ATTACK));
			atkSphere.back()->setMaterial(LavaRed);
			atkSphere.back()->getMaterial()->setAlpha(0.6);
			atkSphere.back()->glMoveTo(pos);
			scene->entryModel(atkSphere.back());

			// SE
			sound.se_on(SE_BOMB_EXPLOSION);
		}

		// ܂L鎞Ԃł
		if(EXPLOSION_TIME - TRIGGER_TIME - EXPLOSION_CREATE_TIME < timer.at(EXPLOSION_TIMER).getTime() && timer.at(EXPLOSION_TIMER).getTime() < EXPLOSION_TIME - TRIGGER_TIME)
		{
			atkSphere.back()->setRad(atkSphere.back()->getRad() + EXPLOSION_SPREAD_SIZE);
		}
	}
	// I
	else if(timer.at(EXPLOSION_TIMER).getTime() == 0)
	{
		hp = 0;	// 

		scene->removeModel(atkSphere.back());		// ̂remove
		SAFE_DELETE(atkSphere.back());
		atkSphere.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}