#include "Boy.h"
#include "Girl.h"
#include "Boss01.h"

using namespace EnemyBase;
using namespace Boss01;

C_Boss01::C_Boss01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl, vector<C_EnemyBase *> *argArray, vector<C_EnemyBase *>::iterator *argIt, int *argTotalNum)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
, enemyArray(argArray)
, itEnemyArray(argIt)
, totalEnemyNum(argTotalNum)
{
	body.create(6, 300.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(Gray1);
	body.getMaterial()->setAlpha(0.8);
	body.getMaterial()->setSpecular(0.0, 0.8, 1.0);
	body.getMaterial()->setShininess(100.0);

	isHeavy = true;			// vC[ȂdG
	isBoot = true;			// ŏAI͋NĂ
	isCollision = false;	// p[cmƂ͓蔻𖳌ɂ
	lockAble = false;		// {̂̓bNIs\

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_BOSS01].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	model.setScale(180.0);
	//model.setScale(1.0, 1.5, 1.0);
	model.glMoveTo(0.0, 0.0, -250.0);
	model.setParent(&body, true);

	//body.glFocus(0.0, body.getInhPosition().y, 100.0);

	hp = hp_max = HP_MAX;

	// {X̂߂orange_bar, gray_frame܂ʂɗpӂ̂ʓ|Ȃ̂greenőp
	if(green_bar.readPNG("Data/CG/orange_bar.png") == false)		fl_alert("orange_bar File Read Error!");
	green_bar.setSpriteSmoothMode(false);
	if(green_frame.readPNG("Data/CG/gray_frame.png") == false)		fl_alert("gray_frame File Read Error!");
	green_frame.setSpriteSmoothMode(false);

	// DFt[
	green_frame.setSpriteSize(Boss01::GAUGE_SIZE_X + 26.0);
	green_frame.glMoveTo(Boss01::GAUGE_POS_X, Boss01::GAUGE_POS_Y, 0.0);

	// Q[W
	green_bar.setSpriteSize(Boss01::GAUGE_SIZE_X);	// Q[W̕ݒ
	green_bar.glMoveTo(Boss01::GAUGE_POS_X, Boss01::GAUGE_POS_Y, 0.0);

	assemble();	// p[cg

	timer.resize(TIMER_MAX);
}

C_Boss01::~C_Boss01()
{
}

// p[cg
void C_Boss01::assemble()
{
	// 
	fist_L = new C_Boss01_Fist_L(scene, camera, map, boy, girl);
	enemyArray->push_back(fist_L);
	body.entryChild(enemyArray->back()->getBody(), true);
	enemyArray->back()->setId(*totalEnemyNum);	// GIDZbg
	++*totalEnemyNum;		// G̗݌v̂ŃCNg
	fist_L->replaceHp(&hp);	// hpL
	enemyArray->back()->entryScene(scene);

	// E
	fist_R = new C_Boss01_Fist_R(scene, camera, map, boy, girl);
	enemyArray->push_back(fist_R);
	body.entryChild(enemyArray->back()->getBody(), true);
	enemyArray->back()->setId(*totalEnemyNum);	// GIDZbg
	++*totalEnemyNum;		// G̗݌v̂ŃCNg
	fist_R->replaceHp(&hp);	// hpL
	enemyArray->back()->entryScene(scene);

	// 
	shoulder_L = new C_Boss01_Shoulder_L(scene, camera, map, boy, girl);
	enemyArray->push_back(shoulder_L);
	body.entryChild(enemyArray->back()->getBody(), true);
	enemyArray->back()->setId(*totalEnemyNum);	// GIDZbg
	++*totalEnemyNum;			// G̗݌v̂ŃCNg
	shoulder_L->replaceHp(&hp);	// hpL
	enemyArray->back()->entryScene(scene);

	// E
	shoulder_R = new C_Boss01_Shoulder_R(scene, camera, map, boy, girl);
	enemyArray->push_back(shoulder_R);
	body.entryChild(enemyArray->back()->getBody(), true);
	enemyArray->back()->setId(*totalEnemyNum);	// GIDZbg
	++*totalEnemyNum;			// G̗݌v̂ŃCNg
	shoulder_R->replaceHp(&hp);	// hpL
	enemyArray->back()->entryScene(scene);

	// 
	head = new C_Boss01_Head(scene, camera, map, boy, girl);
	enemyArray->push_back(head);
	body.entryChild(enemyArray->back()->getBody(), true);
	enemyArray->back()->setId(*totalEnemyNum);	// GIDZbg
	++*totalEnemyNum;		// G̗݌v̂ŃCNg
	head->replaceHp(&hp);	// hpL
	enemyArray->back()->entryScene(scene);
	head->setLockAble(false);	// ŏ̓bNIłȂ
}

// ړ
void C_Boss01::move()
{
	spd.init();						// ړx0ɖ߂
	updateDistToPlayer();			// vC[Ƃ̋XV

	// s߂
	if(timer.at(THINK_TIMER).getTime() <= 0 && timer.at(ATTACK_TIMER).getTime() <= 0
		&& shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER1).getTime() <= 0
		&& shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER1).getTime() <= 0
		&& head->timer.at(Boss01_Head::FALL_TIMER2).getTime() <= 0)
	{
		int oldAttackPattern = attackPattern;	// Õp^[ۑ

		do
		{
			// Ũp^[߂
			attackPattern = GetRand(0, ATTACK_PATTERN_MAX - 1);
		}
		while(oldAttackPattern == attackPattern);

		// Up^[i[
		patternArray.push_back(attackPattern);
		// 6ȏ͊i[Ȃ
		if(patternArray.size() > 5)	patternArray.pop_front();

		// i[p^[Ƀ~TC狭IɃ~TC
		if(patternArray.size() >= 5)
		{
			bool missile_exist = false;
			for(unsigned int i = 0; i < patternArray.size(); ++i)
			{
				if(patternArray.at(i) == MISSILE)	missile_exist = true;
			}

			if(missile_exist == false)
			{
				attackPattern = MISSILE;
				patternArray.pop_back();
				patternArray.push_back(attackPattern);
			}
		}

		// Up^[ɉčsς
		switch(attackPattern)
		{
		case GRAND:
			timer.at(ATTACK_TIMER).setTime(300);
			fist_L->timer.at(Boss01_Fist_L::GRAND_TIMER).setTime(300);
			fist_R->timer.at(Boss01_Fist_R::GRAND_TIMER).setTime(300);
			break;
		case MOW_L:
			timer.at(ATTACK_TIMER).setTime(320);
			fist_L->timer.at(Boss01_Fist_L::MOW_TIMER).setTime(320);
			break;
		case MOW_R:
			timer.at(ATTACK_TIMER).setTime(320);
			fist_R->timer.at(Boss01_Fist_R::MOW_TIMER).setTime(320);
			break;
		case MISSILE:
			timer.at(ATTACK_TIMER).setTime(90);
			shoulder_L->timer.at(Boss01_Shoulder_L::MISSILE_TIMER).setTime(90);
			shoulder_R->timer.at(Boss01_Shoulder_R::MISSILE_TIMER).setTime(90);
			scene->entryModel(&shoulder_L->marker);	// }[J[
			scene->entryModel(&shoulder_R->marker);
			break;
		default:
			break;
		}
	}

	// _EԂǗ
	// 1iKڂ̃_E()
	if(shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER1).getTime() > 0)
	{
		// ŏShoulder̃^C}[L
		if(fist_L->timer.at(Boss01_Fist_L::FALL_TIMER1).getTime() < 0)
		{
			shoulder_R->timer.at(Boss01_Shoulder_R::MISSILE_TIMER).setTime(0);	// ̌[U[ōUĂ悤
			fist_L->timer.at(Boss01_Fist_L::FALL_TIMER1).setTime(shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER1).getTime());
			scene->removeModel(&shoulder_L->marker);	// }[J[
			scene->removeModel(&shoulder_R->marker);
			scene->entryModel(&fist_L->marker);
		}
		// ŏӊOFist̃^C}[L
		else
		{
			shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER1).setTime(fist_L->timer.at(Boss01_Fist_L::FALL_TIMER1).getTime());
		}
	}
	// 1iKڂ̃_E(E)
	else if(shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER1).getTime() > 0)
	{
		// ŏShoulder̃^C}[L
		if(fist_R->timer.at(Boss01_Fist_R::FALL_TIMER1).getTime() < 0)
		{
			shoulder_L->timer.at(Boss01_Shoulder_L::MISSILE_TIMER).setTime(0);	// ̌[U[ōUĂ悤
			fist_R->timer.at(Boss01_Fist_R::FALL_TIMER1).setTime(shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER1).getTime());
			scene->removeModel(&shoulder_R->marker);	// }[J[
			scene->removeModel(&shoulder_L->marker);
			scene->entryModel(&fist_R->marker);
		}
		// ŏӊOFist̃^C}[L
		else
		{
			shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER1).setTime(fist_R->timer.at(Boss01_Fist_R::FALL_TIMER1).getTime());
		}
	}

	// 2iKڂ̃_E()
	if(fist_L->timer.at(Boss01_Fist_L::FALL_TIMER2).getTime() > 0)
	{
		// ŏFist̃^C}[L
		if(head->timer.at(Boss01_Head::FALL_TIMER2).getTime() < 0)
		{
			fist_L->timer.at(Boss01_Fist_L::FALL_TIMER1).setTime(0);
			shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER1).setTime(0);
			head->timer.at(Boss01_Head::FALL_TIMER2).setTime(fist_L->timer.at(Boss01_Fist_L::FALL_TIMER2).getTime());

			scene->removeModel(&fist_L->marker);	// }[J[
			scene->entryModel(&head->marker);

			// bN\
			head->setLockAble(true);
			fist_L->setLockAble(false);
			fist_R->setLockAble(false);
			shoulder_L->setLockAble(false);
			shoulder_R->setLockAble(false);
		}
		// ŏӊOhead̃^C}[L
		else
		{
			fist_L->timer.at(Boss01_Fist_L::FALL_TIMER2).setTime(head->timer.at(Boss01_Head::FALL_TIMER2).getTime());
			shoulder_L->timer.at(Boss01_Shoulder_L::FALL_TIMER2).setTime(head->timer.at(Boss01_Head::FALL_TIMER2).getTime());
		}
	}
	// 2iKڂ̃_E(E)
	else if(fist_R->timer.at(Boss01_Fist_R::FALL_TIMER2).getTime() > 0)
	{
		// ŏFist̃^C}[L
		if(head->timer.at(Boss01_Head::FALL_TIMER2).getTime() < 0)
		{
			fist_R->timer.at(Boss01_Fist_R::FALL_TIMER1).setTime(0);
			shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER1).setTime(0);
			head->timer.at(Boss01_Head::FALL_TIMER2).setTime(fist_R->timer.at(Boss01_Fist_R::FALL_TIMER2).getTime());

			scene->removeModel(&fist_R->marker);	// }[J[
			scene->entryModel(&head->marker);

			// bN\
			head->setLockAble(true);
			fist_L->setLockAble(false);
			fist_R->setLockAble(false);
			shoulder_L->setLockAble(false);
			shoulder_R->setLockAble(false);
		}
		// ŏӊOhead̃^C}[L
		else
		{
			fist_R->timer.at(Boss01_Fist_R::FALL_TIMER2).setTime(head->timer.at(Boss01_Head::FALL_TIMER2).getTime());
			shoulder_R->timer.at(Boss01_Shoulder_R::FALL_TIMER2).setTime(head->timer.at(Boss01_Head::FALL_TIMER2).getTime());
		}
	}

	// bN\ʂɖ߂
	if(head->timer.at(Boss01_Head::FALL_TIMER2).getTime() == 120)
	{
		head->setLockAble(false);
		fist_L->setLockAble(true);
		fist_R->setLockAble(true);
		shoulder_L->setLockAble(true);
		shoulder_R->setLockAble(true);
	}

	//cout << fist_L->timer.at(Boss01_Fist_L::FALL_TIMER1).getTime() << endl;

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Boss01::attack()
{
	// eʂɔC
}

// UꂽƂ̏
void C_Boss01::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		hp -= boy->atkBlock.back()->getPower() / 4;
		damage_flag = true;
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		hp -= boy->atkSphere.back()->getPower() / 4;
		damage_flag = true;
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			//hp -= girl->atkSphere.at(i)->getPower();
			//damage_flag = true;

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);
		}
	}

	// girl̃[U[ɓ
	//if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	//{
	//	//cout << "Laser HIT!" << endl;
	//	//hp -= girl->atkBlock.back()->getPower();
	//	hp--;
	//	damage_flag = true;
	//}

	// damage_flagtrueAHPQ[W𒲐
	if(damage_flag || fist_L->getDamage_flag() || fist_R->getDamage_flag() || shoulder_L->getDamage_flag() || shoulder_R->getDamage_flag() || head->getDamage_flag())
	{
		damage_flag = false;
		fist_L->setDamage_flag(false);
		fist_R->setDamage_flag(false);
		shoulder_L->setDamage_flag(false);
		shoulder_R->setDamage_flag(false);
		head->setDamage_flag(false);

		green_bar.setSpriteSize(Boss01::GAUGE_SIZE_X * hp * (1.0 / hp_max));	// cHP̊ɉĒς
		green_bar.glMoveTo(GAUGE_POS_X - ((Boss01::GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);
	}

	// hp0ȉȂ玀StO𗧂Ă
	if(hp <= 0)
	{
		death_flag = true;
		fist_L->setDeath_flag(true);
		fist_R->setDeath_flag(true);
		shoulder_L->setDeath_flag(true);
		shoulder_R->setDeath_flag(true);
		head->setDeath_flag(true);
	}
}