#pragma once
#include <deque>
#include "EnemyBase.h"
#include "Boss01_Fist_L.h"
#include "Boss01_Fist_R.h"
#include "Boss01_Shoulder_L.h"
#include "Boss01_Shoulder_R.h"
#include "Boss01_Head.h"

namespace Boss01
{
	const int HP_MAX = 2500;			// HP

	const double GAUGE_POS_X = 0.0;		// HPQ[WXW
	const double GAUGE_POS_Y = -320.0;	// HPQ[WYW
	const double GAUGE_SIZE_X = 1000.0;	// HPQ[W̉

	enum AttackPattern
	{
		GRAND,
		MOW_L,
		MOW_R,
		MISSILE,
		ATTACK_PATTERN_MAX
	};

	enum Timer
	{
		THINK_TIMER,
		ATTACK_TIMER,
		TIMER_MAX
	};
}

class C_Boss01 : public C_EnemyBase
{
private:
	// Xe[W󂯎ϐ
	vector<C_EnemyBase *>			*enemyArray;		// G̎
	vector<C_EnemyBase *>::iterator	*itEnemyArray;
	int								*totalEnemyNum;		// G̏o(ID鎞ɗp)

	deque<int>						patternArray;		// ߋ̍Up^[i[Ăz

	C_Boss01_Fist_L					*fist_L;
	C_Boss01_Fist_R					*fist_R;
	C_Boss01_Shoulder_L				*shoulder_L;
	C_Boss01_Shoulder_R				*shoulder_R;
	C_Boss01_Head					*head;
	
public:
	C_Boss01(fk_Scene *, fk_Model *, C_MapBase *, C_Boy *, C_Girl *, vector<C_EnemyBase *> *, vector<C_EnemyBase *>::iterator *, int *);
	~C_Boss01();

	void	assemble();		// p[cg

	void	move();			// ړ
	void	attack();		// U

	void	procDamage();	// UꂽƂ̏
};