#include "Boy.h"
#include "Girl.h"
#include "Boss01_Fist_R.h"

using namespace Boss01_Fist_R;

C_Boss01_Fist_R::C_Boss01_Fist_R(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	body.create(6, 30.0);
	body.glMoveTo(100.0, 180.0, -420.0);
	body.setMaterial(Blue);

	model.setScale(60.0);

	isHeavy = true;			// vC[ȂdG
	isBoot = true;			// ŏAI͋NĂ
	isCollision = false;	// p[cmƂ͓蔻𖳌ɂ

	if(marker.readPNG("Data/CG/marker.png") == false)	fl_alert("marker File Read Error!");
	marker.setSpriteSmoothMode(false);
	marker.glVec(camera->getPosition());	// ŏ͌ȂɂĂ
	marker.setScale(0.4);

	timer.resize(TIMER_MAX);
}

C_Boss01_Fist_R::~C_Boss01_Fist_R()
{
	scene->removeModel(&marker);
}

// ړ
void C_Boss01_Fist_R::move()
{
	spd.init();						// ړx0ɖ߂
	updateDistToPlayer();			// vC[Ƃ̋XV

	static fk_Vector primalPos = body.getPosition();
	//cout << primalPos.x << "," << primalPos.y << "," << primalPos.z << endl;

	// Ohbv
	if(timer.at(GRAND_TIMER).getTime() > 0)
	{
		// Uグ
		if(timer.at(GRAND_TIMER).getTime() > 270)
		{
			body.glTranslate(0.0, 2.0, 0.5);
		}
		// U艺낷
		else if(180 < timer.at(GRAND_TIMER).getTime() && timer.at(GRAND_TIMER).getTime() < 240)
		{
			body.glTranslate(0.0, -10.0, -8.0);

			// n
			if(body.getPosition().y < body.getRad())
			{
				body.glMoveTo(body.getPosition().x, 0.0, body.getPosition().z);
				timer.at(GRAND_TIMER).setTime(180);

				// EF[uo
				timer.at(WAVE_TIMER).setTime(WAVE_LIMIT);
				atkSphere.push_back(new C_HitSphereModel(WAVE_PRIMAL_SIZE, WAVE_POWER, WAVE_LIMIT, false, BOSS01_WAVE, atkSphere.size()));
				atkSphere.back()->setMaterial(Blue);
				atkSphere.back()->getMaterial()->setAlpha(0.8);
				atkSphere.back()->glMoveTo(pos);
				scene->entryModel(atkSphere.back());
			}
		}
		// ̈ʒuɖ߂
		else if(timer.at(GRAND_TIMER).getTime() && timer.at(GRAND_TIMER).getTime() < 80)
		{
			body.glFocus(primalPos);
			body.loTranslate(0.0, 0.0, -3.0);

			if((body.getPosition() - primalPos).dist() < 10.0)
			{
				body.glMoveTo(primalPos);
				body.glVec(0.0, 0.0, -1.0);
				//cout << body.getInhVec().x << "," << body.getInhVec().y << "," << body.getInhVec().z << endl;
				timer.at(GRAND_TIMER).setTime(0);
			}
		}
	}

	// ガ
	if(timer.at(MOW_TIMER).getTime() > 0)
	{
		//cout << body.getPosition().x << "," << body.getPosition().y << "," << body.getPosition().z << endl;
		// \
		if(timer.at(MOW_TIMER).getTime() > 240)
		{
			fk_Vector tempPos;
			tempPos.set(280.0, 0.0, -320.0);
			body.glFocus(tempPos);
			body.loTranslate(0.0, 0.0, -3.0);

			if((body.getPosition() - tempPos).dist() < 10.0)
			{
				//cout << "ok" << endl;
				body.glMoveTo(tempPos);
				body.glVec(0.0, 0.0, -1.0);
			}
		}
		// 蔻p̃ubN𐶐
		else if(timer.at(MOW_TIMER).getTime() == 210)
		{
			atkBlock.push_back(new C_HitBlockModel(40.0, 30.0, 300.0, MOW_POWER, MOW_LIMIT, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(GlossBlack);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(1.0, 0.0, -1.0);
			//atkBlock.back()->loTranslate(0.0, 0.0, -20.0);
			atkBlock.back()->setParent(body, true);
			scene->entryModel(atkBlock.back());
		}
		// ガ
		else if(190 < timer.at(MOW_TIMER).getTime() && timer.at(MOW_TIMER).getTime() < 210)
		{
			fk_Vector tempPos;
			tempPos.set(0.0, 0.0, 0.0);	// {̂ɂ
			body.glRotateWithVec(tempPos, fk_Y, (timer.at(MOW_TIMER).getTime() - 190) * 0.005);
		}
		// ̈ʒuɖ߂
		else if(timer.at(MOW_TIMER).getTime() < 100)
		{
			body.glFocus(primalPos);
			body.loTranslate(0.0, 0.0, -3.0);

			if((body.getPosition() - primalPos).dist() < 10.0)
			{
				//cout << "ok2" << endl;
				body.glMoveTo(primalPos);
				body.glVec(0.0, 0.0, -1.0);
				//cout << body.getInhVec().x << "," << body.getInhVec().y << "," << body.getInhVec().z << endl;
				timer.at(MOW_TIMER).setTime(0);
			}
		}
	}

	// _E
	// 
	if(timer.at(FALL_TIMER1).getTime() > 360)
	{
		body.glTranslate(0.0, -8.0, -4.0);

		// n
		if(body.getPosition().y < body.getRad())
		{
			body.glMoveTo(body.getPosition().x, 0.0, body.getPosition().z);
			timer.at(FALL_TIMER1).setTime(360);
		}
	}
	// ̈ʒuɖ߂
	else if((0 < timer.at(FALL_TIMER1).getTime() && timer.at(FALL_TIMER1).getTime() < 60) || (0 < timer.at(FALL_TIMER2).getTime() && timer.at(FALL_TIMER2).getTime() < 60))
	{
		body.glFocus(primalPos);
		body.loTranslate(0.0, 0.0, -3.0);

		if((body.getPosition() - primalPos).dist() < 10.0)
		{
			body.glMoveTo(primalPos);
			body.glVec(0.0, 0.0, -1.0);
			//timer.at(FALL_TIMER1).setTime(0);
		}
	}

	// }[J[̐
	marker.glMoveTo(body.getInhPosition());
	if(timer.at(FALL_TIMER1).getTime() >= 60)
	{
		marker.glTranslate((camera->getInhPosition() - marker.getInhPosition()) * 0.1);
		marker.glVec(-camera->getPosition());
		marker.loAngle(0.0, 0.0, 0.05);
	}
	else if(timer.at(FALL_TIMER1).getTime() == 59)
	{
		scene->removeModel(&marker);
	}

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Boss01_Fist_R::attack()
{
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		// EF[ȕ
		if(atkSphere.at(i)->getKind() == BOSS01_WAVE)
		{
			// EF[u܂L鎞Ԃł
			if(timer.at(WAVE_TIMER).getTime() > WAVE_LIMIT - WAVE_CREATE_TIME)
			{
				atkSphere.at(i)->setRad(atkSphere.at(i)->getRad() + WAVE_SPREAD_SIZE);
			}

			// EF[u̓蔻𐧌
			if(atkSphere.at(i)->cntLimit())
			{
				// vC[AttackData菜
				// GAttackData菜
				boy->removeAttackData(id, BOSS01_WAVE, atkSphere.at(i)->getIndex());
				girl->removeAttackData(id, BOSS01_WAVE, atkSphere.at(i)->getIndex());

				scene->removeModel(atkSphere.at(i));	// ̂remove
				SAFE_DELETE(atkSphere.at(i));
				itSphere = atkSphere.begin();
				itSphere += i;
				itSphere = atkSphere.erase(itSphere);
			}
		}
	}

	// ガ̓蔻𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}

// UꂽƂ̏
void C_Boss01_Fist_R::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		*trueHp -= boy->atkBlock.back()->getPower();
		damage_flag = true;

		// 1iKڂ̃_EAboy3iKڂ̍U2iKڂ̃_E
		if(timer.at(FALL_TIMER1).getTime() >= 60 && boy->getPunchNum() == 3)
		{
			timer.at(FALL_TIMER2).setTime(480);
		}
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		*trueHp -= boy->atkSphere.back()->getPower();
		damage_flag = true;
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			*trueHp -= girl->atkSphere.at(i)->getPower();
			damage_flag = true;

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);
		}
	}

	// girl̃[U[ɓ
	if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	{
		//cout << "Laser HIT!" << endl;
		*trueHp -= girl->atkBlock.back()->getPower();
		//*trueHp--;
		damage_flag = true;
	}
}

// {X{̂HPƋL
void C_Boss01_Fist_R::replaceHp(int *argHp)
{
	trueHp = argHp;
}