#include "Boy.h"
#include "Girl.h"
#include "Boss01_Head.h"

using namespace Boss01_Head;

C_Boss01_Head::C_Boss01_Head(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	body.create(6, 30.0);
	body.glMoveTo(0.0, 320.0, -250.0);
	body.setMaterial(Blue);

	model.setScale(60.0);

	isHeavy = true;			// vC[ȂdG
	isBoot = true;			// ŏAI͋NĂ
	isCollision = false;	// p[cmƂ͓蔻𖳌ɂ

	if(marker.readPNG("Data/CG/marker.png") == false)	fl_alert("marker File Read Error!");
	marker.setSpriteSmoothMode(false);
	marker.glVec(camera->getPosition());	// ŏ͌ȂɂĂ
	marker.setScale(0.4);

	timer.resize(TIMER_MAX);
}

C_Boss01_Head::~C_Boss01_Head()
{
	scene->removeModel(&marker);
}

// ړ
void C_Boss01_Head::move()
{
	spd.init();						// ړx0ɖ߂
	updateDistToPlayer();			// vC[Ƃ̋XV

	static fk_Vector primalPos = body.getPosition();

	// 
	if(timer.at(FALL_TIMER2).getTime() > 420)
	{
		body.glTranslate(0.0, -6.0, -7.0);

		// n
		if(body.getPosition().y < body.getRad())
		{
			body.glMoveTo(body.getPosition().x, 0.0, body.getPosition().z);
			timer.at(FALL_TIMER2).setTime(420);
		}
	}
	// ̈ʒuɖ߂
	else if(0 < timer.at(FALL_TIMER2).getTime() && timer.at(FALL_TIMER2).getTime() < 120)
	{
		body.glFocus(primalPos);
		body.loTranslate(0.0, 0.0, -4.0);

		if((body.getPosition() - primalPos).dist() < 20.0)
		{
			body.glMoveTo(primalPos);
			body.glVec(0.0, 0.0, -1.0);
		}
	}

	// }[J[̐
	marker.glMoveTo(body.getInhPosition());
	if(timer.at(FALL_TIMER2).getTime() >= 120)
	{
		marker.glTranslate((camera->getInhPosition() - marker.getInhPosition()) * 0.1);
		marker.glVec(-camera->getPosition());
		marker.loAngle(0.0, 0.0, 0.05);
	}
	else if(timer.at(FALL_TIMER2).getTime() == 119)
	{
		scene->removeModel(&marker);
	}

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Boss01_Head::attack()
{
}

// UꂽƂ̏
void C_Boss01_Head::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		if(timer.at(FALL_TIMER2).getTime() >= 120)	*trueHp -= boy->atkBlock.back()->getPower() * 3;
		else										*trueHp -= boy->atkBlock.back()->getPower();
		damage_flag = true;
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		if(timer.at(FALL_TIMER2).getTime() >= 120)	*trueHp -= boy->atkSphere.back()->getPower() * 2;
		else										*trueHp -= boy->atkSphere.back()->getPower();
		damage_flag = true;
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			if(timer.at(FALL_TIMER2).getTime() >= 120)	*trueHp -= girl->atkSphere.at(i)->getPower() * 2;
			else										*trueHp -= girl->atkSphere.at(i)->getPower();
			damage_flag = true;

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);
		}
	}

	// girl̃[U[ɓ
	if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	{
		//cout << "Laser HIT!" << endl;
		if(timer.at(FALL_TIMER2).getTime() >= 120)	*trueHp -= girl->atkBlock.back()->getPower() * 2;
		else										*trueHp -= girl->atkBlock.back()->getPower();
		//*trueHp--;
		damage_flag = true;
	}
}

// {X{̂HPƋL
void C_Boss01_Head::replaceHp(int *argHp)
{
	trueHp = argHp;
}