#include "Boy.h"
#include "Girl.h"
#include "Boss01_Shoulder_L.h"

using namespace EnemyBase;
using namespace Boss01_Shoulder_L;

C_Boss01_Shoulder_L::C_Boss01_Shoulder_L(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	body.create(6, 30.0);
	body.glMoveTo(-120.0, 280.0, -250.0);
	body.setMaterial(Blue);

	model.setScale(60.0);

	isHeavy = true;			// vC[ȂdG
	isBoot = true;			// ŏAI͋NĂ
	isCollision = false;	// p[cmƂ͓蔻𖳌ɂ

	if(marker.readPNG("Data/CG/marker.png") == false)	fl_alert("marker File Read Error!");
	marker.setSpriteSmoothMode(false);
	marker.glVec(camera->getPosition());	// ŏ͌ȂɂĂ
	marker.setScale(0.4);

	timer.resize(TIMER_MAX);
}

C_Boss01_Shoulder_L::~C_Boss01_Shoulder_L()
{
	scene->removeModel(&marker);
}

// ړ
void C_Boss01_Shoulder_L::move()
{
	spd.init();						// ړx0ɖ߂
	updateDistToPlayer();			// vC[Ƃ̋XV

	static fk_Vector primalPos = body.getPosition();

	// _E
	// 
	if(timer.at(FALL_TIMER1).getTime() > 360)
	{
		body.glTranslate(0.0, -3.0, 0.0);
	}
	// ̈ʒuɖ߂
	else if((0 < timer.at(FALL_TIMER1).getTime() && timer.at(FALL_TIMER1).getTime() < 60) || (0 < timer.at(FALL_TIMER2).getTime() && timer.at(FALL_TIMER2).getTime() < 60))
	{
		body.glFocus(primalPos);
		body.loTranslate(0.0, 0.0, -3.0);

		if((body.getPosition() - primalPos).dist() < 10.0)
		{
			body.glMoveTo(primalPos);
			body.glVec(0.0, 0.0, -1.0);
			//timer.at(FALL_TIMER1).setTime(0);
		}
	}

	// }[J[̐
	marker.glMoveTo(body.getInhPosition());
	if(timer.at(MISSILE_TIMER).getTime() > 0)
	{
		marker.glTranslate((camera->getInhPosition() - marker.getInhPosition()) * 0.1);
		marker.glVec(-camera->getPosition());
		marker.loAngle(0.0, 0.0, 0.05);
	}
	else if(timer.at(MISSILE_TIMER).getTime() == 0)
	{
		scene->removeModel(&marker);
	}

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Boss01_Shoulder_L::attack()
{
	if(timer.at(MISSILE_TIMER).getTime() == 30)
	{
		atkSphere.push_back(new C_HitSphereModel(MISSILE_RAD, MISSILE_POWER, MISSILE_LIMIT, MISSILE_SPEED, true, BOSS01_MISSILE, atkSphere.size()));
		atkSphere.back()->setMaterial(Red);
		atkSphere.back()->getMaterial()->setAlpha(0.7);
		atkSphere.back()->glMoveTo(pos);

		atkSphere.back()->setTarget(lockRandom());
		if(atkSphere.back()->getTarget() == BOY)	atkSphere.back()->glFocus(boy->getPos());
		else										atkSphere.back()->glFocus(girl->getPos());

		atkSphere.back()->loTranslate(0.0, 0.0, -50.0);
		scene->entryModel(atkSphere.back());
	}

	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		// ĂȂ
		if(atkSphere.at(i)->getExpTime() == -1)
		{
			fk_Vector posA, posB, tempVec;

			if(atkSphere.at(i)->getTarget() == BOY)	tempVec = boy->getPos();
			else									tempVec = girl->getPos();

			posA = atkSphere.at(i)->getInvMatrix() * tempVec;	// e猩target̍W𓾂

			if(posA.x >= 0)	atkSphere.at(i)->loAngle(MISSILE_TURN_SPEED, 0.0, 0.0);		// EtargetȂEɉ]
			else			atkSphere.at(i)->loAngle(-MISSILE_TURN_SPEED, 0.0, 0.0);	// targetȂ獶ɉ]
			posB = atkSphere.at(i)->getInvMatrix() * tempVec;
			// ]ĂƏ𐳊mɍ킹
			if((posA.x >= 0 && posB.x < 0) || (posA.x < 0 && posB.x > 0))
			{
				atkSphere.at(i)->glFocus(tempVec);
			}

			atkSphere.at(i)->move();	// ëړ

			// ŎԂɂȂ邩Aǂ̓vC[ɓĂ甚
			if(atkSphere.at(i)->cntLimit() || map->isHit(atkSphere.at(i)) || boy->isHit(atkSphere.at(i)) || girl->isHit(atkSphere.at(i)))
			{
				atkSphere.at(i)->setRad(EXPLOSION_PRIMAL_SIZE);
				atkSphere.at(i)->setExpTime(EXPLOSION_LIMIT);
			}
		}
		// 
		else
		{
			// EF[u܂L鎞Ԃł
			if(atkSphere.at(i)->getExpTime() > EXPLOSION_LIMIT - EXPLOSION_CREATE_TIME)
			{
				atkSphere.at(i)->setRad(atkSphere.at(i)->getRad() + EXPLOSION_SPREAD_SIZE);
			}

			// ^C}[JEgA0ɂȂe
			if(atkSphere.at(i)->cntExpTime())
			{
				// vC[AttackData菜
				boy->removeAttackData(id, BOSS01_MISSILE, atkSphere.at(i)->getIndex());
				girl->removeAttackData(id, BOSS01_MISSILE, atkSphere.at(i)->getIndex());

				scene->removeModel(atkSphere.at(i));
				SAFE_DELETE(atkSphere.at(i));
				itSphere = atkSphere.begin();
				itSphere += i;
				itSphere = atkSphere.erase(itSphere);
			}
		}
	}
}

// UꂽƂ̏
void C_Boss01_Shoulder_L::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		*trueHp -= boy->atkBlock.back()->getPower();
		damage_flag = true;
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		*trueHp -= boy->atkSphere.back()->getPower();
		damage_flag = true;
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			*trueHp -= girl->atkSphere.at(i)->getPower();
			damage_flag = true;

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);
		}
	}

	// girl̃[U[ɓ
	if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	{
		//cout << "Laser HIT!" << endl;
		*trueHp -= girl->atkBlock.back()->getPower();
		//*trueHp--;
		damage_flag = true;
		
		// ~TCU狯
		if(timer.at(MISSILE_TIMER).getTime() > 0)
		{
			timer.at(MISSILE_TIMER).setTime(0);
			timer.at(FALL_TIMER1).setTime(420);
		}
	}
}

// {X{̂HPƋL
void C_Boss01_Shoulder_L::replaceHp(int *argHp)
{
	trueHp = argHp;
}