#include "Boy.h"
#include "Girl.h"
#include "EnemyBase.h"

using namespace Boy;
using namespace Heal;

int C_Boy::BOY_HP = HP_MAX;		// ÓIoϐ̎
int C_Boy::DEATH_NUM = 0;

C_Boy::C_Boy(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Girl *argGirl, vector<C_EnemyBase *> *argEnemy)
: RX(0.0)
, RY(0.0)
, magnitudeR(0.0)
, guard_flag(false)
, punchNum(0)
, deathNum(DEATH_NUM)
{
	scene = argScene;
	camera = argCamera;
	map = argMap;
	girl = argGirl;
	enemyArray = argEnemy;

	body.create(6, 20.0);
	body.glMoveTo(0.0, 20.0, 0.0);
	//body.glMoveTo(20.0, 20.0, 0.0);
	//body.setMaterial(Red);
	body.setMaterial(White);
	body.getMaterial()->setSpecular(0.2, 0.2, 0.2);
	body.getMaterial()->setShininess(128.0);

	//xfile.load("Data/CG/Character/player/boy.x", "Data/CG/Character/player/boy_tex.png");
	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_BOY].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Phong.vert", "Data/Shader/Phong.frag");
	model.setScale(55.0);
	//model.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	model.glMoveTo(0.0, 0.0, 0.0);
	//model.setScale(1.0, 1.2, 1.0);
	model.setParent(&body, true);

	// K[hĂ邩ǂ킩₷悤ɃubNpӂĂ
	guardBlock.create(45.0, 100.0, 45.0);
	guardBlock.glMoveTo(0.0, 50.0, 0.0);
	guardBlock.setMaterial(Red);
	guardBlock.getMaterial()->setAlpha(0.8);
	guardBlock.setParent(body, true);

	hp = BOY_HP;
	hp_max = HP_MAX;
	id = -1;	// boyID-1, girlID-2ŌŒ

	// _EԂXe[WړĂꍇA񕜂Ă
	if(hp <= 0)		hp = HP_MAX;

	// ΃t[
	green_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	green_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	// ԃt[
	red_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	red_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);
	
	// t[
	purple_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	purple_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	// ΃Q[W
	//green_bar.setSpriteSize(hp * GAUGE_SIZE_COEF);	
	//green_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));	// cHP̊ɉĒς
	green_bar.glMoveTo(GAUGE_POS_X - ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

	// ԃQ[W
	red_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));		// cHP̊ɉĒς
	//red_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	red_bar.glMoveTo(GAUGE_POS_X - ((GAUGE_SIZE_X - red_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

	// Q[W
	purple_bar.setSpriteSize(0.0);
	//purple_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	purple_bar.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	timer.resize(TIMER_MAX);
}

C_Boy::~C_Boy()
{
	// HPƃ_E񐔂ۑĂ
	BOY_HP = hp;
	DEATH_NUM = deathNum;
}

void C_Boy::move()
{
	//scene->removeModel(&body);

	spd.init();	// ړx0ɖ߂

	if(move_flag && death_flag == false)
	{
		RX = controller[0].state.Gamepad.sThumbRX;
		RY = controller[0].state.Gamepad.sThumbRY;
		magnitudeR = sqrt(RX * RX + RY * RY);

		if( (RX > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE || RX < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)
			|| (RY > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE || RY < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE) )
		{
			vec.x =	 RX / magnitudeR;
			vec.z = -RY / magnitudeR;
			spd.z = -BOY_SPEED;
			timer.at(AUTO_GUARD_TIMER).setTime(0, false);	// I[gK[h̎ԂZbg
		}
		// ĂȂAI[g[hAU{^ĂȂꍇ
		else if(controller[0].getIsAuto() && !controller[0].KeyPress(X_GAMEPAD_RB) && timer.at(AUTO_GUARD_TIMER).getTime() < 10000)
		{
			timer.at(AUTO_GUARD_TIMER).setTime(timer.at(AUTO_GUARD_TIMER).getTime() + 1, false);	// I[gK[h܂ł̎Ԃ𑝂₷
		}
	}

	// K[hԂ̎
	if(guard_flag)
	{
		vec = body.getVec();		// K[hԂ̌ۑ
	}
	// K[hԂłȂ
	else
	{
		// p`ł
		if(timer.at(ATTACK_DELAY_TIMER).getTime() > 0 && timer.at(WAVE_TIMER).getTime() <= 0)
		{
			body.glTranslate(body.getVec() * (BOY_SPEED / 3));
			vec = body.getVec();	// p`ۑ
		}
		// ʏԂ̎
		else
		{
			body.glVec(vec);		// Ľݒ
			body.loTranslate(spd);	// Lړ
		}
	}

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// girlƂ̓蔻
	procHit(girl->getBody());

	// enemyƂ̓蔻
	for(unsigned int i = 0; i < enemyArray->size(); ++i)
	{
		// yGȂ牟
		if(!enemyArray->at(i)->getIsHeavy())	procHit(enemyArray->at(i)->getBody());
	}

	pos = body.getInhPosition();	// L̈ʒuۑ
	//cout << pos.x << "," << pos.y << "," << pos.z << endl;
}

// U
void C_Boy::attack()
{
	// U\Ȃ
	if(timer.at(ATTACK_DELAY_TIMER).getTime() <= 0 && death_flag == false)
	{
		// EF[u̐
		if(timer.at(CHARGE_TIMER).getTime() >= CHARGE_COMP_TIME && controller[0].KeyUp(X_GAMEPAD_RB))
		{
			atkSphere.push_back(new C_HitSphereModel(WAVE_PRIMAL_SIZE, WAVE_POWER, WAVE_LIMIT, false, BOY_WAVE));
			atkSphere.back()->setMaterial(Orange);
			atkSphere.back()->getMaterial()->setAlpha(0.5);
			atkSphere.back()->glMoveTo(pos);		// WvC[Ɠ
			//atkSphere.back()->glVec(body.getVec());	// vC[Ɠ
			scene->entryModel(atkSphere.back());

			// fBC^CƃEF[u̔Ǘϐɒl
			timer.at(ATTACK_DELAY_TIMER).setTime(WAVE_DELAY);
			timer.at(WAVE_TIMER).setTime(WAVE_DELAY);
			timer.at(CHARGE_TIMER).setTime(0, false);	// CHARGE_TIMERZbg
			move_flag = false;	// d

			// SE
			sound.se_on(SE_WAVE);
		}

		// RBĂԃEF[u`[W
		if(controller[0].KeyPress(X_GAMEPAD_RB) && timer.at(ATTACK_DELAY_TIMER).getTime() <= 0 && guard_flag == false)
		{
			timer.at(CHARGE_TIMER).setTime(timer.at(CHARGE_TIMER).getTime() + 1, false);

			//cout << timer.at(CHARGE_TIMER).getTime() << endl;

			// `[W
			// SE
			if(timer.at(CHARGE_TIMER).getTime() == CHARGE_COMP_TIME)	sound.se_on(SE_CHARGE_COMPLETE);

			// `[WĂȂU
			if(timer.at(CHARGE_TIMER).getTime() >= CHARGE_COMP_TIME)	controller[0].vib_on(20000, 0, 1, 0);
		}
		// RBĂȂCHARGE_TIMERZbg
		else	timer.at(CHARGE_TIMER).setTime(0, false);

		// p`
		if(controller[0].KeyDown(X_GAMEPAD_RB) || attackJudge())
		{
			// ͈̔͂ɂԋ߂G̕
			int index = -1;	// -1ȊOɂȂAΏۂ̓G

			// GƂ̋Zo
			vector<double> dist;
			for(unsigned int i = 0; i < enemyArray->size(); i++)
			{
				// GƂ̋*2distpush
				dist.push_back((pos - enemyArray->at(i)->getPos()).dist2());
			}

			boost::sort(dist);	// GƂ̋߂()ɕёւ

			// ߂ɓς߁A͈͓ł΂̓G
			for(unsigned int i = 0; i < dist.size(); i++)
			{
				// ݒl艓A܂͊ɑ_G肵Ă΃[v𔲂
				if(dist.at(i) > AUTO_POINT_MAX_RANGE * AUTO_POINT_MAX_RANGE || index != -1)	break;			

				// 1OɊi[ĂlƓȂcontinue
				if(i >= 1 && dist.at(i) == dist.at(i - 1))	continue;

				for(unsigned int j = 0; j < enemyArray->size(); j++)
				{
					if(dist.at(i) == (pos - enemyArray->at(j)->getPos()).dist2())
					{
						double cos = fk_Math::calcCosine(body.getVec(), enemyArray->at(j)->getPos() - pos);

						if(cos >= AUTO_POINT_MIN_COS)
						{
							body.glFocus(enemyArray->at(j)->getPos().x, pos.y, enemyArray->at(j)->getPos().z);
							index = j;
							break;
						}
					}
				}
			}

			switch(punchNum)
			{
			case 0:	// 1i
				atkBlock.push_back(new C_HitBlockModel(20.0, 30.0, 50.0, WEAK_PUNCH_POWER, WEAK_PUNCH_LIMIT, false, BOY_PUNCH));
				atkBlock.back()->glMoveTo(pos);			// WvC[Ɠ
				atkBlock.back()->glVec(body.getVec());	// vC[Ɠ
				atkBlock.back()->loTranslate(5.0, 0.0, -35.0);
				timer.at(ATTACK_DELAY_TIMER).setTime(WEAK_PUNCH_DELAY);	// 0ɂȂ玟̍U\
				timer.at(COMBO_TIMER).setTime(WEAK_PUNCH_DELAY + COMBO_ABLE_TIME);	// (U\ɂȂĂ)COMBO_ABLE_TIMEo܂łȂ2iKڂ̃p`\
				move_flag = false;

				// SE
				sound.se_on(SE_PUNCH_WEAK);
				break;
			case 1:	// 2i
				atkBlock.push_back(new C_HitBlockModel(20.0, 30.0, 50.0, WEAK_PUNCH_POWER, WEAK_PUNCH_LIMIT, false, BOY_PUNCH));
				atkBlock.back()->glMoveTo(pos);			// WvC[Ɠ
				atkBlock.back()->glVec(body.getVec());	// vC[Ɠ
				atkBlock.back()->loTranslate(-5.0, 0.0, -35.0);
				timer.at(ATTACK_DELAY_TIMER).setTime(WEAK_PUNCH_DELAY);	// 0ɂȂ玟̍U\
				timer.at(COMBO_TIMER).setTime(WEAK_PUNCH_DELAY + COMBO_ABLE_TIME);	// (U\ɂȂĂ)COMBO_ABLE_TIMEo܂łȂ3iKڂ̃p`\
				move_flag = false;

				// SE
				sound.se_on(SE_PUNCH_WEAK);
				break;
			case 2:	// 3i
				atkBlock.push_back(new C_HitBlockModel(40.0, 30.0, 70.0, STRONG_PUNCH_POWER, STRONG_PUNCH_LIMIT, false, BOY_PUNCH));
				atkBlock.back()->glMoveTo(pos);			// WvC[Ɠ
				atkBlock.back()->glVec(body.getVec());	// vC[Ɠ
				atkBlock.back()->loTranslate(0.0, 0.0, -40.0);
				timer.at(ATTACK_DELAY_TIMER).setTime(STRONG_PUNCH_DELAY);	// 0ɂȂ玟̍U\
				timer.at(COMBO_TIMER).setTime(STRONG_PUNCH_LIMIT);			// STRONG_PUNCH_LIMITƓɂ
				move_flag = false;

				// SE
				sound.se_on(SE_PUNCH_STRONG);
				break;
			}
			punchNum++;
			atkBlock.back()->setMaterial(Pink);
			atkBlock.back()->setParent(body, true);
			scene->entryModel(atkBlock.back());	// ubNentry
		}
	}

	// R{𐧌
	if(timer.at(COMBO_TIMER).getTime() == 0)		punchNum = 0;

	// EF[ȕ
	if(atkSphere.size() > 0)
	{
		// EF[u܂L鎞Ԃł
		if(timer.at(WAVE_TIMER).getTime() > WAVE_DELAY - WAVE_CREATE_TIME)
		{
			atkSphere.back()->setRad(atkSphere.back()->getRad() + WAVE_SPREAD_SIZE);
		}
	}

	// U\Ɠɓ悤
	if(timer.at(ATTACK_DELAY_TIMER).getTime() == 0)	move_flag = true;

	// punch̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// GAttackData菜
		for(unsigned int i = 0; i < enemyArray->size(); ++i)	enemyArray->at(i)->removeAttackData(id, BOY_PUNCH, 0);
	}

	// wave̓蔻𐧌
	if(atkSphere.size() > 0 && atkSphere.back()->cntLimit())
	{
		scene->removeModel(atkSphere.back());		// ̂remove
		SAFE_DELETE(atkSphere.back());
		atkSphere.pop_back();

		// GAttackData菜
		for(unsigned int i = 0; i < enemyArray->size(); ++i)	enemyArray->at(i)->removeAttackData(id, BOY_WAVE, 0);
	}

	// K[h
	if((controller[0].KeyPress(X_GAMEPAD_RT) || timer.at(AUTO_GUARD_TIMER).getTime() >= AUTO_GURAD_TIME) && timer.at(ATTACK_DELAY_TIMER).getTime() < 0 && death_flag == false)
	{
		guard_flag = true;
		scene->entryModel(&guardBlock);
		punchNum = 0;
	}
	else
	{
		guard_flag = false;
		scene->removeModel(&guardBlock);
	}
}

// UƂ̔f
bool C_Boy::attackJudge()
{
	// G߂ɂtO
	bool flag = false;

	// Rg[AUTOݒɂȂĂ邩ǂH
	// āAU{^ĂȂH
	// ɁAK[hԂɂȂĂȂH
	// ȂAԂȂ̂H
	if(controller[0].getIsAuto() && !controller[0].KeyPress(X_GAMEPAD_RB) && !guard_flag && move_flag)
	{
		// pbh͂Ƃ
		// move֐ł́AȂԂ͓͂Ӑ}IɂƂĂȂ߁B
		RX = controller[0].state.Gamepad.sThumbRX;
		RY = controller[0].state.Gamepad.sThumbRY;
		magnitudeR = sqrt(RX * RX + RY * RY);

		if( (RX > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE || RX < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)
			|| (RY > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE || RY < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE) )
		{
			vec.x =	 RX / magnitudeR;
			vec.z = -RY / magnitudeR;
			body.glVec(vec);		// Ľݒ
		}

		// ͈̔͂ɂԋ߂G̕
		int index = -1;	// -1ȊOɂȂAΏۂ̓G

		// GƂ̋Zo
		vector<double> dist;
		for(unsigned int i = 0; i < enemyArray->size(); i++)
		{
			// GƂ̋*2distpush
			dist.push_back((pos - enemyArray->at(i)->getPos()).dist2());
		}

		boost::sort(dist);	// GƂ̋߂()ɕёւ

		// ߂ɓς߁A͈͓ł΂̓G
		for(unsigned int i = 0; i < dist.size(); i++)
		{
			// ݒl艓A܂͊ɑ_G肵Ă΃[v𔲂
			if(dist.at(i) > AUTO_POINT_EASY_MAX_RANGE * AUTO_POINT_EASY_MAX_RANGE || index != -1)	break;			
			// 1OɊi[ĂlƓȂcontinue
			if(i >= 1 && dist.at(i) == dist.at(i - 1))	continue;
			for(unsigned int j = 0; j < enemyArray->size(); j++)
			{
				if(dist.at(i) == (pos - enemyArray->at(j)->getPos()).dist2())
				{
					double cos = fk_Math::calcCosine(body.getVec(), enemyArray->at(j)->getPos() - pos);
					if(cos >= AUTO_POINT_EASY_MIN_COS)	
					{
						body.glFocus(enemyArray->at(j)->getPos().x, pos.y, enemyArray->at(j)->getPos().z);
						index = j;
						flag = true;
						break;
					}
				}
			}
		}
	}

	return flag;
}

// 
void C_Boy::heal()
{
	//cout << body.getAngle().p << "," << body.getAngle().h << "," << body.getAngle().b << endl;
	if(death_flag && !girl->getDeath_flag() && (girl->getPos() - pos).dist() <= HEAL_DIST)
	{
		timer.at(HEAL_TIMER).setTime(timer.at(HEAL_TIMER).getTime() + 1, false);

		// SE
		sound.se_on(SE_AT_HEAL);

		if(timer.at(HEAL_TIMER).getTime() >= HEAL_COMP_PRIMAL_TIME + deathNum * HEAL_PENALTY_TIME)
		{
			hp = HP_MAX;
			death_flag = false;

			model.loFocus(0.0, 1.0, 0.0);			// N

			timer.at(HEAL_TIMER).setTime(0, false);	// ^C}[ZbgĂ
			purple_bar.setSpriteSize(0.0);			// Q[W̕ݒ
			scene->removeOverlayModel(&purple_frame);
			scene->removeOverlayModel(&purple_bar);

			scene->entryOverlayModel(&green_frame);
			scene->entryOverlayModel(&green_bar);
			green_bar.setSpriteSize(GAUGE_SIZE_X);
			green_bar.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

			// SE
			sound.se_stop(SE_AT_HEAL);
			sound.se_on(SE_HEAL_COMPLETE);
		}
		else if(timer.at(HEAL_TIMER).getTime() > 0)
		{
			purple_bar.setSpriteSize(GAUGE_SIZE_X * timer.at(HEAL_TIMER).getTime() / (HEAL_COMP_PRIMAL_TIME + deathNum * HEAL_PENALTY_TIME));	// Q[W̕ݒ
			purple_bar.glMoveTo(GAUGE_POS_X - ((GAUGE_SIZE_X - purple_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);
		}
	}

	// 񕜒SE~߂
	if(sound.se_getFlag(SE_AT_HEAL) && ((girl->getPos() - pos).dist() > HEAL_DIST || (death_flag && girl->getDeath_flag())))
	{
		sound.se_stop(SE_AT_HEAL);
	}
}

// UꂽƂ̏
void C_Boy::procDamage()
{
	int tempHp = hp;	// 3ȉɂȂƂԘgo

	if(death_flag == false)
	{
		for(unsigned int i = 0; i < enemyArray->size(); ++i)
		{
			for(unsigned int j = 0; j < enemyArray->at(i)->atkSphere.size(); ++j)
			{
				// eɓ
				if(isHit(enemyArray->at(i)->atkSphere.at(j)))
				{
					// 蔻肪cȔꍇ
					if(enemyArray->at(i)->atkSphere.at(j)->getKind() >= 0)
					{
						// (K[hĂȂA͔ꍇ)AattackDataɓo^ĂȂ
						if((guard_flag == false || enemyArray->at(i)->atkSphere.at(j)->getCE_flag())
							&& checkAttackData(enemyArray->at(i)->getId(), enemyArray->at(i)->atkSphere.at(j)->getKind(), enemyArray->at(i)->atkSphere.at(j)->getIndex()))
						{
							hp -= enemyArray->at(i)->atkSphere.at(j)->getPower();
							damage_flag = true;
						}
					}
					// x悤ȍȔꍇ
					else
					{
						// K[hĂȂA͔ꍇ
						if(guard_flag == false || enemyArray->at(i)->atkSphere.at(j)->getCE_flag())
						{
							hp -= enemyArray->at(i)->atkSphere.at(j)->getPower();
							damage_flag = true;
						}

						// ʂ
						scene->removeModel(enemyArray->at(i)->atkSphere.at(j));
						SAFE_DELETE(enemyArray->at(i)->atkSphere.at(j));
						enemyArray->at(i)->itSphere = enemyArray->at(i)->atkSphere.begin();
						enemyArray->at(i)->itSphere += j;
						enemyArray->at(i)->itSphere = enemyArray->at(i)->atkSphere.erase(enemyArray->at(i)->itSphere);
					}
				}
			}

			for(unsigned int j = 0; j < enemyArray->at(i)->atkBlock.size(); ++j)
			{
				fk_Vector	back;
				// ubNɓ
				if(enemyArray->at(i)->atkBlock.at(j)->checkToSphere(body, back))
				{
					// 蔻肪cȔꍇ
					if(enemyArray->at(i)->atkBlock.at(j)->getKind() >= 0)
					{
						// (K[hĂȂA͔ꍇ)AattackDataɓo^ĂȂ
						if((guard_flag == false || enemyArray->at(i)->atkBlock.at(j)->getCE_flag())
							&& checkAttackData(enemyArray->at(i)->getId(), enemyArray->at(i)->atkBlock.at(j)->getKind(), enemyArray->at(i)->atkBlock.at(j)->getIndex()))
						{
							hp -= enemyArray->at(i)->atkBlock.at(j)->getPower();
							damage_flag = true;
						}
					}
					// x悤ȍȔꍇ
					else
					{
						// K[hĂȂA͔ꍇ
						if(guard_flag == false || enemyArray->at(i)->atkBlock.at(j)->getCE_flag())
						{
							hp -= enemyArray->at(i)->atkBlock.at(j)->getPower();
							damage_flag = true;
						}

						// ʂ
						scene->removeModel(enemyArray->at(i)->atkBlock.at(j));
						SAFE_DELETE(enemyArray->at(i)->atkBlock.at(j));
						enemyArray->at(i)->itBlock = enemyArray->at(i)->atkBlock.begin();
						enemyArray->at(i)->itBlock += j;
						enemyArray->at(i)->itBlock = enemyArray->at(i)->atkBlock.erase(enemyArray->at(i)->itBlock);
					}
				}
			}
		}
	}

	// hp0ȉȂ玀StO𗧂Ă
	if(death_flag == false && hp <= 0)
	{
		death_flag = true;
		++deathNum;
		green_bar.setSpriteSize(0.0);		// ΃Q[W̕ݒ

		model.loFocus(0.0, -1.0, 0.0);			// |

		// SE
		sound.se_on(SE_DOWN);

		guard_flag = false;
		scene->removeModel(&guardBlock);
		punchNum = 0;

		scene->removeOverlayModel(&red_frame);
		scene->removeOverlayModel(&red_bar);
		scene->removeOverlayModel(&green_frame);	// u3炤Ƃ͂ȂƎvꉞÔ
		scene->removeOverlayModel(&green_bar);

		scene->entryOverlayModel(&purple_frame);
		scene->entryOverlayModel(&purple_bar);
	}

	// damage_flagtrueAHPQ[W𒲐
	if(damage_flag)
	{
		damage_flag = false;
		green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));	// cHP̊ɉĒς
		green_bar.glMoveTo(GAUGE_POS_X - ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);
		red_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));		// cHP̊ɉĒς
		red_bar.glMoveTo(GAUGE_POS_X - ((GAUGE_SIZE_X - red_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

		// HP3ƂԘgɂ
		if(tempHp > hp_max * 0.3 && hp <= hp_max * 0.3)
		{
			scene->removeOverlayModel(&green_frame);
			scene->removeOverlayModel(&green_bar);

			scene->entryOverlayModel(&red_frame);
			scene->entryOverlayModel(&red_bar);
		}
	}
}

int C_Boy::getPunchNum()
{
	return punchNum;
}

void C_Boy::setDeathNum(int num)
{
	deathNum = num;
}

int C_Boy::getDeathNum()
{
	return deathNum;
}