#include "Character.h"

C_Character::C_Character()
: move_flag(true)
, death_flag(false)
, damage_flag(false)
{
	if(red_bar.readPNG("Data/CG/red_bar.png") == false)				fl_alert("red_bar File Read Error!");
	red_bar.setSpriteSmoothMode(false);
	if(red_frame.readPNG("Data/CG/red_frame.png") == false)			fl_alert("red_frame File Read Error!");
	red_frame.setSpriteSmoothMode(false);

	if(purple_bar.readPNG("Data/CG/purple_bar.png") == false)		fl_alert("purple_bar File Read Error!");
	purple_bar.setSpriteSmoothMode(false);
	if(purple_frame.readPNG("Data/CG/purple_frame.png") == false)	fl_alert("purple_frame File Read Error!");
	purple_frame.setSpriteSmoothMode(false);

	if(green_bar.readPNG("Data/CG/green_bar.png") == false)			fl_alert("green_bar File Read Error!");
	green_bar.setSpriteSmoothMode(false);
	if(green_frame.readPNG("Data/CG/green_frame.png") == false)		fl_alert("green_frame File Read Error!");
	green_frame.setSpriteSmoothMode(false);
}

C_Character::~C_Character()
{
	for(unsigned int i = 0; i < atkBlock.size(); ++i)
	{
		scene->removeModel(atkBlock.at(i));
		SAFE_DELETE(atkBlock.at(i));
	}
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		scene->removeModel(atkSphere.at(i));
		SAFE_DELETE(atkSphere.at(i));
	}
	atkBlock.clear();
	atkSphere.clear();

	timer.clear();
	attackData.clear();
}

void C_Character::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&model);
	//argScene->entryModel(&body);
}

// SpriteModelƈꏏɃGg[鎞ȂǂɎgp
void C_Character::entryScene(fk_Scene *argScene, fk_Window *argWin, fk_Model *argCamera)
{
	argScene->entryModel(&model);
	//argScene->entryModel(&body);

	purple_frame.entryFirst(argWin, argScene, argCamera);
	red_frame.entryFirst(argWin, argScene, argCamera);
	green_frame.entryFirst(argWin, argScene, argCamera);
	purple_bar.entryFirst(argWin, argScene, argCamera);
	red_bar.entryFirst(argWin, argScene, argCamera);
	green_bar.entryFirst(argWin, argScene, argCamera);

	// HP3ȉȂ΂菜
	if(hp <= hp_max * 0.3)
	{
		argScene->removeOverlayModel(&green_frame);
		argScene->removeOverlayModel(&green_bar);
	}
}
	
void C_Character::removeScene(fk_Scene *argScene)
{
	argScene->removeModel(&model);
	argScene->removeModel(&body);

	// Gp
	argScene->removeModel(&red_bar);
	argScene->removeModel(&purple_bar);
	argScene->removeModel(&green_bar);

	// vC[E{Xp
	argScene->removeOverlayModel(&purple_frame);
	argScene->removeOverlayModel(&red_frame);
	argScene->removeOverlayModel(&green_frame);
	argScene->removeOverlayModel(&purple_bar);
	argScene->removeOverlayModel(&red_bar);
	argScene->removeOverlayModel(&green_bar);
}

// hpZbg
void C_Character::setHp(int argHp)
{
	hp = argHp;
}

// hp_maxZbg
void C_Character::setHp_Max(int argHp_Max)
{
	hp_max = argHp_Max;
}

// idZbg
void C_Character::setId(int num)
{
	id = num;
}

// posZbg
void C_Character::setPos(fk_Vector argPos)
{
	pos = argPos;
}

// vecZbg
void C_Character::setVec(fk_Vector argVec)
{
	vec = argVec;
}

// spdZbg
void C_Character::setSpd(fk_Vector argSpd)
{
	spd = argSpd;
}

// move_flagZbg
void C_Character::setMove_flag(bool argFlag)
{
	move_flag = argFlag;
}

// death_flagZbg
void C_Character::setDeath_flag(bool argFlag)
{
	death_flag = argFlag;
}

// damage_flagZbg
void C_Character::setDamage_flag(bool argFlag)
{
	damage_flag = argFlag;
}

// modelԂ
GLSLModel* C_Character::getModel()
{
	return &model;
}

// bodyԂ
fkut_SphereModel* C_Character::getBody()
{
	return &body;
}

// hpԂ
int C_Character::getHp()
{
	return hp;
}

// hp_maxԂ
int C_Character::getHp_Max()
{
	return hp_max;
}

// idԂ
int C_Character::getId()
{
	return id;
}

// posԂ
fk_Vector C_Character::getPos()
{
	return pos;
}

// vecԂ
fk_Vector C_Character::getVec()
{
	return vec;
}

// spdԂ
fk_Vector C_Character::getSpd()
{
	return spd;
}

// move_flagԂ
bool C_Character::getMove_flag()
{
	return move_flag;
}

// death_flagԂ
bool C_Character::getDeath_flag()
{
	return death_flag;
}

// damage_flagԂ
bool C_Character::getDamage_flag()
{
	return damage_flag;
}

// Փˏ(߂)s
void C_Character::procHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	if(body.checkToSphere(*sphere, back))
	{
		// Y͍lȂ
		back.y = 0.0;

		sphere->glTranslate(-back);
	}
}

// Ă邩ǂ
bool C_Character::isHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	return body.checkToSphere(*sphere, back);
}

// 蔻肪cUɑ΂āA܂ĂȂǂ
bool C_Character::checkAttackData(int argId, int argKind, int argIndex)
{
	// ƍ
	for(unsigned int i = 0; i < attackData.size(); ++i)
	{
		// v̂falseԂ
		if(attackData.at(i).id == argId && attackData.at(i).kind == argKind && attackData.at(i).index == argIndex)	return false;
	}

	// push_back
	AttackData data;
	data.id = argId;
	data.kind = argKind;
	data.index = argIndex;
	attackData.push_back(data);

	return true;
}

// 蔻̏菜
void C_Character::removeAttackData(int argId, int argKind, int argIndex)
{
	for(unsigned int i = 0; i < attackData.size(); ++i)
	{
		// v񂪂Ύ菜
		if(attackData.at(i).id == argId && attackData.at(i).kind == argKind && attackData.at(i).index == argIndex)
		{
			itData = attackData.begin();
			itData += i;
			itData = attackData.erase(itData);
		}
	}
}