#pragma once
#include <GL/glew.h>
#include <FK/Vector.h>
#include "FKUT/Misc.h"
#include "FKUT/CubicModel.h"
#include "FKUT/SpriteModel.h"
#include "GLSLModel.h"
#include "Sound.h"
#include "MapBase.h"
#include "Timer.h"
#include "XFile.h"
#include "AttackData.h"
#include "Function.h"
#include "HitSphereModel.h"
#include "HitBlockModel.h"

class C_Character
{
protected:
	GLSLModel			model;
	C_DX3File			xfile;
	fkut_SphereModel	body;

	fk_Scene	*scene;
	fk_Model	*camera;
	C_MapBase	*map;

	int			hp, hp_max, id;
	fk_Vector	pos, vec, spd;

	bool		move_flag, death_flag, damage_flag;

	vector<AttackData>	attackData;			// ̍UǗz
	vector<AttackData>::iterator	itData;	// Ce[^[

public:
	C_Character();
	virtual ~C_Character();

	vector<C_Timer>		timer;				// ^C}[
	fkut_SpriteModel	red_bar, red_frame, purple_bar, purple_frame, green_bar, green_frame;	// HPo[ƃt[

	// V[\E\
	void	entryScene(fk_Scene *);
	void	entryScene(fk_Scene *, fk_Window *, fk_Model *);		// SpriteModelȂǂꏏɃGg[鎞Ɏgp
	void	removeScene(fk_Scene *);

	vector<C_HitBlockModel *>				atkBlock;		// Up̃ubN
	vector<C_HitBlockModel *>::iterator		itBlock;		// Ce[^[

	vector<C_HitSphereModel *>				atkSphere;		// Up̋
	vector<C_HitSphereModel *>::iterator	itSphere;		// Ce[^[

	void	setHp(int);					// hpZbg
	void	setHp_Max(int);				// hp_maxZbg
	void	setId(int);					// idZbg
	void	setPos(fk_Vector);			// posZbg
	void	setVec(fk_Vector);			// vecZbg
	void	setSpd(fk_Vector);			// spdZbg
	void	setMove_flag(bool);			// move_flagZbg
	void	setDeath_flag(bool);		// death_flagZbg
	void	setDamage_flag(bool);		// damage_flagZbg

	GLSLModel*			getModel();		// modelԂ
	fkut_SphereModel*	getBody();		// bodyԂ
	int			getHp();				// hpԂ
	int			getHp_Max();			// hp_maxԂ
	int			getId();				// idԂ
	fk_Vector	getPos();				// posԂ
	fk_Vector	getVec();				// vecԂ
	fk_Vector	getSpd();				// spdԂ
	bool		getMove_flag();			// move_flagԂ
	bool		getDeath_flag();		// death_flagԂ
	bool		getDamage_flag();		// damege_flagԂ

	virtual void move() = 0;	// ړ
	virtual void attack() = 0;	// U

	virtual void procDamage() = 0;	// UꂽƂ̏

	// 蔻菈
	void procHit(fkut_SphereModel *sphere);			// Փˏ(߂)s
	bool isHit(fkut_SphereModel *sphere);			// Ă邩ǂ

	// 蔻肪cUɑ΂āA܂ĂȂǂ
	// ĂȂΏo^
	bool checkAttackData(int argId, int argKind, int argIndex);
	void removeAttackData(int argId, int argKind, int argIndex);	// 蔻̏菜
};