#include "Boy.h"
#include "Girl.h"
#include "Enemy01.h"

using namespace EnemyBase;
using namespace Enemy01;

C_Enemy01::C_Enemy01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = HP_MAX;

	body.create(6, 25.0);
	body.setMaterial(DarkPurple);

	xfile.load("Data/CG/Character/boss/meka.x", "Data/CG/Character/boss/meka_tex.bmp");
	model.setShape(&xfile.DX3_IFSTexture);
	model.setScale(6.0);
	model.glMoveTo(0.0, -10.0, 0.0);
	//model.setScale(1.0, 1.5, 1.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Enemy01::~C_Enemy01()
{
}

// ړ
void C_Enemy01::move()
{
	spd.init();	// ړx0ɖ߂

	// vC[Ƃ̋XV
	updateDistToPlayer();

	// s߂
	if(timer.at(THINK_TIMER).getTime() <= 0 && timer.at(MOVE_TIMER).getTime() <= 0 && timer.at(ATTACK_DELAY_TIMER).getTime() <= 0)
	{
		// Ũp^[߂
		attackPattern = GetRand(0, ATTACK_PATTERN_MAX - 1);

		// Up^[ɉĈړ鎞Ԃ߂Ă
		// }VKōUȂ
		if(attackPattern == MACHINE_GUN)	timer.at(MOVE_TIMER).setTime(120);
		// p`Ȃ
		else if(attackPattern == PUNCH)		timer.at(MOVE_TIMER).setTime(150);

		// _vC[_Ō߂
		lockTarget = lockRandom();
	}

	if(timer.at(MOVE_TIMER).getTime() > 0)
	{
		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// }VKōUȂ
			if(attackPattern == MACHINE_GUN)
			{
				// ƏȂ܂܈ړԂI悤ƂĂAƂ肠OɌ
				if(timer.at(MOVE_TIMER).getTime() == 1)
				{
					timer.at(MOVE_TIMER).setTime(0);
					timer.at(ATTACK_DELAY_TIMER).setTime(MACHINE_GUN_DELAY);
					timer.at(MACHINE_GUN_TIMER).setTime(MACHINE_GUN_DELAY);
				}
				// boyƂ̋Ă
				else if(distToBoy > MACHINE_GUN_DIST)		spd.z = -SPEED;	// ߂Â
				// ߂ÂĂ
				else if(distToBoy < MACHINE_GUN_DIST / 2)	spd.z = SPEED;	// 
				// KɋāAƏĂ΍U
				else if(getIsLock())
				{
					timer.at(MOVE_TIMER).setTime(0);	// ~܂
					timer.at(ATTACK_DELAY_TIMER).setTime(MACHINE_GUN_DELAY);
					timer.at(MACHINE_GUN_TIMER).setTime(MACHINE_GUN_DELAY);
				}
			}
			// ߐڍUȂ
			else if(attackPattern == PUNCH)
			{
				// boyƂ̋Ă
				if(distToBoy > PUNCH_DIST)		spd.z = -SPEED;	// ߂Â
				// KɋāAƏĂ΍U
				else if(getIsLock())
				{
					timer.at(MOVE_TIMER).setTime(0);	// ~܂
					timer.at(ATTACK_DELAY_TIMER).setTime(PUNCH_DELAY);
					timer.at(PUNCH_TIMER).setTime(PUNCH_DELAY);
				}
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// }VKōUȂ
			if(attackPattern == MACHINE_GUN)
			{
				// ƏȂ܂܈ړԂI悤ƂĂAƂ肠OɌ
				if(timer.at(MOVE_TIMER).getTime() == 1)
				{
					timer.at(MOVE_TIMER).setTime(0);	// ~܂
					timer.at(ATTACK_DELAY_TIMER).setTime(MACHINE_GUN_DELAY);
					timer.at(MACHINE_GUN_TIMER).setTime(MACHINE_GUN_DELAY);
				}
				// girlƂ̋Ă
				else if(distToGirl > MACHINE_GUN_DIST)		spd.z = -SPEED;	// ߂Â
				// ߂ÂĂ
				else if(distToGirl < MACHINE_GUN_DIST / 2)	spd.z = SPEED;	// 
				// KɋāAƏĂ΍U
				else if(getIsLock())
				{
					timer.at(MOVE_TIMER).setTime(0);
					timer.at(ATTACK_DELAY_TIMER).setTime(MACHINE_GUN_DELAY);
					timer.at(MACHINE_GUN_TIMER).setTime(MACHINE_GUN_DELAY);
				}
			}
			// ߐڍUȂ
			else if(attackPattern == PUNCH)
			{
				// girlƂ̋Ă
				if(distToGirl > PUNCH_DIST)		spd.z = -SPEED;	// ߂Â
				// KɋāAƏĂ΍U
				else if(getIsLock())
				{
					timer.at(MOVE_TIMER).setTime(0);	// ~܂
					timer.at(ATTACK_DELAY_TIMER).setTime(PUNCH_DELAY);
					timer.at(PUNCH_TIMER).setTime(PUNCH_DELAY);
				}
			}
		}

		body.loTranslate(spd);
	}

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Enemy01::attack()
{
	if(timer.at(ATTACK_DELAY_TIMER).getTime() > 0)
	{
		// }VK̐
		if(timer.at(MACHINE_GUN_TIMER).getTime() % MACHINE_GUN_INTERVAL == 0)
		{
			atkSphere.push_back(new C_HitSphereModel(MACHINE_GUN_RAD, MACHINE_GUN_POWER, MACHINE_GUN_LIMIT, MACHINE_GUN_SPEED, false));
			atkSphere.back()->setMaterial(DimYellow);
			atkSphere.back()->glMoveTo(pos);
			atkSphere.back()->glVec(body.getVec());
			atkSphere.back()->loTranslate(0.0, 0.0, -20.0);
			//atkSphere.back()->loFocus(GetRand(-5, 5) * 0.1, 0.0, -1.0);	// ΂
			scene->entryModel(atkSphere.back());
		}
		// p`
		else if(timer.at(PUNCH_TIMER).getTime() == PUNCH_DELAY)
		{
			atkBlock.push_back(new C_HitBlockModel(30.0, 30.0, 60.0, PUNCH_POWER, PUNCH_LIMIT, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(DarkPurple);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(0.0, 0.0, -40.0);
			scene->entryModel(atkBlock.back());
		}
		
		// ȔIۂTHINK_TIMERZbg(dԂ肽)
		if(timer.at(ATTACK_DELAY_TIMER).getTime() == 1)	timer.at(THINK_TIMER).setTime(30);
	}

	// }VK̈ړƏŏ
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		atkSphere.at(i)->move();	// ëړ

		// ŎԂɂȂ邩AǂɓĂ
		if(atkSphere.at(i)->cntLimit() || map->isHit(atkSphere.at(i)))
		{
			scene->removeModel(atkSphere.at(i));
			SAFE_DELETE(atkSphere.at(i));
			itSphere = atkSphere.begin();
			itSphere += i;
			itSphere = atkSphere.erase(itSphere);
		}
	}

	// punch̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}