#include "Boy.h"
#include "Girl.h"
#include "EnemyBase.h"

using namespace EnemyBase;

C_EnemyBase::C_EnemyBase(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: lockTarget(0)
//, state(0)
, movePattern(0)
, attackPattern(0)
, distToBoy(0.0)
, distToGirl(0.0)
, isHeavy(false)
, isLock(false)
, isBoot(false)
, isCollision(true)
, lockAble(true)
{
	scene = argScene;
	camera = argCamera;
	map = argMap;
	boy = argBoy;
	girl = argGirl;

	red_bar.setSpriteSize(GAUGE_SIZE_X, GAUGE_SIZE_Y);		// ԃQ[W̕ݒ
	//red_bar.setPositionLT(-500.0, 320.0);
	//red_bar.glMoveTo(0.0, 320.0, 0.0);

	purple_bar.setSpriteSize(0.0);							// Q[W̕ݒ
	//purple_bar.setPositionLT(-500.0, 320.0);

	green_bar.setSpriteSize(GAUGE_SIZE_X, GAUGE_SIZE_Y);	// ΃Q[W̕ݒ
	//green_bar.setPositionLT(-500.0, 320.0);
	//green_bar.glMoveTo(0.0, 320.0, 0.0);
}

C_EnemyBase::~C_EnemyBase()
{
	for(unsigned int i = 0; i < shield.size(); ++i)
	{
		scene->removeModel(shield.at(i));
		SAFE_DELETE(shield.at(i));
	}
	shield.clear();
}

// UꂽƂ̏
void C_EnemyBase::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		hp -= boy->atkBlock.back()->getPower();
		damage_flag = true;
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		hp -= boy->atkSphere.back()->getPower();
		damage_flag = true;
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			hp -= girl->atkSphere.at(i)->getPower();
			damage_flag = true;

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);
		}
	}

	// girl̃[U[ɓ
	if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	{
		//cout << "Laser HIT!" << endl;
		hp -= girl->atkBlock.back()->getPower();
		damage_flag = true;
	}

	// hp0ȉȂ玀StO𗧂Ă
	if(hp <= 0)	death_flag = true;

	// damage_flagtrueAHPQ[W𒲐
	if(damage_flag)
	{
		damage_flag = false;
		green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max), GAUGE_SIZE_Y);	// cHP̊ɉĒς
	}

	red_bar.glMoveTo(pos.x, model.getScale() * 2.5, pos.z);
	green_bar.glMoveTo(pos.x - ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), model.getScale() * 2.5, pos.z);
	red_bar.glVec(-camera->getPosition());
	green_bar.glVec(-camera->getPosition());
	red_bar.glTranslate((red_bar.getInhPosition() - camera->getInhPosition()) * 0.01);
}

void C_EnemyBase::updateDistToPlayer()
{
	distToBoy = (boy->getBody()->getInhPosition() - body.getInhPosition()).dist();
	distToGirl = (girl->getBody()->getInhPosition() - body.getInhPosition()).dist();
}

double C_EnemyBase::getDistToBoy()
{
	return distToBoy;
}

double C_EnemyBase::getDistToGirl()
{
	return distToGirl;
}

bool C_EnemyBase::getIsHeavy()
{
	return isHeavy;
}

bool C_EnemyBase::getIsLock()
{
	return isLock;
}

bool C_EnemyBase::getIsCollision()
{
	return isCollision;
}

void C_EnemyBase::setIsBoot(bool argFlag)
{
	isBoot = argFlag;
}

bool C_EnemyBase::getIsBoot()
{
	return isBoot;
}

void C_EnemyBase::setLockAble(bool argFlag)
{
	lockAble = argFlag;
}

bool C_EnemyBase::getLockAble()
{
	return lockAble;
}

int C_EnemyBase::lockNear()
{
	// ߂̃vC[_
	if(distToBoy <= distToGirl)
	{
		if(!boy->getDeath_flag())	return BOY;
		else						return GIRL;
	}
	else
	{
		if(!girl->getDeath_flag())	return GIRL;
		else						return BOY;
	}
}

int C_EnemyBase::lockFar()
{
	// ̃vC[_
	if(distToBoy >= distToGirl)
	{
		if(!boy->getDeath_flag())	return BOY;
		else						return GIRL;
	}
	else
	{
		if(!girl->getDeath_flag())	return GIRL;
		else						return BOY;
	}
}

int C_EnemyBase::lockBoy()
{
	// {Iboy_
	if(boy->getDeath_flag() && !girl->getDeath_flag())	return GIRL;
	else												return BOY;
}

int C_EnemyBase::lockGirl()
{
	// {Igirl_
	if(girl->getDeath_flag() && !boy->getDeath_flag())	return BOY;
	else												return GIRL;
}

int C_EnemyBase::lockRandom()
{
	if(boy->getDeath_flag() && !girl->getDeath_flag())		return GIRL;
	else if(girl->getDeath_flag() && !boy->getDeath_flag())	return BOY;
	else													return GetRand(1, 2);	// _vC[_Ō߂
}

void C_EnemyBase::turnToBoy(double turnSpeed)
{
	fk_Vector posA, posB, tempVec;

	// sƂ̌vZʂYɂ邽߂Y𓯂ɂĂ
	tempVec.set(boy->getBody()->getInhPosition().x, body.getInhPosition().y, boy->getBody()->getInhPosition().z);
	posA = body.getInvMatrix() * tempVec;					// 猩boy̍W𓾂
	if(posA.x >= 0)	body.loAngle(turnSpeed, 0.0, 0.0);		// EboyȂEɉ]
	else			body.loAngle(-turnSpeed, 0.0, 0.0);		// boyȂ獶ɉ]
	posB = body.getInvMatrix() * tempVec;
	// ]ĂƏ𐳊mɍ킹
	if((posA.x >= 0 && posB.x < 0) || (posA.x < 0 && posB.x > 0))
	{
		body.glFocus(tempVec);
		isLock = true;
	}
	else	isLock = false;
}

void C_EnemyBase::turnToGirl(double turnSpeed)
{
	fk_Vector posA, posB, tempVec;

	// sƂ̌vZʂYɂ邽߂Y𓯂ɂĂ
	tempVec.set(girl->getBody()->getInhPosition().x, body.getInhPosition().y, girl->getBody()->getInhPosition().z);
	posA = body.getInvMatrix() * tempVec;					// 猩girl̍W𓾂
	if(posA.x >= 0)	body.loAngle(turnSpeed, 0.0, 0.0);		// EgirlȂEɉ]
	else			body.loAngle(-turnSpeed, 0.0, 0.0);		// girlȂ獶ɉ]
	posB = body.getInvMatrix() * tempVec;
	// ]ĂƏ𐳊mɍ킹
	if((posA.x >= 0 && posB.x < 0) || (posA.x < 0 && posB.x > 0))
	{
		body.glFocus(tempVec);
		isLock = true;
	}
	else	isLock = false;
}