/************************************************************************
@@Fire.h

@@Fire Effect

@@Date : Nov. 12, 2007
@@Version : 1.0
@@Author : Pocol
*************************************************************************/

#ifndef _FIRE_H_INCLUDED_
#define _FIRE_H_INCLUDED_

//
//@include
//
#include <iostream>
#include <cmath>
#include <GL/glew.h>
#include <GL/glut.h>
#include <FK/FK.h>	// FKCN[hGLwb_L
#include "DDSLoader.h"
using namespace std;

//
//@link
//
#pragma comment(lib, "glew32.lib")

/////////////////////////////////////////////////////////////////////////
//@@FireParticle class
/////////////////////////////////////////////////////////////////////////
class FireParticle
{
protected:
	double position[3];
	double velocity[3];
	double size;
	float color[3];
	float baseColor[3];
	double maxXZ;

	int time;
	int endTime;

public:
	FireParticle(float base_color[3], double max_xz);
	~FireParticle();
	void Initialize();
	void Move();
	void Render(double argAlpha);
};

/////////////////////////////////////////////////////////////////////////
//@@Fire class
/////////////////////////////////////////////////////////////////////////
class Fire
{
protected:
	FireParticle **fire_particle;
	int fireCount;
	DDSImage texture;

public:
	Fire(int fire_count, float smoke_color[3], double max_xz);
	~Fire();
	void LoadTexture(const char *filename);
	void Move();
	void Render(double argAlpha);
};

/////////////////////////////////////////////////////////////////////////
//@@FireModel class
/////////////////////////////////////////////////////////////////////////

class FireModel : public fk_Model {
private:
	fk_Point		dummyShape;
	Fire			*fire;
	double			alpha;
	int				timer, fadeInTime, nonFadeTime, fadeOutTime;

public:
	FireModel(int argFadeInTime, int argNonFadeTime, int argFadeOutTime);
	~FireModel();
	void init(void);

	bool isLimit();

	void preShader(void);
	void postShader(void);
};

#endif	//@_SMOKE_H_INCLUDED_