#pragma once
#include <GL/glew.h>
#include <FK/FK.h>
#include "FKUT/FrameController.h"
#include "FKUT/Fullscreen.h"
#include "FKUT/Input.h"
#include "FKUT/SpriteModel.h"
#include "EventManager.h"
#include "Sound.h"

enum fkut_LoopState
{
	FKUT_EXIT,
	FKUT_RUNNING,
	FKUT_SLEEPING
};

class C_GameBase
{
private:
	void	Sleep(unsigned long);
	void	ToggleScreen(void);

protected:
	Fl_Window	*mainWin;
	fk_Window	*drawWin;

	fkut_Input	input;
	bool		inputReady;

	fkut_FrameController	fps;
	CFullscreenControler	fsc;
	C_EventManager			eveMan;

	virtual void	init(void) = 0;
	virtual bool	procLoop(void) = 0;

	fkut_LoopState	updateWindow(void);

public:
	C_GameBase(Fl_Window *argMainWin, fk_Window *argDrawWin);
	virtual ~C_GameBase(void);

	int				run(void);
};