#include "Boy.h"
#include "Girl.h"
#include "EnemyBase.h"

using namespace Girl;
using namespace Heal;

int C_Girl::GIRL_HP = HP_MAX;	// ÓIoϐ̎

C_Girl::C_Girl(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, vector<C_EnemyBase *> *argEnemy)
: LX(0.0)
, LY(0.0)
, magnitudeL(0.0)
, lock_flag(false)
, lockSwitchNum(0)
, lockOrder_flag(false)
, lockOrderAdjust_flag(false)
, lockEnemyId(0)
, lockEnemyIndex(0)
, nextShot_flag(false)
{
	scene = argScene;
	camera = argCamera;
	map = argMap;
	boy = argBoy;
	enemyArray = argEnemy;

	body.create(6, 20.0);
	body.glMoveTo(0.0, 20.0, 0.0);
	//body.setMaterial(Yellow);
	body.setMaterial(White);
	body.getMaterial()->setSpecular(0.2, 0.2, 0.2);
	body.getMaterial()->setShininess(128.0);

	//xfile.load("Data/CG/Character/player/girl.x", "Data/CG/Character/player/girl_tex.png");
	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_GIRL].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Phong.vert", "Data/Shader/Phong.frag");
	model.setScale(55.0);
	model.glMoveTo(0.0, 50.0, 0.0);
	model.setParent(&body, true);

	hp = GIRL_HP;
	hp_max = HP_MAX;
	id = -2;	// boyID-1, girlID-2ŌŒ

	// _EԂXe[WړĂꍇA񕜂Ă
	if(hp <= 0)		hp = HP_MAX;

	// ΃t[
	green_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	green_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	// ԃt[
	red_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	red_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);
	
	// t[
	purple_frame.setSpriteSize(GAUGE_SIZE_X + 7.0);
	purple_frame.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	// ΃Q[W
	//green_bar.setSpriteSize(hp * GAUGE_SIZE_COEF);	
	//green_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));	// cHP̊ɉĒς
	green_bar.glMoveTo(GAUGE_POS_X + ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

	// ԃQ[W
	red_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));		// cHP̊ɉĒς
	//red_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	red_bar.glMoveTo(GAUGE_POS_X + ((GAUGE_SIZE_X - red_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

	// Q[W
	purple_bar.setSpriteSize(0.0);
	//purple_bar.setPositionLT(GAUGE_POS_X, GAUGE_POS_Y);
	purple_bar.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

	timer.resize(TIMER_MAX);
}

C_Girl::~C_Girl()
{
	// HPƃ_E񐔂ۑĂ
	GIRL_HP = hp;
}

// ړ
void C_Girl::move()
{
	spd.init();	// ړx0ɖ߂

	if(move_flag && death_flag == false)
	{
		LX = controller[0].state.Gamepad.sThumbLX;
		LY = controller[0].state.Gamepad.sThumbLY;
		magnitudeL = sqrt(LX * LX + LY * LY);

		if( (LX > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE || LX < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)
			|| (LY > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE || LY < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE) )
		{
			vec.x =  LX / magnitudeL;
			vec.z = -LY / magnitudeL;
			spd.z = -GIRL_SPEED;
		}

		// bNIԂ̎
		if(lock_flag)
		{
			if( (LX > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE || LX < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)
				|| (LY > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE || LY < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE) )
			{
				body.glTranslate(vec * GIRL_SPEED);	// Lړ
			}
		}
		// bNIԂłȂ
		else
		{
			body.glVec(vec);		// Ľݒ
			body.loTranslate(spd);	// Lړ
		}
	}

	// }bvƂ̓蔻
	if(lock_flag)	map->procHit_forGirl(&body, &spd);
	else			map->procHit(&body, &spd);

	// boyƂ̓蔻
	procHit(boy->getBody());

	// enemyƂ̓蔻
	for(unsigned int i = 0; i < enemyArray->size(); ++i)
	{
		// yGȂ牟
		if(!enemyArray->at(i)->getIsHeavy())	procHit(enemyArray->at(i)->getBody());
	}

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Girl::attack()
{
	// U\Ȃ
	if(timer.at(ATTACK_DELAY_TIMER).getTime() <= 0 && death_flag == false)
	{
		// [U[̐
		if(timer.at(CHARGE_TIMER).getTime() >= CHARGE_COMP_TIME && controller[0].KeyUp(X_GAMEPAD_LB))
		{
			atkBlock.push_back(new C_HitBlockModel(LASER_THICK, LASER_THICK, LASER_PRIMAL_LENGTH, LASER_POWER, LASER_LIMIT, LASER_SPEED, false));
			atkBlock.back()->setMaterial(Blue);
			atkBlock.back()->glMoveTo(pos);
			if(lock_flag)	atkBlock.back()->glFocus(lockVec);
			else			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(10.0, 0.0, -30.0);
			scene->entryModel(atkBlock.back());

			// fBC^Cƃ[U[̔˂Ǘϐɒl
			timer.at(ATTACK_DELAY_TIMER).setTime(LASER_DELAY);
			timer.at(LASER_TIMER).setTime(LASER_DELAY);
			timer.at(CHARGE_TIMER).setTime(0, false);	// CHARGE_TIMERZbg
			move_flag = false;	// d

			// SE
			sound.se_on(SE_LASER);
		}

		// LBĂԃ[U[`[W
		if(controller[0].KeyPress(X_GAMEPAD_LB) && timer.at(MACHINE_GUN_TIMER).getTime() <= 0)
		{
			timer.at(CHARGE_TIMER).setTime(timer.at(CHARGE_TIMER).getTime() + 1, false);

			// `[W
			// SE
			if(timer.at(CHARGE_TIMER).getTime() == CHARGE_COMP_TIME)	sound.se_on(SE_CHARGE_COMPLETE);

			// `[WĂȂU
			if(timer.at(CHARGE_TIMER).getTime() >= CHARGE_COMP_TIME)	controller[0].vib_on(0, 20000, 0, 1);
		}
		// LBĂȂCHARGE_TIMERZbg
		else	timer.at(CHARGE_TIMER).setTime(0, false);

		// }VK̏
		if(nextShot_flag || controller[0].KeyDown(X_GAMEPAD_LB) || (controller[0].getIsAuto() && !controller[0].KeyPress(X_GAMEPAD_LB) && lock_flag && move_flag))
		{
			// fBC^Cƃ}VK̔˂Ǘϐɒl
			timer.at(ATTACK_DELAY_TIMER).setTime(MACHINE_GUN_DELAY);
			timer.at(MACHINE_GUN_TIMER).setTime(MACHINE_GUN_DELAY);
			nextShot_flag = false;
		}
	}
	else
	{
		// ̎ˌ\
		if(controller[0].KeyDown(X_GAMEPAD_LB) && death_flag == false)	nextShot_flag = true;
	}

	// }VK̐
	if(timer.at(MACHINE_GUN_TIMER).getTime() != 0 && timer.at(MACHINE_GUN_TIMER).getTime() % MACHINE_GUN_INTERVAL == 0)
	{
		atkSphere.push_back(new C_HitSphereModel(MACHINE_GUN_RAD, MACHINE_GUN_POWER, MACHINE_GUN_LIMIT, MACHINE_GUN_SPEED, false));
		atkSphere.back()->setMaterial(Orange);
		atkSphere.back()->glMoveTo(pos);
		if(lock_flag)	atkSphere.back()->glFocus(lockVec);
		else			atkSphere.back()->glVec(body.getVec());
		atkSphere.back()->loTranslate(10.0, 0.0, -30.0);
		scene->entryModel(atkSphere.back());

		// SE
		sound.se_on(SE_MACHINE_GUN);
	}

	// }VK̈ړƏŏ
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		// e̗U
		if(lock_flag && enemyArray->size() > 0)
		{
			fk_Vector posA, posB, tempVec;

			//tempVec.set(enemyArray->at(lockEnemyIndex)->getBody()->getInhPosition().x, enemyArray->at(lockEnemyIndex)->getBody()->getInhPosition().y, enemyArray->at(lockEnemyIndex)->getBody()->getInhPosition().z);
			tempVec = enemyArray->at(lockEnemyIndex)->getBody()->getInhPosition();
			posA = atkSphere.at(i)->getInvMatrix() * tempVec;		// e猩G̍W𓾂

			//cout << posA.x << "," << posA.y << "," << posA.z << endl;

			if(posA.x >= 0)	atkSphere.at(i)->loAngle(TURN_SPEED, 0.0, 0.0);		// EɓGȂEɉ]
			else			atkSphere.at(i)->loAngle(-TURN_SPEED, 0.0, 0.0);	// ɓGȂ獶ɉ]
			posB = atkSphere.at(i)->getInvMatrix() * tempVec;
			// ]ĂƏ𐳊mɍ킹
			if((posA.x >= 0 && posB.x < 0) || (posA.x < 0 && posB.x > 0))
			{
				atkSphere.at(i)->glFocus(tempVec);
			}
		}

		//cout << atkSphere.at(i)->getSpd().x << "," << atkSphere.at(i)->getSpd().y << "," << atkSphere.at(i)->getSpd().z << endl;
		atkSphere.at(i)->move();	// ëړ

		// ŎԂɂȂ邩Aboy܂͕ǂɓĂ
		if(atkSphere.at(i)->cntLimit() || boy->isHit(atkSphere.at(i)) || map->isHit(atkSphere.at(i)))
		{
			scene->removeModel(atkSphere.at(i));
			SAFE_DELETE(atkSphere.at(i));
			itSphere = atkSphere.begin();
			itSphere += i;
			itSphere = atkSphere.erase(itSphere);
		}
	}

	// [U[̈ړ
	if(atkBlock.size() > 0)
	{
		fk_Vector	back;
		bool		shieldHit = false;

		// [U[܂Ȃ鎞Ԃł
		if(timer.at(LASER_TIMER).getTime() > LASER_DELAY - LASER_CREATE_TIME)
		{
			// G̏ɓĂ邩
			for(unsigned int i = 0; i < enemyArray->size(); ++i)
			{
				if(enemyArray->at(i)->shield.size() > 0 && atkBlock.back()->checkToBlock(*enemyArray->at(i)->shield.back(), back))
				{
					shieldHit = true;
				}
			}

			// boy܂͕ǂG̏ɓĂȂ
			if(!atkBlock.back()->checkToSphere(*boy->getBody(), back) && !map->isHit(atkBlock.back()) && !shieldHit)
			{
				// ړĂ璷spd*2L΂čĐ
				//atkBlock.back()->setLength(atkBlock.back()->getLength() + atkBlock.back()->getSpd().z * -2);
				atkBlock.back()->move();
				atkBlock.back()->setSize(atkBlock.back()->getSizeX(), atkBlock.back()->getSizeY(), atkBlock.back()->getSizeZ() + atkBlock.back()->getSpd().z * -2);
			}
		}
		else
		{
			// G̏ɓĂ邩
			for(unsigned int i = 0; i < enemyArray->size(); ++i)
			{
				if(enemyArray->at(i)->shield.size() > 0 && atkBlock.back()->checkToMovingBlock(*enemyArray->at(i)->shield.back(), atkBlock.back()->getSpd(), back))
				{
					shieldHit = true;
				}
			}

			// boy܂͕ǂG̏ɓĂ鎞
			if(atkBlock.back()->checkToMovingSphere(*boy->getBody(), atkBlock.back()->getSpd(), back) || map->procHit(atkBlock.back(), &atkBlock.back()->getSpd(), &back) || shieldHit)
			{
				// back+spdZ
				double tempLength = atkBlock.back()->getSizeZ() - (back.dist() - atkBlock.back()->getSpd().z);

				// [U[̒0ȉɂȂł
				if(tempLength <= 0.0)
				{
					scene->removeModel(atkBlock.back());
					SAFE_DELETE(atkBlock.back());
					atkBlock.pop_back();

					// GAttackData菜
					//for(unsigned int i = 0; i < enemyArray->size(); ++i)	enemyArray->at(i)->removeAttackData(id, GIRL_LASER, 0);
				}
				// łȂ΍Đ
				else	atkBlock.back()->setSize(atkBlock.back()->getSizeX(), atkBlock.back()->getSizeY(), tempLength);
			}
			// ĂȂ
			else	atkBlock.back()->move();
		}
	}

	// [U[̍d
	if(timer.at(LASER_TIMER).getTime() == 0)	move_flag = true;

	// [U[̑؋󎞊Ԃ
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// GAttackData菜
		//for(unsigned int i = 0; i < enemyArray->size(); ++i)	enemyArray->at(i)->removeAttackData(id, GIRL_LASER, 0);
	}

	// [U[̓蔻𐧌䂷
	//if(atkBlock.size() > 0 && atkBlock.back()->getLimit() % 2 == 0)
	//{
	//	// GAttackData菜
	//	for(unsigned int i = 0; i < enemyArray->size(); ++i)	enemyArray->at(i)->removeAttackData(id, GIRL_LASER, 0);
	//}
}

// bNI
void C_Girl::lockon()
{
	if(death_flag == false)
	{
		if(lock_flag == false && enemyArray->size() > 0)	// bNĂȂɓG玩ŃbN
		{
			lock_flag = true;	// bNԂɂ
			lockOrder.clear();	// bNNA
			lockSwitchNum = 0;
			lockOrder_flag = false;
			lockOrderAdjust_flag = false;

			// GƂ̋Zo
			vector<double> dist;
			for(unsigned int i = 0; i < enemyArray->size(); i++)
			{
				// girlƓGƂ̋*2distpush
				dist.push_back((pos - enemyArray->at(i)->getPos()).dist2());
			}

			boost::sort(dist);	// GƂ̋߂()ɕёւ

			// ߂ɓGID擾
			for(unsigned int i = 0; i < dist.size(); i++)
			{
				// 1OɊi[ĂlƓȂcontinue
				if(i >= 1 && dist.at(i) == dist.at(i - 1))	continue;

				for(unsigned int j = 0; j < enemyArray->size(); j++)
				{
					if(dist.at(i) == (pos - enemyArray->at(j)->getPos()).dist2())
					{
						lockOrder.push_back(enemyArray->at(j)->getId());
					}
				}
			}

			// bNĂGw|C^[
			lockPointer.create(6, 8.0, 15.0);
			lockPointer.setMaterial(DimYellow);
			lockPointer.glVec(0.0, -1.0, 0.0);
			scene->entryModel(&lockPointer);
			timer.at(LOCK_TIMER).setTime(0, false);

			// SE
			sound.se_on(SE_LOCKON);
		}

		if(controller[0].KeyDown(X_GAMEPAD_LT) && enemyArray->size() > 1)	// bNΏۂ̓G؂Ԃ鎞
		{
			if(lockSwitchNum >= lockOrder.size() - 1)	lockSwitchNum = 0;
			else										lockSwitchNum++;

			//timer.at(LOCK_TIMER).setTime(0, false);

			// SE
			sound.se_on(SE_LOCKON);
		}
	}

	if(lock_flag == true && enemyArray->size() > 0)
	{
		if(lockOrder_flag)	// bNĂG|
		{
			lockOrder.clear();	// ԂZbg

			// GƂ̋Zo
			vector<double> dist;
			for(unsigned int i = 0; i < enemyArray->size(); i++)
			{
				// girlƓGƂ̋*2distpush
				dist.push_back((pos - enemyArray->at(i)->getPos()).dist2());
			}

			boost::sort(dist);	// GƂ̋߂()ɕёւ

			// ߂ɓGID擾
			for(unsigned int i = 0; i < dist.size(); i++)
			{
				// 1OɊi[ĂlƓȂcontinue
				if(i >= 1 && dist.at(i) == dist.at(i - 1))	continue;

				for(unsigned int j = 0; j < enemyArray->size(); j++)
				{
					if(dist.at(i) == (pos - enemyArray->at(j)->getPos()).dist2())
					{
						lockOrder.push_back(enemyArray->at(j)->getId());
					}
				}
			}
			lockOrder_flag = false;
			lockOrderAdjust_flag = false;
			lockSwitchNum = 0;
			timer.at(LOCK_TIMER).setTime(0, false);

			// SE
			sound.se_on(SE_LOCKON);
		}

		if(lockOrderAdjust_flag)	// bNĂGȊO|Ƃ
		{
			lockOrder.clear();	// ԂZbg

			// GƂ̋Zo
			vector<double> dist;
			for(unsigned int i = 0; i < enemyArray->size(); i++)
			{
				// bNĂGIDƈvG܂݂Ă΍ŏɓo^Ă
				if(enemyArray->at(i)->getId() == lockEnemyId)	lockOrder.push_back(lockEnemyId);

				// girlƓGƂ̋*2distpush
				dist.push_back((pos - enemyArray->at(i)->getPos()).dist2());
			}

			boost::sort(dist);	// GƂ̋߂()ɕёւ

			// ߂ɓGID擾
			for(unsigned int i = 0; i < dist.size(); i++)
			{
				// 1OɊi[ĂlƓȂcontinue
				if(i >= 1 && dist.at(i) == dist.at(i - 1))	continue;

				for(unsigned int j = 0; j < enemyArray->size(); j++)
				{
					if(dist.at(i) == (pos - enemyArray->at(j)->getPos()).dist2())
					{
						// bNĂGȂɓĂ̂continue
						if(enemyArray->at(j)->getId() == lockEnemyId)	continue;

						lockOrder.push_back(enemyArray->at(j)->getId());
					}
				}
			}
			lockSwitchNum = 0;
			lockOrderAdjust_flag = false;
		}

		// bN悤ƂĂGz̉Ԗڂɂ邩ׂ
		//unsigned int lockEnemyIndex = 0;
		for(unsigned int i = 0; i < enemyArray->size(); ++i)
		{
			if(lockOrder.at(lockSwitchNum) == enemyArray->at(i)->getId())
			{
				lockEnemyIndex = i;
				break;
			}
		}

		// bNłȂGXLbv
		if(enemyArray->at(lockEnemyIndex)->getLockAble() == false)
		{
			int tempLockSwitchNum = lockSwitchNum;
			do
			{
				if(lockSwitchNum >= lockOrder.size() - 1)	lockSwitchNum = 0;
				else										lockSwitchNum++;

				for(unsigned int i = 0; i < enemyArray->size(); ++i)
				{
					if(lockOrder.at(lockSwitchNum) == enemyArray->at(i)->getId())
					{
						lockEnemyIndex = i;
						break;
					}
				}
			}
			while(enemyArray->at(lockEnemyIndex)->getLockAble() == false && tempLockSwitchNum != lockSwitchNum);

			// bNłȂGȂlock_flagfalse
			if(tempLockSwitchNum == lockSwitchNum)
			{
				lock_flag = false;
				sound.se_stop(SE_LOCKON);
			}
			else
			{
				// SE
				sound.se_on(SE_LOCKON);
			}

			// bNΏۂ̐؂ւsƂAbNłΏۂ1̂ȂꍇSE
			if(tempLockSwitchNum == 0)	tempLockSwitchNum = lockOrder.size() - 1;
			else						tempLockSwitchNum--;
			if(tempLockSwitchNum == lockSwitchNum)
			{
				sound.se_stop(SE_LOCKON);
			}
			else
			{
				timer.at(LOCK_TIMER).setTime(0, false);
			}
		}

		// ړłȂ
		if(move_flag)
		{
			// bNĂG
			body.glFocus(enemyArray->at(lockEnemyIndex)->getPos().x, pos.y, enemyArray->at(lockEnemyIndex)->getPos().z);

			// bNĂۑ
			lockVec = enemyArray->at(lockEnemyIndex)->getPos();
		}
		// bNĂGIDۑ
		lockEnemyId = enemyArray->at(lockEnemyIndex)->getId();

		// bN|C^[ړ
		lockPointer.glMoveTo(enemyArray->at(lockEnemyIndex)->getPos().x,
			enemyArray->at(lockEnemyIndex)->getPos().y + enemyArray->at(lockEnemyIndex)->getModel()->getScale() * 1.8/* * (1.0 + 1.0 / 6.0) */+ sin(FK_PI * 2.0 / /**/30.0/**/ * timer.at(LOCK_TIMER).getTime()) * /*U*/enemyArray->at(lockEnemyIndex)->getModel()->getScale() / 5.0,
			enemyArray->at(lockEnemyIndex)->getPos().z/* - enemyArray->at(lockEnemyIndex)->getBody()->getRad()*/);

		// ԂɂăbN|C^[
		timer.at(LOCK_TIMER).setTime(timer.at(LOCK_TIMER).getTime() + 1, false);
	}
	else// bNGȂȂ
	{
		lock_flag = false;
		scene->removeModel(&lockPointer);	// bN|C^[
	}
}

// 
void C_Girl::heal()
{
	//cout << body.getAngle().p << "," << body.getAngle().h << "," << body.getAngle().b << endl;
	//cout << "num: " << boy->getDeathNum() << ", time: " << timer.at(HEAL_TIMER).getTime() << endl;

	if(death_flag && !boy->getDeath_flag() && (boy->getPos() - pos).dist() <= HEAL_DIST)
	{
		timer.at(HEAL_TIMER).setTime(timer.at(HEAL_TIMER).getTime() + 1, false);

		// SE
		sound.se_on(SE_AT_HEAL);

		if(timer.at(HEAL_TIMER).getTime() >= HEAL_COMP_PRIMAL_TIME + boy->getDeathNum() * HEAL_PENALTY_TIME)
		{
			hp = HP_MAX;
			death_flag = false;

			model.loFocus(0.0, 1.0, 0.0);			// N

			timer.at(HEAL_TIMER).setTime(0, false);	// ^C}[ZbgĂ
			purple_bar.setSpriteSize(0.0);			// Q[W̕ݒ
			scene->removeOverlayModel(&purple_frame);
			scene->removeOverlayModel(&purple_bar);

			scene->entryOverlayModel(&green_frame);
			scene->entryOverlayModel(&green_bar);
			green_bar.setSpriteSize(GAUGE_SIZE_X);
			green_bar.glMoveTo(GAUGE_POS_X, GAUGE_POS_Y, 0.0);

			// SE
			sound.se_stop(SE_AT_HEAL);
			sound.se_on(SE_HEAL_COMPLETE);
		}
		else if(timer.at(HEAL_TIMER).getTime() > 0)
		{
			purple_bar.setSpriteSize(GAUGE_SIZE_X * timer.at(HEAL_TIMER).getTime() / (HEAL_COMP_PRIMAL_TIME + boy->getDeathNum() * HEAL_PENALTY_TIME));	// Q[W̕ݒ
			purple_bar.glMoveTo(GAUGE_POS_X + ((GAUGE_SIZE_X - purple_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);
		}
	}

	// 񕜒SE~߂
	if(sound.se_getFlag(SE_AT_HEAL) && ((boy->getPos() - pos).dist() > HEAL_DIST || (death_flag && boy->getDeath_flag())))
	{
		sound.se_stop(SE_AT_HEAL);
	}
}

// UꂽƂ̏
void C_Girl::procDamage()
{
	int tempHp = hp;	// 3ȉɂȂƂԘgo

	if(death_flag == false)
	{
		for(unsigned int i = 0; i < enemyArray->size(); ++i)
		{
			for(unsigned int j = 0; j < enemyArray->at(i)->atkSphere.size(); ++j)
			{
				// eɓ
				if(isHit(enemyArray->at(i)->atkSphere.at(j)))
				{
					// 蔻肪cȔꍇ
					if(enemyArray->at(i)->atkSphere.at(j)->getKind() >= 0)
					{
						// attackDataɓo^ĂȂ
						if(checkAttackData(enemyArray->at(i)->getId(), enemyArray->at(i)->atkSphere.at(j)->getKind(), enemyArray->at(i)->atkSphere.at(j)->getIndex()))
						{
							hp -= enemyArray->at(i)->atkSphere.at(j)->getPower();
							damage_flag = true;
						}
					}
					// x悤ȍȔꍇ
					else
					{
						hp -= enemyArray->at(i)->atkSphere.at(j)->getPower();
						damage_flag = true;

						// ʂ
						scene->removeModel(enemyArray->at(i)->atkSphere.at(j));
						SAFE_DELETE(enemyArray->at(i)->atkSphere.at(j));
						enemyArray->at(i)->itSphere = enemyArray->at(i)->atkSphere.begin();
						enemyArray->at(i)->itSphere += j;
						enemyArray->at(i)->itSphere = enemyArray->at(i)->atkSphere.erase(enemyArray->at(i)->itSphere);
					}
				}
			}

			for(unsigned int j = 0; j < enemyArray->at(i)->atkBlock.size(); ++j)
			{
				fk_Vector	back;
				// ubNɓ
				if(enemyArray->at(i)->atkBlock.at(j)->checkToSphere(body, back))
				{
					// 蔻肪cȔꍇ
					if(enemyArray->at(i)->atkBlock.at(j)->getKind() >= 0)
					{
						// attackDataɓo^ĂȂ
						if(checkAttackData(enemyArray->at(i)->getId(), enemyArray->at(i)->atkBlock.at(j)->getKind(), enemyArray->at(i)->atkBlock.at(j)->getIndex()))
						{
							hp -= enemyArray->at(i)->atkBlock.at(j)->getPower();
							damage_flag = true;
						}
					}
					// x悤ȍȔꍇ
					else
					{
						hp -= enemyArray->at(i)->atkBlock.at(j)->getPower();
						damage_flag = true;

						// ʂ
						scene->removeModel(enemyArray->at(i)->atkBlock.at(j));
						SAFE_DELETE(enemyArray->at(i)->atkBlock.at(j));
						enemyArray->at(i)->itBlock = enemyArray->at(i)->atkBlock.begin();
						enemyArray->at(i)->itBlock += j;
						enemyArray->at(i)->itBlock = enemyArray->at(i)->atkBlock.erase(enemyArray->at(i)->itBlock);
					}
				}
			}
		}
	}

	// hp0ȉȂ玀StO𗧂Ă
	if(death_flag == false && hp <= 0)
	{
		death_flag = true;
		boy->setDeathNum(boy->getDeathNum() + 1);
		green_bar.setSpriteSize(0.0);	// ΃Q[W̕ݒ

		model.loFocus(0.0, -1.0, 0.0);		// |

		// SE
		sound.se_on(SE_DOWN);

		lock_flag = false;
		scene->removeModel(&lockPointer);	// bN|C^[
		nextShot_flag = false;

		scene->removeOverlayModel(&red_frame);
		scene->removeOverlayModel(&red_bar);
		scene->removeOverlayModel(&green_frame);	// u3炤Ƃ͂ȂƎvꉞÔ
		scene->removeOverlayModel(&green_bar);

		scene->entryOverlayModel(&purple_frame);
		scene->entryOverlayModel(&purple_bar);
	}

	// damage_flagtrueAHPQ[W𒲐
	if(damage_flag)
	{
		damage_flag = false;
		green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));	// cHP̊ɉĒς
		green_bar.glMoveTo(GAUGE_POS_X + ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);
		red_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max));		// cHP̊ɉĒς
		red_bar.glMoveTo(GAUGE_POS_X + ((GAUGE_SIZE_X - red_bar.getSpriteSize().x) * 0.5), GAUGE_POS_Y, 0.0);

		// HP3ƂԘgɂ
		if(tempHp > hp_max * 0.3 && hp <= hp_max * 0.3)
		{
			scene->removeOverlayModel(&green_frame);
			scene->removeOverlayModel(&green_bar);

			scene->entryOverlayModel(&red_frame);
			scene->entryOverlayModel(&red_bar);
		}
	}
}

// bNtOݒ肷
void C_Girl::setLock_flag(bool argFlag)
{
	lock_flag = argFlag;
}

// bNĂ邩ǂԂ
bool C_Girl::getLock_flag()
{
	return lock_flag;
}

// lockSwitchNumԂ
//unsigned int C_Girl::getLockSwitchNum()
//{
//	return lockSwitchNum;
//}

// lockOrderԂ
//vector<int> C_Girl::getLockOrder()
//{
//	return lockOrder;
//}

// bN鏇ԂύXAtrueZbg
void C_Girl::setLockOrder_flag(bool argFlag)
{
	lockOrder_flag = argFlag;
}

// lockOrder_flagԂ
bool C_Girl::getLockOrder_flag()
{
	return lockOrder_flag;
}

// bNĂGȊO|trueZbg
void C_Girl::setLockOrderAdjust_flag(bool argFlag)
{
	lockOrderAdjust_flag = argFlag;
}

// lockOrderAdjust_flagԂ
bool C_Girl::getLockOrderAdjust_flag()
{
	return lockOrderAdjust_flag;
}

// bNGIDZbg
void C_Girl::setLockEnemyId(int num)
{
	lockEnemyId = num;
}

// bNĂGIDԂ
int C_Girl::getLockEnemyId()
{
	return lockEnemyId;
}