#include "Boy.h"
#include "Girl.h"
#include "Hammer01.h"

using namespace EnemyBase;
using namespace Hammer01;

C_Hammer01::C_Hammer01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.8, 0.8, 0.0);
	body.getMaterial()->setShininess(100.0);

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_HAMMER01].DX3_IFSTexture);	
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Hammer01::~C_Hammer01()
{
}

// ړ
void C_Hammer01::move()
{
	spd.init();				//ړx0ɖ߂
	updateDistToPlayer();	//vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		// ߂̃vC[_
		lockTarget = lockNear();

		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// Ă
			if(distToBoy > ATTACK_DIST)		spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(WAVE_TIME + WAVE_DELAY);
				timer.at(WAVE_TIMER).setTime(WAVE_TIME);
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// Ă
			if(distToGirl > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(WAVE_TIME + WAVE_DELAY);
				timer.at(WAVE_TIMER).setTime(WAVE_TIME);
			}
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Hammer01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// ߐڍU
		if(timer.at(WAVE_TIMER).getTime() == WAVE_TIME)
		{
			atkSphere.push_back(new C_HitSphereModel(WAVE_PRIMAL_SIZE, WAVE_POWER, WAVE_TIME, false, ENEMY_SINGLE_ATTACK));
			atkSphere.back()->setMaterial(Blue);
			atkSphere.back()->getMaterial()->setAlpha(0.6);
			atkSphere.back()->glMoveTo(pos);
			scene->entryModel(atkSphere.back());
		}
	}

	// EF[ȕ
	if(atkSphere.size() > 0)
	{
		// EF[u܂L鎞Ԃł
		if(timer.at(WAVE_TIMER).getTime() > WAVE_TIME - WAVE_CREATE_TIME)
		{
			atkSphere.back()->setRad(atkSphere.back()->getRad() + WAVE_SPREAD_SIZE);
		}
	}

	// EF[u̓蔻𐧌
	if(atkSphere.size() > 0 && atkSphere.back()->cntLimit())
	{
		scene->removeModel(atkSphere.back());		// ̂remove
		SAFE_DELETE(atkSphere.back());
		atkSphere.pop_back();

		// vC[AttackData菜
		// GAttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}