#include "HitBlockModel.h"

C_HitBlockModel::C_HitBlockModel(double x, double y, double z, int argPower, int argLimit, fk_Vector argSpd, bool argCE_flag, int argKind, int argIndex)
: limit_flag(false)
{
	create(x, y, z);
	sizeX = x;
	sizeY = y;
	sizeZ = z;
	power = argPower;
	limit = argLimit;
	spd = argSpd;
	isCE = argCE_flag;
	kind = argKind;
	index = argIndex;
}

C_HitBlockModel::C_HitBlockModel(double x, double y, double z, int argPower, int argLimit, bool argCE_flag, int argKind, int argIndex)
: limit_flag(false)
{
	create(x, y, z);
	sizeX = x;
	sizeY = y;
	sizeZ = z;
	power = argPower;
	limit = argLimit;
	isCE = argCE_flag;
	kind = argKind;
	index = argIndex;
}

C_HitBlockModel::~C_HitBlockModel()
{
}

void C_HitBlockModel::setSpd(fk_Vector argSpd)
{
	spd = argSpd;
}

fk_Vector C_HitBlockModel::getSpd()
{
	return spd;
}

void C_HitBlockModel::setPower(int argPower)
{
	power = argPower;
}

int C_HitBlockModel::getPower()
{
	return power;
}

void C_HitBlockModel::setCE_flag(bool argFlag)
{
	isCE = argFlag;
}

bool C_HitBlockModel::getCE_flag()
{
	return isCE;
}

void C_HitBlockModel::setKind(int argKind)
{
	kind = argKind;
}

int C_HitBlockModel::getKind()
{
	return kind;
}

void C_HitBlockModel::setIndex(int argIndex)
{
	index = argIndex;
}

int C_HitBlockModel::getIndex()
{
	return index;
}

void C_HitBlockModel::setLimit(int argLimit)
{
	limit = argLimit;
}

int C_HitBlockModel::getLimit()
{
	return limit;
}

void C_HitBlockModel::setLimit_flag(bool argFlag)
{
	limit_flag = argFlag;
}

bool C_HitBlockModel::getLimit_flag()
{
	return limit_flag;
}

void C_HitBlockModel::setSize(double x, double y, double z)
{
	create(x, y, z);
	sizeX = x;
	sizeY = y;
	sizeZ = z;
}

double C_HitBlockModel::getSizeX()
{
	return sizeX;
}

double C_HitBlockModel::getSizeY()
{
	return sizeY;
}

double C_HitBlockModel::getSizeZ()
{
	return sizeZ;
}

bool C_HitBlockModel::cntLimit()
{
	if(limit > 0)
	{
		--limit;
		if(limit == 0)
		{
			limit_flag = true;
			return true;
		}
	}

	return false;
}

void C_HitBlockModel::move()
{
	loTranslate(spd);
}

// Փˏ(߂)s(OBBp)
void C_HitBlockModel::procHit(fkut_BlockModel *OBB, fk_Vector *spd)
{
	// spdO[oWnɍ킹
	fk_HVector	hSpd = *spd;
	hSpd.setw(0.0);
	*spd = OBB->getMatrix() * hSpd;

	fk_Vector back;

	if(checkToMovingBlock(*OBB, *spd, back))
	{
		// Y͍lȂ
		back.y = 0.0;
		OBB->glTranslate(-back);
	}
}

// Փˏ(߂)s(p)
void C_HitBlockModel::procHit(fkut_SphereModel *sphere, fk_Vector *spd)
{
	// spdO[oWnɍ킹
	fk_HVector	hSpd = *spd;
	hSpd.setw(0.0);
	*spd = sphere->getMatrix() * hSpd;

	fk_Vector back;

	if(checkToMovingSphere(*sphere, *spd, back))
	{
		// Y͍lȂ
		back.y = 0.0;
		sphere->glTranslate(-back);
	}
}

// Ă邩ǂ(OBBp)
bool C_HitBlockModel::isHit(fkut_BlockModel *OBB)
{
	fk_Vector back;

	return checkToBlock(*OBB, back);
}

// Ă邩ǂ(p)
bool C_HitBlockModel::isHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	return checkToSphere(*sphere, back);
}