#include "HitSphereModel.h"

C_HitSphereModel::C_HitSphereModel(double argRad, int argPower, int argLimit, fk_Vector argSpd, bool argCE_flag, int argKind, int argIndex)
: limit_flag(false)
, expTime(-1)
{
	create(3, argRad);
	power = argPower;
	limit = argLimit;
	spd = argSpd;
	isCE = argCE_flag;
	kind = argKind;
	index = argIndex;
}

C_HitSphereModel::C_HitSphereModel(double argRad, int argPower, int argLimit, bool argCE_flag, int argKind, int argIndex)
: limit_flag(false)
, expTime(-1)
{
	create(3, argRad);
	power = argPower;
	limit = argLimit;
	isCE = argCE_flag;
	kind = argKind;
	index = argIndex;
}

C_HitSphereModel::~C_HitSphereModel()
{
}

void C_HitSphereModel::setSpd(fk_Vector argSpd)
{
	spd = argSpd;
}

fk_Vector C_HitSphereModel::getSpd()
{
	return spd;
}

void C_HitSphereModel::setPower(int argPower)
{
	power = argPower;
}

int C_HitSphereModel::getPower()
{
	return power;
}

void C_HitSphereModel::setCE_flag(bool argFlag)
{
	isCE = argFlag;
}

bool C_HitSphereModel::getCE_flag()
{
	return isCE;
}

void C_HitSphereModel::setKind(int argKind)
{
	kind = argKind;
}

int C_HitSphereModel::getKind()
{
	return kind;
}

void C_HitSphereModel::setIndex(int argIndex)
{
	index = argIndex;
}

int C_HitSphereModel::getIndex()
{
	return index;
}

void C_HitSphereModel::setLimit(int argLimit)
{
	limit = argLimit;
}

int C_HitSphereModel::getLimit()
{
	return limit;
}

void C_HitSphereModel::setLimit_flag(bool argFlag)
{
	limit_flag = argFlag;
}

bool C_HitSphereModel::getLimit_flag()
{
	return limit_flag;
}

void C_HitSphereModel::setExpTime(int argTime)
{
	expTime = argTime;
}

int C_HitSphereModel::getExpTime()
{
	return expTime;
}

void C_HitSphereModel::setTarget(int argTarget)
{
	target = argTarget;
}

int C_HitSphereModel::getTarget()
{
	return target;
}

void C_HitSphereModel::setRad(double argRad)
{
	create(3, argRad);
}

double C_HitSphereModel::getRad()
{
	return rad;
}

bool C_HitSphereModel::cntLimit()
{
	if(limit > 0)
	{
		--limit;
		if(limit == 0)
		{
			limit_flag = true;
			return true;
		}
	}

	return false;
}

bool C_HitSphereModel::cntExpTime()
{
	if(expTime > 0)
	{
		--expTime;
		if(expTime == 0)
		{
			return true;
		}
	}

	return false;
}

void C_HitSphereModel::move()
{
	loTranslate(spd);
}

// Փˏ(߂)s
void C_HitSphereModel::procHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	if(checkToSphere(*sphere, back))
	{
		// Y͍lȂ
		back.y = 0.0;
		sphere->glTranslate(-back);
	}
}

// Ă邩ǂ
bool C_HitSphereModel::isHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	return checkToSphere(*sphere, back);
}