#include "MapBase.h"

C_MapBase::C_MapBase()
{
	colors.insert( map<string, fk_Material>::value_type( "LightCyan", LightCyan ) );
	colors.insert( map<string, fk_Material>::value_type( "AshGray", AshGray ) );
	colors.insert( map<string, fk_Material>::value_type( "BurntTitan", BurntTitan ) );
	colors.insert( map<string, fk_Material>::value_type( "IridescentGreen", IridescentGreen ) );
	colors.insert( map<string, fk_Material>::value_type( "UltraMarine", UltraMarine ) );
	colors.insert( map<string, fk_Material>::value_type( "Ivory", Ivory ) );
	colors.insert( map<string, fk_Material>::value_type( "BambooGreen", BambooGreen ) );
	colors.insert( map<string, fk_Material>::value_type( "PearWhite", PearWhite ) );
	colors.insert( map<string, fk_Material>::value_type( "Lilac", Lilac ) );
	colors.insert( map<string, fk_Material>::value_type( "HolidaySkyBlue", HolidaySkyBlue ) );
	colors.insert( map<string, fk_Material>::value_type( "DimYellow", DimYellow ) );
	colors.insert( map<string, fk_Material>::value_type( "LavaRed", LavaRed ) );
	colors.insert( map<string, fk_Material>::value_type( "GrassGreen", GrassGreen ) );
	colors.insert( map<string, fk_Material>::value_type( "Red", Red ) );
	colors.insert( map<string, fk_Material>::value_type( "Pink", Pink ) );
	colors.insert( map<string, fk_Material>::value_type( "DarkRed", DarkRed ) );
	colors.insert( map<string, fk_Material>::value_type( "Orange", Orange ) );
	colors.insert( map<string, fk_Material>::value_type( "Flesh", Flesh ) );
	colors.insert( map<string, fk_Material>::value_type( "Brown", Brown ) );
	colors.insert( map<string, fk_Material>::value_type( "Yellow", Yellow ) );
	colors.insert( map<string, fk_Material>::value_type( "Cream", Cream ) );
	colors.insert( map<string, fk_Material>::value_type( "DarkYellow", DarkYellow ) );
	colors.insert( map<string, fk_Material>::value_type( "Green", Green ) );
	colors.insert( map<string, fk_Material>::value_type( "LightGreen", LightGreen ) );
	colors.insert( map<string, fk_Material>::value_type( "Cyan", Cyan ) );
	colors.insert( map<string, fk_Material>::value_type( "PaleBlue", PaleBlue ) );
	colors.insert( map<string, fk_Material>::value_type( "Blue", Blue ) );
	colors.insert( map<string, fk_Material>::value_type( "LightBlue", LightBlue ) );
	colors.insert( map<string, fk_Material>::value_type( "DarkGreen", DarkGreen ) );
	colors.insert( map<string, fk_Material>::value_type( "DarkBlue", DarkBlue ) );
	colors.insert( map<string, fk_Material>::value_type( "DarkPurple", DarkPurple ) );
	colors.insert( map<string, fk_Material>::value_type( "Violet", Violet ) );
	colors.insert( map<string, fk_Material>::value_type( "Purple", Purple ) );
	colors.insert( map<string, fk_Material>::value_type( "LightViolet", LightViolet ) );
	colors.insert( map<string, fk_Material>::value_type( "Coral", Coral ) );
	colors.insert( map<string, fk_Material>::value_type( "White", White ) );
	colors.insert( map<string, fk_Material>::value_type( "Gray1", Gray1 ) );
	colors.insert( map<string, fk_Material>::value_type( "Gray2", Gray2 ) );
	colors.insert( map<string, fk_Material>::value_type( "GlossBlack", GlossBlack ) );
	colors.insert( map<string, fk_Material>::value_type( "MatBlack", MatBlack ) );

	// ŏbootWallΓȂꏊɈړĂ
	for(int i = 0; i < 2; ++i)
	{
		bootWall[i].create(1.0, 1.0, 1.0);
		bootWall[i].glMoveTo(0.0, -500.0, 0.0);
	}
}

C_MapBase::~C_MapBase()
{	
	for(unsigned int i = 0; i < block.size(); ++i)	SAFE_DELETE(block.at(i));

	colors.clear();
	block.clear();
}

bool C_MapBase::load(const string &cfgFileName)
{
	ifstream		in_file(cfgFileName.c_str());
	string			lineStr;
	vector<string>	blockData;

	if(!in_file.is_open()) return false;

	block.clear();

	while(getline(in_file, lineStr))
	{
		// ","݂ȂA1s(ڍs)Ȃcontinue
		if(lineStr.find(",") == string::npos || lineStr.find("X") != string::npos)	continue;

		blockData.clear();		// ubNf[^YɂĂ
		blockData = SplitStr(lineStr, ",");		// ubÑf[^o

		// ڐĂȂcontinue
		if(blockData.size() < 10)	continue;

		// of[^ɊÂăubN쐬
		block.push_back(new fkut_BlockModel());
		block.back()->create(atof(blockData.at(0).c_str()), atof(blockData.at(1).c_str()), atof(blockData.at(2).c_str()));
		block.back()->glMoveTo(atof(blockData.at(3).c_str()), atof(blockData.at(4).c_str()), atof(blockData.at(5).c_str()));
		block.back()->glAngle(atof(blockData.at(6).c_str()), atof(blockData.at(7).c_str()), atof(blockData.at(8).c_str()));
		block.back()->setMaterial(colors[blockData.at(9)]);
	}

	return true;
}

void C_MapBase::createSectionWall(fk_Window *argWin, fkut_BlockModel *argCameraPoint)
{
	//// Jɉǂ̍쐬 ////
	Fl::check();
	fk_Plane plane;
	plane.setPosNormal(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 1.0, 0.0));

	//fk_Vector LTPos, LBPos, RTPos, RBPos;

	argWin->getProjectPosition(0.0, 0.0, &plane, &LTPos);
	argWin->getProjectPosition(0.0, 720.0, &plane, &LBPos);
	argWin->getProjectPosition(1280.0, 0.0, &plane, &RTPos);
	argWin->getProjectPosition(1280.0, 720.0, &plane, &RBPos);

	fk_Vector tempWallPos[2];
	tempWallPos[0] = LBPos + (LTPos - LBPos) / 2;	// 
	tempWallPos[1] = RBPos + (RTPos - RBPos) / 2;	// E

	sectionWallDist = (tempWallPos[1] - tempWallPos[0]).dist();

	block.push_back(new fkut_BlockModel());
	block.back()->create(30.0, 100.0, (LTPos - LBPos).dist() * 2.0);
	block.back()->glVec(LTPos - LBPos);
	block.back()->glMoveTo(tempWallPos[0].x, 50.0, tempWallPos[0].z);
	block.back()->setParent(*argCameraPoint);	// J̒_Ɛeq֌W
	leftWallIndex = block.size() - 1;			// ̕ǂblockz̉Ԗڂɂ邩ۑĂ

	bootWall[0].create(10.0, 100.0, (LTPos - LBPos).dist() * 2.0);
	bootWall[0].glVec(LTPos - LBPos);
	bootWall[0].glMoveTo(tempWallPos[0].x + 70.0, 50.0, tempWallPos[0].z);
	bootWall[0].setMaterial(Green);
	bootWall[0].setParent(*argCameraPoint);		// J̒_Ɛeq֌W

	block.push_back(new fkut_BlockModel());
	block.back()->create(30.0, 100.0, (RTPos - RBPos).dist() * 2.0);
	block.back()->glVec(RTPos - RBPos);
	block.back()->glMoveTo(tempWallPos[1].x, 50.0, tempWallPos[1].z);
	block.back()->setParent(*argCameraPoint);	// J̒_Ɛeq֌W
	rightWallIndex = block.size() - 1;			// E̕ǂblockz̉Ԗڂɂ邩ۑĂ

	bootWall[1].create(10.0, 100.0, (RTPos - RBPos).dist() * 2.0);
	bootWall[1].glVec(RTPos - RBPos);
	bootWall[1].glMoveTo(tempWallPos[1].x - 70.0, 50.0, tempWallPos[1].z);
	bootWall[1].setMaterial(Green);
	bootWall[1].setParent(*argCameraPoint);		// J̒_Ɛeq֌W
}

//void C_MapBase::adjustSectionWall(fk_Window *argWin)
//{
//	//Fl::check();
//	fk_Plane plane;
//	plane.setPosNormal(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 1.0, 0.0));
//
//	//LTPos.init(); LBPos.init(); RTPos.init(); RBPos.init();
//
//	argWin->getProjectPosition(0.0, 0.0, &plane, &LTPos);
//	argWin->getProjectPosition(0.0, 720.0, &plane, &LBPos);
//	argWin->getProjectPosition(1280.0, 0.0, &plane, &RTPos);
//	argWin->getProjectPosition(1280.0, 720.0, &plane, &RBPos);
//
//	//fk_Vector tempWallPos[2];
//	//tempWallPos[0] = LBPos + (LTPos - LBPos) / 2;	// 
//	//tempWallPos[1] = RBPos + (RTPos - RBPos) / 2;	// E
//
//	/*!!!!! z̓Y34Ƃ͌ȂꍇACKv !!!!!*/
//	//block.at(3)->glVec(LTPos - LBPos);
//	//block.at(3)->glMoveTo(tempWallPos[0].x, 50.0, tempWallPos[0].z);
//
//	//cout << LTPos.x << "," << LTPos.y << "," << LTPos.z << endl;
//	//cout << tempWallPos[0].x << "," << tempWallPos[0].z << endl;
//	//cout << LBPos.x << "," << LBPos.y << "," << LBPos.z << endl << endl;
//
//	//block.at(4)->glVec(RTPos - RBPos);
//	//block.at(4)->glMoveTo(tempWallPos[1].x, 50.0, tempWallPos[1].z);
//}

void C_MapBase::entryScene(fk_Scene *argScene)
{
	//argScene->entryModel(&floor);
	//for(int i = 0; i < 4; ++i)	argScene->entryModel(&wall[i]);
	
	for(unsigned int i = 0; i < block.size(); ++i)	
	{
		// \
		if(i == 0)	argScene->entryModel(block.at(i));
	}

	//for(int i = 0; i < 2; ++i)	argScene->entryModel(&bootWall[i]);

	argScene->entryModel(&model);
}

void C_MapBase::removeScene(fk_Scene *argScene)
{
	//argScene->removeModel(&floor);
	//for(int i = 0; i < 4; ++i)	argScene->removeModel(&wall[i]);

	for(unsigned int i = 0; i < block.size(); ++i)	argScene->removeModel(block.at(i));

	//for(int i = 0; i < 2; ++i)	argScene->removeModel(&bootWall[i]);

	argScene->removeModel(&model);
}

// Փˏ(߂)s(OBBp)
void C_MapBase::procHit(fkut_BlockModel *OBB, fk_Vector *spd)
{
	// spdO[oWnɍ킹
	fk_HVector	hSpd = *spd;
	hSpd.setw(0.0);
	*spd = OBB->getMatrix() * hSpd;

	fk_Vector back;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		back.init();
		if(block.at(i)->checkToMovingBlock(*OBB, *spd, back))
		{
			// Y͍lȂ
			back.y = 0.0;
			OBB->glTranslate(-back);
		}
	}
}

// [U[p
bool C_MapBase::procHit(fkut_BlockModel *OBB, fk_Vector *spd, fk_Vector *back)
{
	// spdO[oWnɍ킹
	//fk_HVector	hSpd = *spd;
	//hSpd.setw(0.0);
	//*spd = OBB->getMatrix() * hSpd;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		back->init();
		if(block.at(i)->checkToMovingBlock(*OBB, *spd, *back))	return true;
	}

	return false;
}

// Փˏ(߂)s(p)
void C_MapBase::procHit(fkut_SphereModel *sphere, fk_Vector *spd)
{
	// spdO[oWnɍ킹
	fk_HVector	hSpd = *spd;
	hSpd.setw(0.0);
	*spd = sphere->getMatrix() * hSpd;

	fk_Vector back;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		back.init();
		if(block.at(i)->checkToMovingSphere(*sphere, *spd, back))
		{
			// Y͍lȂ
			back.y = 0.0;
			sphere->glTranslate(-back);
		}
	}
}

// girlbNIĂ鎞̏Փˏ(߂)
void C_MapBase::procHit_forGirl(fkut_SphereModel *sphere, fk_Vector *spd)
{
	// spdO[oWnɍ킹鏈ȗ

	fk_Vector back;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		back.init();
		if(block.at(i)->checkToMovingSphere(*sphere, *spd, back))
		{
			// Y͍lȂ
			back.y = 0.0;
			sphere->glTranslate(-back);
		}
	}
}

// Ă邩ǂ(OBBp)
bool C_MapBase::isHit(fkut_BlockModel *OBB)
{
	fk_Vector back;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		if(block.at(i)->checkToBlock(*OBB, back))	return true;
	}

	return false;
}

// Ă邩ǂ(p)
bool C_MapBase::isHit(fkut_SphereModel *sphere)
{
	fk_Vector back;

	// ubNƂ̓蔻
	for(unsigned int i = 0; i < block.size(); ++i)
	{
		if(block.at(i)->checkToSphere(*sphere, back))	return true;
	}

	return false;
}

// Ă邩ǂ(p, Xs[ht)
bool C_MapBase::isHit(fkut_SphereModel *sphere, fk_Vector spd)
{
	fk_Vector back, tempSpd;
	tempSpd = spd * 2.0;	// spd葁߂ɐݒ

	// spdO[oWnɍ킹
	fk_HVector	hSpd = tempSpd;
	hSpd.setw(0.0);
	tempSpd = sphere->getMatrix() * hSpd;

	//cout << tempSpd.x << "," << tempSpd.y << "," << tempSpd.z << endl;

	for(unsigned int i = 0; i < block.size(); ++i)
	{
		if(block.at(i)->checkToMovingSphere(*sphere, tempSpd, back))	return true;
	}

	return false;
}

// E(is)̕ǂɓĂ邩ǂ(p)
bool C_MapBase::isHit_rightWall(fkut_SphereModel *sphere)
{
	fk_Vector back, tempSpd;
	//tempSpd = spd * 3.0;	// spd葁߂ɐݒ
	tempSpd.set(0.0, 0.0, -8.0);	// vC[SPEED葁ڂɐݒ

	// spdO[oWnɍ킹
	fk_HVector	hSpd = tempSpd;
	hSpd.setw(0.0);
	tempSpd = sphere->getMatrix() * hSpd;

	//cout << tempSpd.x << "," << tempSpd.y << "," << tempSpd.z << endl;

	// E̕ǂƂ̓蔻
	if(block.at(rightWallIndex)->checkToMovingSphere(*sphere, tempSpd, back))	return true;

	return false;
}

// AINp̕ǂɓĂ邩ǂ(p)
bool C_MapBase::isHit_bootWall(fkut_SphereModel *sphere)
{
	fk_Vector back;

	// bootWallƂ̓蔻
	for(int i = 0; i < 2; ++i)
	{
		if(bootWall[i].checkToSphere(*sphere, back))	return true;
	}

	return false;
}