#include "Boy.h"
#include "Girl.h"
#include "Punch01.h"

using namespace EnemyBase;
using namespace Punch01;

C_Punch01::C_Punch01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.0, 0.8, 0.4);
	body.getMaterial()->setShininess(100.0);
	
	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_PUNCH01].DX3_IFSTexture);	
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Punch01::~C_Punch01()
{
}

// ړ
void C_Punch01::move()
{
	spd.init();				//ړx0ɖ߂
	updateDistToPlayer();	//vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		// ߂̃vC[_
		lockTarget = lockNear();

		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// Ă
			if(distToBoy > ATTACK_DIST)		spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(PUNCH_TIME);
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// Ă
			if(distToGirl > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(PUNCH_TIME);
			}
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Punch01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// ߐڍU
		if(timer.at(ATTACK_TIMER).getTime() == PUNCH_TIME)
		{
			atkBlock.push_back(new C_HitBlockModel(30.0, 30.0, 80.0, PUNCH_POWER, PUNCH_LIMIT, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(GlossBlack);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(0.0, 0.0, -60.0);
			scene->entryModel(atkBlock.back());
		}
	}

	// punch̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}