#include "Boy.h"
#include "Girl.h"
#include "Rush01.h"

using namespace EnemyBase;
using namespace Rush01;

C_Rush01::C_Rush01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 25.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.0, 0.8, 0.4);
	body.getMaterial()->setShininess(100.0);
	
	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_RUSH01].DX3_IFSTexture);	
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Rush01::~C_Rush01()
{
}

// ړ
void C_Rush01::move()
{
	spd.init();				//ړx0ɖ߂
	updateDistToPlayer();	//vC[Ƃ̋XV

	// ːiO
	if(timer.at(ATTACK_TIMER).getTime() <= 0 && timer.at(THINK_TIMER).getTime() <= 0)
	{
		// UI܂Ń^[QbgύXȂ悤ɂ
		// vC[_őI
		if(lockTarget == NONE)	lockTarget = lockRandom();

		// ^[Qbg|ꂽ^[Qbg̕ύX\iːiO܂Łj
		if(lockTarget == BOY && boy->getDeath_flag())	lockTarget = GIRL;
		if(lockTarget == GIRL && girl->getDeath_flag())	lockTarget = BOY;

		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// ƏĂ΍U
			if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(RUSH_TIME);
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// ƏĂ΍U
			if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(RUSH_TIME);
			}
		}
	}

	// ːi
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(RUSH_TURN_SPEED);

			spd.z = -SPEED;	// ߂Â
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(RUSH_TURN_SPEED);

			spd.z = -SPEED;	// ߂Â
		}

		// }bv̓vC[ɓ܂œːi
		if(map->isHit(&body, spd) || boy->isHit(&body) || girl->isHit(&body))
		//if((atkBlock.size() > 0 && map->isHit(atkBlock.back())) || boy->isHit(&body) || girl->isHit(&body))
		{
			timer.at(ATTACK_TIMER).setTime(0);
			timer.at(THINK_TIMER).setTime(120);
			timer.at(KNOCK_BACK_TIMER).setTime(30);	// THINK_TIMER菭Ȃ
			lockTarget = NONE;
		}
	}

	// mbNobN
	if(timer.at(KNOCK_BACK_TIMER).getTime() > 10)
	{
		spd.z = timer.at(KNOCK_BACK_TIMER).getTime() * 0.2;
	}

	//cout << timer.at(ATTACK_TIMER).getTime() << endl;

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Rush01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// ːiuԁA蔻p̃ubNo
		if(timer.at(ATTACK_TIMER).getTime() == RUSH_TIME)
		{
			atkBlock.push_back(new C_HitBlockModel(50.0, 50.0, 50.0, RUSH_POWER, 1, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(GlossBlack);
			atkBlock.back()->getMaterial()->setAlpha(0.8);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(0.0, 0.0, -10.0);
			atkBlock.back()->setParent(body, true);
			scene->entryModel(atkBlock.back());
		}
	}

	// ubN̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}