#include "SceneBase.h"

C_SceneBase::C_SceneBase(fk_Window *argWin, C_EventManager *argEve)
: ref_window(argWin)
, ref_event(argEve)
, sceneNum(0)
, b_state(0)
{
	ref_window->setScene(&scene);
	scene.setBlendStatus(true);

	// 摜̓ǂݍ
	if(blackScreen.readPNG("Data/CG/black_screen.png") == false)	fl_alert("blackScreen File Read Error!");
	if(whiteScreen.readPNG("Data/CG/white_screen.png") == false)	fl_alert("whiteScreen File Read Error!");
}

C_SceneBase::~C_SceneBase(void)
{
	ref_window->setScene(NULL);
}

int C_SceneBase::getStageNum()
{
	return sceneNum;
}

// tF[hC
void C_SceneBase::fadeIn(bool isBlack, int time, bool b_fade, int b_num1, int b_num2, int b_num3)
{
	//scene.setBlendStatus(true);

	if(isBlack)	blackScreen.entryFirst(ref_window, &scene, &camera);
	else		whiteScreen.entryFirst(ref_window, &scene, &camera);

	double alpha = 1.0;

	if(b_fade)	sound.b_setAllVolume(0.0, true);

	while(alpha > 0.0)
	{
		alpha -= 1.0 / time;

		if(isBlack)	blackScreen.getMaterial()->setAlpha(alpha);
		else		whiteScreen.getMaterial()->setAlpha(alpha);

		ref_window->drawWindow();
		Fl::check();

		// TEh
		if(b_fade)	sound.b_setAllVolume(sound.b_getAllVolume(true) + sound.b_getAllVolume() / time, true);

		sound.b_play(b_num1);
		sound.b_play(b_num2);
		sound.b_play(b_num3);

		sound.se_play();
	}

	if(isBlack)	scene.removeOverlayModel(&blackScreen);
	else		scene.removeOverlayModel(&whiteScreen);

	//scene.setBlendStatus(false);
}

// tF[hAEg
void C_SceneBase::fadeOut(bool isBlack, int time, bool b_fade, int b_num1, int b_num2, int b_num3)
{
	//scene.setBlendStatus(true);

	if(isBlack)	blackScreen.entryFirst(ref_window, &scene, &camera);
	else		whiteScreen.entryFirst(ref_window, &scene, &camera);

	double alpha = 0.0;

	if(b_fade)	sound.b_setAllVolume(sound.b_getAllVolume(), true);

	while(alpha < 1.0)
	{
		alpha += 1.0 / time;

		if(isBlack)	blackScreen.getMaterial()->setAlpha(alpha);
		else		whiteScreen.getMaterial()->setAlpha(alpha);

		ref_window->drawWindow();
		Fl::check();

		// TEh
		if(b_fade)	sound.b_setAllVolume(sound.b_getAllVolume(true) - sound.b_getAllVolume() / time, true);
		
		sound.b_play(b_num1);
		sound.b_play(b_num2);
		sound.b_play(b_num3);

		sound.se_play();
	}

	if(isBlack)	scene.removeOverlayModel(&blackScreen);
	else		scene.removeOverlayModel(&whiteScreen);

	//scene.setBlendStatus(false);

	// SẼtOfalseɂĂ
	sound.se_flagInit();
}