#include "Boy.h"
#include "Girl.h"
#include "Shield01.h"

using namespace EnemyBase;
using namespace Shield01;

C_Shield01::C_Shield01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.8, 0.8, 0.0);
	body.getMaterial()->setShininess(100.0);

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_SHIELD01].DX3_IFSTexture);	
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(50.0);
	model.setParent(&body, true);

	// 
	shield.push_back(new fkut_BlockModel());
	shield.back()->create(70.0, 70.0, 40.0);
	shield.back()->glMoveTo(0.0, 40.0, -30.0);
	shield.back()->setMaterial(AshGray);
	//shield.back()->getMaterial()->setAlpha(0.8);
	shield.back()->setParent(body, true);
	scene->entryModel(shield.back());

	timer.resize(TIMER_MAX);
}

C_Shield01::~C_Shield01()
{
}

// ړ
void C_Shield01::move()
{
	spd.init();				//ړx0ɖ߂
	updateDistToPlayer();	//vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		// ŏ͂Ƃ肠߂̃vC[_
		if(lockTarget == NONE)	lockTarget = lockNear();

		// ^[Qbg_EĂAЕ_
		if(lockTarget == BOY && boy->getDeath_flag())	lockTarget = GIRL;
		if(lockTarget == GIRL && girl->getDeath_flag())	lockTarget = BOY;

		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// Ă
			if(distToBoy > ATTACK_DIST)
			{
				if(timer.at(SPEED_DOWN_TIMER).getTime() < 0)	spd.z = -SPEED;	// ߂Â
				// K[h
				else											spd.z = -SPEED_DOWN;	// x߂Â
			}
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(PUNCH_TIME);
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// Ă
			if(distToGirl > ATTACK_DIST)
			{
				if(timer.at(SPEED_DOWN_TIMER).getTime() < 0)	spd.z = -SPEED;	// ߂Â
				// K[h
				else											spd.z = -SPEED_DOWN;	// x߂Â
			}
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(PUNCH_TIME);
			}
		}
	}
	// U̍dȂĐs
	else if(timer.at(ATTACK_TIMER).getTime() <= PUNCH_TIME * 0.75)
	{
		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Shield01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// ߐڍU
		if(timer.at(ATTACK_TIMER).getTime() == PUNCH_TIME)
		{
			atkBlock.push_back(new C_HitBlockModel(30.0, 30.0, 80.0, PUNCH_POWER, PUNCH_LIMIT, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(GlossBlack);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(0.0, 0.0, -60.0);
			scene->entryModel(atkBlock.back());
		}
	}

	// punch̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}

// UꂽƂ̏
void C_Shield01::procDamage()
{
	// boỹp`
	if(boy->atkBlock.size() > 0 && boy->atkBlock.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkBlock.back()->getKind(), boy->atkBlock.back()->getIndex()))
	{
		// Ƃ̔
		double cos = fk_Math::calcCosine(body.getInhVec(), boy->atkBlock.back()->getInhVec());
		// ĝ̌ƃp`̗̌]l120ȉ珂ɂ͓ĂȂƂ݂Ȃ
		if(cos >= -0.5)
		{
			hp -= boy->atkBlock.back()->getPower();
			damage_flag = true;
		}
		// ŃK[hƂ݂Ȃ
		else
		{
			timer.at(SPEED_DOWN_TIMER).setTime(SPEED_DOWN_TIME);
		}

		// ^[QbgBOY
		if(timer.at(SHIELD_TIMER).getTime() <= 0)
		{
			lockTarget = BOY;
			timer.at(SHIELD_TIMER).setTime(30);
		}
	}

	// boỹEF[u
	if(boy->atkSphere.size() > 0 && boy->atkSphere.back()->isHit(&body) && checkAttackData(boy->getId(), boy->atkSphere.back()->getKind(), boy->atkSphere.back()->getIndex()))
	{
		fk_Vector posA, tempVec;

		// sƂ̌vZʂYɂ邽߂Y𓯂ɂĂ
		tempVec.set(boy->atkSphere.back()->getInhPosition().x, body.getInhPosition().y, boy->atkSphere.back()->getInhPosition().z);
		posA = body.getInvMatrix() * tempVec;		// 猩EF[u̍W𓾂
		//cout << posA.x << "," << posA.y << "," << posA.z << endl;

		if(posA.z > -body.getRad())
		{
			hp -= boy->atkSphere.back()->getPower();
			damage_flag = true;
		}
		// ŃK[hƂ݂Ȃ
		else
		{
			timer.at(SPEED_DOWN_TIMER).setTime(SPEED_DOWN_TIME);
		}

		// ^[QbgBOY
		if(timer.at(SHIELD_TIMER).getTime() <= 0)
		{
			lockTarget = BOY;
			timer.at(SHIELD_TIMER).setTime(30);
		}
	}

	// girl̃}VK̒eɓ
	for(unsigned int i = 0; i < girl->atkSphere.size(); ++i)
	{
		if(isHit(girl->atkSphere.at(i)))
		{
			// Ƃ̔
			double cos = fk_Math::calcCosine(body.getInhVec(), girl->atkSphere.at(i)->getInhVec());
			// ĝ̌ƒě̗]l120ȉ珂ɂ͓ĂȂƂ݂Ȃ
			if(cos >= -0.5)
			{
				hp -= girl->atkSphere.at(i)->getPower();
				damage_flag = true;
			}
			// ŃK[hƂ݂Ȃ
			else
			{
				timer.at(SPEED_DOWN_TIMER).setTime(SPEED_DOWN_TIME);
			}

			scene->removeModel(girl->atkSphere.at(i));
			SAFE_DELETE(girl->atkSphere.at(i));
			girl->itSphere = girl->atkSphere.begin();
			girl->itSphere += i;
			girl->itSphere = girl->atkSphere.erase(girl->itSphere);

			// ^[QbgGIRL
			if(timer.at(SHIELD_TIMER).getTime() <= 0)
			{
				lockTarget = GIRL;
				timer.at(SHIELD_TIMER).setTime(30);
			}
		}
	}

	// girl̃[U[ɓ
	if(girl->atkBlock.size() > 0 && girl->atkBlock.back()->isHit(&body)/* && checkAttackData(girl->getId(), GIRL_LASER, 0)*/)
	{
		//cout << "Laser HIT!" << endl;

		// Ƃ̔
		double cos = fk_Math::calcCosine(body.getInhVec(), girl->atkBlock.back()->getInhVec());
		// ĝ̌ƃ[U[̗̌]l120ȉ珂ɂ͓ĂȂƂ݂Ȃ
		if(cos >= -0.5)
		{
			hp -= girl->atkBlock.back()->getPower();
			damage_flag = true;
		}
		// ŃK[hƂ݂Ȃ
		else
		{
			timer.at(SPEED_DOWN_TIMER).setTime(SPEED_DOWN_TIME);
		}

		// ^[QbgGIRL
		if(timer.at(SHIELD_TIMER).getTime() <= 0)
		{
			lockTarget = GIRL;
			timer.at(SHIELD_TIMER).setTime(30);
		}
	}

	// hp0ȉȂ玀StO𗧂Ă
	if(hp <= 0)	death_flag = true;

	// damage_flagtrueAHPQ[W𒲐
	if(damage_flag)
	{
		damage_flag = false;
		green_bar.setSpriteSize(GAUGE_SIZE_X * hp * (1.0 / hp_max), GAUGE_SIZE_Y);	// cHP̊ɉĒς
	}

	red_bar.glMoveTo(pos.x, model.getScale() * 2.5, pos.z);
	green_bar.glMoveTo(pos.x - ((GAUGE_SIZE_X - green_bar.getSpriteSize().x) * 0.5), model.getScale() * 2.5, pos.z);
	red_bar.glVec(-camera->getPosition());
	green_bar.glVec(-camera->getPosition());
	red_bar.glTranslate((red_bar.getInhPosition() - camera->getInhPosition()) * 0.01);
}