/************************************************************************
@@Smoke.h

@@Smoke Effect

@@Date : Nov. 12, 2007
@@Version : 1.0
@@Author : Pocol
*************************************************************************/

#ifndef _SMOKE_H_INCLUDED_
#define _SMOKE_H_INCLUDED_

//
//@include
//
#include <iostream>
#include <cmath>
#include <GL/glew.h>
#include <GL/glut.h>
#include <FK/FK.h>	// FKCN[hGLwb_L
#include "DDSLoader.h"

using namespace std;

//
//@link
//
#pragma comment(lib, "glew32.lib")

/////////////////////////////////////////////////////////////////////////
//@@SmokeParticle class
/////////////////////////////////////////////////////////////////////////
class SmokeParticle
{
protected:
	double position[3];
	double velocity[3];
	double size;
	float color[3];
	float baseColor[3];

	int time;
	int endTime;

public:
	SmokeParticle(float base_color[3]);
	~SmokeParticle();
	void Initialize();
	void Move();
	void Render(double argAlpha);
};

/////////////////////////////////////////////////////////////////////////
//@@Smoke class
/////////////////////////////////////////////////////////////////////////
class Smoke
{
protected:
	SmokeParticle **smokeparticle;
	int smokeCount;
	DDSImage texture;

public:
	Smoke(int smoke_count, float smoke_color[3]);
	~Smoke();
	void LoadTexture(const char *filename);
	void Move();
	void Render(double argAlpha);
};

/////////////////////////////////////////////////////////////////////////
//@@SmokeModel class
/////////////////////////////////////////////////////////////////////////

class SmokeModel : public fk_Model {
private:
	fk_Point		dummyShape;
	Smoke			*smoke;
	double			alpha;
	int				timer, fadeInTime, nonFadeTime, fadeOutTime;

public:
	SmokeModel(int argFadeInTime, int argNonFadeTime, int argFadeOutTime);
	~SmokeModel();
	void init(void);

	bool isLimit();

	void preShader(void);
	void postShader(void);
};

#endif	//@_SMOKE_H_INCLUDED_