#include "Sound.h"
#include <FL/fl_ask.H>

C_Sound sound;

C_Sound::C_Sound()
: b_volume(1.0)
, b_tempVolume(1.0)
//, b_time(0.0)
, se_volume(1.0)
{
	printf("Sound Load Start...");		//fobOpATEh̓ǂݍ݂łĂ邩mFB

	// BGM
	if(!bgm[B_DEBUG].open("Data/Sound/BGM/debug.ogg"))			fl_alert("open(B_DEBUG) failed.");
	if(!bgm[B_STAGE].open("Data/Sound/BGM/stage.ogg"))			fl_alert("open(B_STAGE) failed.");
	if(!bgm[B_STAGE1_1].open("Data/Sound/BGM/stage1_1.ogg"))	fl_alert("open(B_STAGE1_1) failed.");
	if(!bgm[B_BOSS1].open("Data/Sound/BGM/boss1.ogg"))			fl_alert("open(B_BOSS1) failed.");
	if(!bgm[B_TITLE].open("Data/Sound/BGM/title.ogg"))			fl_alert("open(B_TITLE) failed.");

	for(int i = 0; i < BGM_MAX; ++i)	bgm[i].setLoopMode(true);

	// BGM̃[vw
	//bgm[b_title].setLoopArea(70.0, 75.0);	// 2@\ȂH
	bgm[B_STAGE1_1].setLoopArea(12.0, 61.0);
	bgm[B_BOSS1].setLoopArea(15.6526, 73.043);

	//b_setAllVolume(0.0);

	// SE
	if(!se[SE_ARROW_BLINK].open("Data/Sound/SE/arrowBlink.wav"))				fl_alert("open(SE_ARROW_BLINK) failed.");
	if(!se[SE_ASSASSIN_PUNCH].open("Data/Sound/SE/assassin_punch.wav"))			fl_alert("open(SE_ASSASSIN_PUNCH) failed.");
	if(!se[SE_AT_HEAL].open("Data/Sound/SE/at_heal.wav"))						fl_alert("open(SE_AT_HEAL) failed.");
	if(!se[SE_BOMB_EXPLOSION].open("Data/Sound/SE/bomb_explosion.wav"))			fl_alert("open(SE_BOMB_EXPLOSION) failed.");
	if(!se[SE_BOSS01_MACHINE_GUN].open("Data/Sound/SE/boss01_machine_gun.wav"))	fl_alert("open(SE_BOSS01_MACHINE_GUN) failed.");
	if(!se[SE_CHARGE_COMPLETE].open("Data/Sound/SE/chargeComplete.wav"))		fl_alert("open(SE_CHARGE_COMPLETE) failed.");
	if(!se[SE_CURSOR_MOVE].open("Data/Sound/SE/cursorMove.wav"))				fl_alert("open(SE_CURSOR_MOVE) failed.");
	if(!se[SE_DECISION].open("Data/Sound/SE/decision.wav"))						fl_alert("open(SE_DECISION) failed.");
	if(!se[SE_DESTRUCTION].open("Data/Sound/SE/destruction.wav"))				fl_alert("open(SE_DESTRUCTION) failed.");
	if(!se[SE_DOWN].open("Data/Sound/SE/down.wav"))								fl_alert("open(SE_DOWN) failed.");
	if(!se[SE_HEAL_COMPLETE].open("Data/Sound/SE/healComplete.wav"))			fl_alert("open(SE_HEAL_COMPLETE) failed.");
	if(!se[SE_LASER].open("Data/Sound/SE/laser.wav"))							fl_alert("open(SE_LASER) failed.");
	if(!se[SE_LOCKON].open("Data/Sound/SE/lockon.wav"))							fl_alert("open(SE_LOCKON) failed.");
	if(!se[SE_MACHINE_GUN].open("Data/Sound/SE/machine_gun.wav"))				fl_alert("open(SE_MACHINE_GUN) failed.");
	if(!se[SE_PAUSE_OFF].open("Data/Sound/SE/pauseOff.wav"))					fl_alert("open(SE_PAUSE_OFF) failed.");
	if(!se[SE_PAUSE_ON].open("Data/Sound/SE/pauseOn.wav"))						fl_alert("open(SE_PAUSE_ON) failed.");
	if(!se[SE_PUNCH_STRONG].open("Data/Sound/SE/punch_strong.wav"))				fl_alert("open(SE_PUNCH_STRONG) failed.");
	if(!se[SE_PUNCH_WEAK].open("Data/Sound/SE/punch_weak.wav"))					fl_alert("open(SE_PUNCH_WEAK) failed.");
	if(!se[SE_SECTION_MOVE].open("Data/Sound/SE/sectionMove.wav"))				fl_alert("open(SE_SECTION_MOVE) failed.");
	if(!se[SE_WAVE].open("Data/Sound/SE/wave.wav"))								fl_alert("open(SE_WAVE) failed.");

	se_flagInit();

	// [vSE͂Ŏw肵Ă
	se[SE_AT_HEAL].setLoopMode(true);
	se[SE_BOSS01_MACHINE_GUN].setLoopMode(true);

	printf("Complete!\n");

	//se_setAllVolume(0.0);
}

C_Sound::~C_Sound()
{
}

// BGM
void C_Sound::b_play(int b_num)
{
	if(0 <= b_num && b_num < BGM_MAX)	bgm[b_num].play();
}

//void C_Sound::b_rewind(int b_num)
//{
//	if(0 <= b_num && b_num < BGM_MAX)	bgm[b_num].seek(0.0);
//}

//double C_Sound::b_tell(int b_num)
//{
//	return	bgm[b_num].tell();
//}

void C_Sound::b_seek(int b_num, double argTime)
{
	if(0 <= b_num && b_num < BGM_MAX)	bgm[b_num].seek(argTime);
}

void C_Sound::b_stopAll(bool isRewind)
{
	for(int i = 0; i < BGM_MAX; ++i)
	{
		bgm[i].pause();
		if(isRewind)	bgm[i].seek(0.0);
	}
}

void C_Sound::b_stop(int b_num, bool isRewind)
{
	if(0 <= b_num && b_num < BGM_MAX)
	{
		bgm[b_num].pause();
		if(isRewind)	bgm[b_num].seek(0.0);
	}
}

//void C_Sound::b_setTime(double argTime)
//{
//	b_time = argTime;
//}
//
//double C_Sound::b_getTime()
//{
//	return b_time;
//}

void C_Sound::b_setAllVolume(double argVolume, bool isTemp)
{	
	if(isTemp)	b_tempVolume = argVolume;
	else		b_volume = argVolume;

	for(int i = 0; i < BGM_MAX; ++i)	bgm[i].setGain(argVolume);
}

void C_Sound::b_setVolume(int b_num, double argVolume)
{
	if(0 <= b_num && b_num < BGM_MAX)	bgm[b_num].setGain(argVolume);
}

double C_Sound::b_getAllVolume(bool isTemp)
{
	if(isTemp)	return b_tempVolume;
	else		return b_volume;
}

double C_Sound::b_getVolume(int b_num)
{
	if(0 <= b_num && b_num < BGM_MAX)	return bgm[b_num].getGain();
	else								return 0.0;
}

void C_Sound::b_fadeIn(int b_num, int argTime)
{
	if(0 <= b_num && b_num < BGM_MAX)
	{
		bgm[b_num].setGain(bgm[b_num].getGain() + b_volume / argTime);
		if(bgm[b_num].getGain() >= b_volume)	bgm[b_num].setGain(b_volume);
	}
}

void C_Sound::b_fadeOut(int b_num, int argTime)
{
	if(0 <= b_num && b_num < BGM_MAX)
	{
		bgm[b_num].setGain(bgm[b_num].getGain() - b_volume / argTime);
		if(bgm[b_num].getGain() <= 0.0)			bgm[b_num].setGain(0.0);
	}
}

// SE
void C_Sound::se_on(int se_num)
{
	if(0 <= se_num && se_num < SE_MAX)
	{
		if(se_called[se_num] == false)
		{
			se_flag[se_num] = true;
			se_called[se_num] = true;
			if(!se[se_num].getLoopMode())	se[se_num].seek(0.0);
		}
	}
}

void C_Sound::se_play()
{
	for(int i = 0; i < SE_MAX; ++i)
	{
		if(se_flag[i])	se_flag[i] = se[i].play();
		se_called[i] = false;
	}
}

void C_Sound::se_stop(int se_num)
{
	if(0 <= se_num && se_num < SE_MAX)
	{
		//se[se_num].pause();
		//se[se_num].seek(0.0);
		se[se_num].end();	// calledƂ炸se_on̍ŏɂĂłŗǂ
		se_flag[se_num] = false;
		se_called[se_num] = false;
	}
}

bool C_Sound::se_getFlag(int se_num)
{
	if(0 <= se_num && se_num < SE_MAX)
	{
		return se_flag[se_num];
	}

	return false;
}

void C_Sound::se_setAllVolume(double argVolume)
{
	se_volume = argVolume;

	for(int i = 0; i < SE_MAX; ++i)	se[i].setGain(argVolume);
}

double C_Sound::se_getAllVolume()
{
	return se_volume;
}

void C_Sound::se_flagInit()
{
	for(int i = 0; i < SE_MAX; ++i)
	{
		se_flag[i] = false;
		se_called[i] = false;
	}
}