#pragma once
#include "FKUT/Audio.h"

enum BGM
{
	B_DEBUG,
	B_STAGE,
	B_STAGE1_1,
	B_BOSS1,
	B_TITLE,
	BGM_MAX
};

enum SE
{
	SE_ARROW_BLINK,
	SE_ASSASSIN_PUNCH,
	SE_AT_HEAL,
	SE_BOMB_EXPLOSION,
	SE_BOSS01_MACHINE_GUN,
	SE_CHARGE_COMPLETE,
	SE_CURSOR_MOVE,
	SE_DECISION,
	SE_DESTRUCTION,
	SE_DOWN,
	SE_HEAL_COMPLETE,
	SE_LASER,
	SE_LOCKON,
	SE_MACHINE_GUN,
	SE_PAUSE_OFF,
	SE_PAUSE_ON,
	SE_PUNCH_STRONG,
	SE_PUNCH_WEAK,
	SE_SECTION_MOVE,
	SE_WAVE,
	SE_MAX
};

class C_Sound
{
private:
	// BGM
	fk_AudioStream	bgm[BGM_MAX];
	double			b_volume;				// [U[ݒ肷鉹
	double			b_tempVolume;			// V[Jڎ̃tF[hCEAEgɎgꎞIȉ
	//double			b_time;				// V[JڎȂǂBGM̍ĐʒuۑĂ߂̕ϐ

	// SE
	fk_AudioWavBuffer	se[SE_MAX];
	double				se_volume;			// [U[ݒ肷鉹
	bool				se_flag[SE_MAX];	// 炷trueɂ
	bool				se_called[SE_MAX];	// ̃t[Ŋse_on()ŌĂ΂ꂽǂ

public:
	C_Sound();
	~C_Sound();

	// BGM
	void	b_play(int b_num);
	//void	b_rewind(int);		// BGMŏɊ߂
	//double	b_tell(int);	// BGM̍Đʒu擾
	void	b_seek(int b_num, double argTime);				// BGMCӂ̎ԂɈړ

	void	b_stopAll(bool isRewind = true);				// SĂBGM~߂(2͊߂ǂ)
	void	b_stop(int b_num, bool isRewind = true);		// CӂBGMXgbv

	//void	b_setTime(double);	// V[ύXȂǂBGM̍ĐʒuۑĂ߂̊֐
	//double	b_getTime();

	void	b_setAllVolume(double argVolume, bool isTemp = false);	// SĂBGM̉ʂݒ(2͈ꎞIȉʂǂ)
	void	b_setVolume(int b_num, double argVolume);				// 1Ȃʂςꍇ͂̊֐
	double	b_getAllVolume(bool isTemp = false);					// Ŝ̉(b_volume܂b_tempVolume)擾
	double	b_getVolume(int b_num);									// w肵BGM̉ʂ擾

	// BGM̃tF[hCEAEg(1BGM̔ԍA2̓tF[h̎)
	void	b_fadeIn(int b_num, int argTime);
	void	b_fadeOut(int b_num, int argTime);

	// SE
	void	se_on(int se_num);		// se_flagtrueɂčŏɊ߂
	void	se_play();
	void	se_stop(int se_num);	// CӂSEXgbv
	bool	se_getFlag(int se_num);	// CӂSẼtO擾

	void	se_setAllVolume(double argVolume);
	double	se_getAllVolume();

	void	se_flagInit();		// se_flagSfalseɂ
};

extern C_Sound sound;