#include "StageBase.h"

using namespace StageBase;

C_StageBase::C_StageBase(fk_Window *argWin, C_EventManager *argEve)
: C_SceneBase(argWin, argEve)
, boy(&scene, &camera, &map, &girl, &enemyArray)
, girl(&scene, &camera, &map, &boy, &enemyArray)
, zoomOutDist(0.0)
, sectionMove_flag(false)
, sectionNum(0)
, finalSectionNum(0)
, stageClear_flag(false)
, pause_flag(false)
, pause_cursorPos(0)
, totalEnemyNum(0)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.getMaterial()->setSpecular(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 1000.0, 0.0);
	lightModel.glFocus(0.0, -1.0, 0.0);

	// JfBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);

	// J̐ݒ
	camera.glMoveTo(0.0, 580.0, 635.0);	// J̈ʒuςēG̑傫ςȂAbootWall߂Kv
	camera.glAngle(0.0, -0.65, 0.0);
	primalCameraPos = camera.getPosition();
	//camera.glFocus(0.0, 0.0, 0.0);

	// J_̐ݒ
	cameraPoint.create(0.01, 0.01, 0.01);
	camera.setParent(&cameraPoint, true);	// J_Ɛeq֌W

	// ^C}[̗vf肷
	timer.resize(TIMER_MAX);

	///// |[Y̕ /////
	// J[\
	pause_cursor.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	pause_cursor.text.setPTSize(32);
	pause_cursor.drawText("");

	for(int i = 0; i < Pause::STR_MAX; ++i)
	{
		pause_str[i].initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
		pause_str[i].text.setPTSize(32);
	}
	pause_str[0].drawText("Q[ɖ߂");
	pause_str[1].drawText("^Cgɖ߂");
	for(int i = 0; i < Pause::STR_MAX; ++i)
	{
		pause_str[i].glMoveTo(0.0, 50.0 - i * 50.0, 0.0);
		//pause_str[i].entryFirst(ref_window, &scene, &camera);
	}

	// 
	// 摜̓ǂݍ
	if(arrow.readPNG("Data/CG/arrow.png") == false)	fl_alert("arrow File Read Error!");
	arrow.setPositionRT(590.0, 310.0);
}

C_StageBase::~C_StageBase(void)
{
	// G̃f[g
	for(unsigned int i = 0; i < enemyArray.size(); ++i)
	{
		scene.removeModel(enemyArray.at(i)->getModel());
		SAFE_DELETE(enemyArray.at(i));
	}

	limitEnemyNum.clear();
	enemyEmergeData.clear();
	enemyArray.clear();
	maxSectionEnemyNum.clear();
	timer.clear();

	// GtFNg̃f[g
	for(unsigned int i = 0; i < smokeModel.size(); ++i)
	{
		scene.removeModel(smokeModel.at(i));
		SAFE_DELETE(smokeModel.at(i));
	}
	for(unsigned int i = 0; i < fireModel.size(); ++i)
	{
		scene.removeModel(fireModel.at(i));
		SAFE_DELETE(fireModel.at(i));
	}
	smokeModel.clear();
	fireModel.clear();
}

// Gf[^̓ǂݍ
bool C_StageBase::loadEnemyData(const string &cfgFileName)
{
	ifstream		in_file(cfgFileName.c_str());
	string			lineStr;
	vector<string>	tempData;
	int				tempNum = 0;	// ̋ԔԍƓǂ𔻕ʂ
	int				tempMaxSectionEnemyNum = 0;

	if(!in_file.is_open()) return false;

	enemyEmergeData.clear();

	while(getline(in_file, lineStr))
	{
		// ","݂ȂA1s(ڍs)Ȃcontinue
		if(lineStr.find(",") == string::npos || lineStr.find("") != string::npos)	continue;

		tempData.clear();						// f[^YɂĂ
		tempData = SplitStr(lineStr, ",");		// f[^o

		// ڐĂȂcontinue
		if(tempData.size() < 4)	continue;

		// of[^i[Ă
		enemyEmergeData.push_back(EnemyEmergeData());
		enemyEmergeData.back().section = atoi(tempData.at(0).c_str());
		enemyEmergeData.back().kind = atoi(tempData.at(1).c_str());
		enemyEmergeData.back().direction = atoi(tempData.at(2).c_str());
		enemyEmergeData.back().posZ = atof(tempData.at(3).c_str());

		// ԂƂ̓G̍ő吔i[Ă
		if(tempData.size() >= 5 && atoi(tempData.at(4).c_str()) > 0)
		{
			limitEnemyNum.push_back(atoi(tempData.at(4).c_str()));
		}

		// O̓GƋԂȂ
		if(tempNum == atoi(tempData.at(0).c_str()))	++tempMaxSectionEnemyNum;	// ̋Ԃł̓G̍ő吔𑝂₷
		// ԂႤGȂ
		else
		{
			maxSectionEnemyNum.push_back(tempMaxSectionEnemyNum);	// 1ŐԂ̓G̍ő吔ۑ
			tempNum = atoi(tempData.at(0).c_str());					// ԊmFpϐύX
			tempMaxSectionEnemyNum = 1;								// 1̂
		}
	}

	// Ō̋Ԃ̓G̍ő吔ۑ
	maxSectionEnemyNum.push_back(tempMaxSectionEnemyNum);

	// Ō̓G̋ԔԍőԐɂȂ
	finalSectionNum = atoi(tempData.at(0).c_str());

	//for(unsigned int i = 0; i < enemyEmergeData.size(); ++i)
	//{
	//	cout << ": " << enemyEmergeData.at(i).section << ", G̎: " << enemyEmergeData.at(i).kind << ", E: " << enemyEmergeData.at(i).direction << ", posZ: " << enemyEmergeData.at(i).posZ << endl;
	//}

	//for(unsigned int i = 0; i < maxSectionEnemyNum.size(); ++i)
	//{
	//	cout << i << "Ԃ̓G̍ő吔: " << maxSectionEnemyNum.at(i) << endl;
	//}

	//cout << "Ō̋: " << finalSectionNum << endl;

	//for(unsigned int i = 0; i < limitEnemyNum.size(); ++i)
	//{
	//	cout << i << "Ԃ̓G̏: " << limitEnemyNum.at(i) << endl;
	//}

	return true;
}

// G̏o
void C_StageBase::emergeEnemy()
{
	// ݂G̐limitEnemyNumĂG𑝂₷
	if(limitEnemyNum.size() > 0 && enemyArray.size() < limitEnemyNum.front() && timer.at(EMERGE_TIMER).getTime() <= 0)
	{
		// G̋ԂƁAԂʒuĂāAȂԈړłȂ
		if(enemyEmergeData.size() > 0 && enemyEmergeData.front().section == sectionNum && sectionMove_flag == false)
		{
			switch(enemyEmergeData.front().kind)
			{
			case 0:
				enemyArray.push_back(new C_Assassin01(&scene, &camera, &map, &boy, &girl));
				break;
			case 1:
				enemyArray.push_back(new C_Bomb01(&scene, &camera, &map, &boy, &girl));
				break;
			case 2:
				enemyArray.push_back(new C_Punch01(&scene, &camera, &map, &boy, &girl));
				break;
			case 3:
				enemyArray.push_back(new C_AssaultRifle01(&scene, &camera, &map, &boy, &girl));
				break;
			case 4:
				enemyArray.push_back(new C_Sword01(&scene, &camera, &map, &boy, &girl));
				break;
			case 5:
				enemyArray.push_back(new C_Hammer01(&scene, &camera, &map, &boy, &girl));
				break;
			case 6:
				enemyArray.push_back(new C_Rush01(&scene, &camera, &map, &boy, &girl));
				break;
			case 7:
				enemyArray.push_back(new C_Bazooka01(&scene, &camera, &map, &boy, &girl));
				break;
			case 8:
				enemyArray.push_back(new C_Shield01(&scene, &camera, &map, &boy, &girl));
				break;
			default:
				break;
			}

			//enemyArray.at(enemyArray.size() - 1)->entryScene(&scene);

			// oW
			enemyArray.back()->getBody()->glTranslate(cameraPoint.getInhPosition().x - 1000.0 + enemyEmergeData.front().direction * 2000.0,
				0.0, enemyEmergeData.front().posZ);

			// HPQ[W
			enemyArray.back()->red_bar.glMoveTo(enemyArray.back()->getBody()->getInhPosition());
			scene.entryModel(&enemyArray.back()->red_bar);
			enemyArray.back()->green_bar.glMoveTo(enemyArray.back()->getBody()->getInhPosition());
			scene.entryModel(&enemyArray.back()->green_bar);
			//enemyArray.back()->red_bar.glTranslate(0.0, 50.0, 0.0);

			// GIDZbg
			enemyArray.back()->setId(totalEnemyNum);

			// GƂgirllock_flagtrueAlockOrder̈ԌID
			if(girl.getLock_flag())		girl.lockOrder.push_back(totalEnemyNum);

			++totalEnemyNum;	// G̗݌v̂ŃCNg

			enemyEmergeData.pop_front();	// KvłȂȂG̏of[^̐擪
			enemyArray.back()->entryScene(&scene);

			// ̓G̏o܂ŏԊu
			timer.at(EMERGE_TIMER).setTime(10);
		}
	}
}

// _[W
void C_StageBase::procDamage()
{
	// boy
	boy.procDamage();

	// girl
	girl.procDamage();

	// enemy
	for(unsigned int i = 0; i < enemyArray.size(); ++i)	enemyArray.at(i)->procDamage();
}

// G̏ŏ
void C_StageBase::vanishEnemy()
{
	for(int i = enemyArray.size() - 1; i >= 0; --i)
	{
		// StOĂ
		if(enemyArray.at(i)->getDeath_flag())
		{
			if(girl.getLock_flag())		// bNԂ
			{
				// bNĂGȂ
				if(girl.getLockEnemyId() == enemyArray.at(i)->getId())	girl.setLockOrder_flag(true);
				// bNĂGȊOȂ
				else													girl.setLockOrderAdjust_flag(true);
			}

			// GtFNgo
			smokeModel.push_back(new SmokeModel(60, 60, 30));
			smokeModel.back()->init();
			smokeModel.back()->glMoveTo(enemyArray.at(i)->getPos());
			//smokeModel.back()->loTranslate(0.0, 30.0, 0.0);
			smokeModel.back()->setScale(double(enemyArray.at(i)->getBody()->getRad()));
			scene.entryModel(smokeModel.back());

			fireModel.push_back(new FireModel(60, 60, 30));
			fireModel.back()->init();
			fireModel.back()->glMoveTo(enemyArray.at(i)->getPos());
			//fireModel.back()->loTranslate(0.0, 30.0, 0.0);
			fireModel.back()->setScale(double(enemyArray.at(i)->getBody()->getRad()));
			scene.entryModel(fireModel.back());

			// Gʂ
			enemyArray.at(i)->removeScene(&scene);
			SAFE_DELETE(enemyArray.at(i));
			itEnemyArray = enemyArray.begin();
			itEnemyArray += i;
			itEnemyArray = enemyArray.erase(itEnemyArray);

			// Ԃ̓G̐炷
			if(maxSectionEnemyNum.size() > 0)	--maxSectionEnemyNum.front();

			// SE
			sound.se_on(SE_DESTRUCTION);
		}
	}
}

// Ԃ̈ړ
void C_StageBase::procSectionMove()
{
	// GȂȂu
	if(maxSectionEnemyNum.front() <= 0 && timer.at(ARROW_TIMER).getTime() == -1)
	{
		timer.at(ARROW_TIMER).setTime(60);
	}

	// o
	if(timer.at(ARROW_TIMER).getTime() == 30)
	{
		arrow.entryFirst(ref_window, &scene, &camera);

		// SE
		sound.se_on(SE_ARROW_BLINK);
	}
	else if(timer.at(ARROW_TIMER).getTime() == 0)
	{
		scene.removeOverlayModel(&arrow);
		timer.at(ARROW_TIMER).setTime(60);
	}

	//cout << map.isHit_rightWall(boy.getBody()) << endl;

	//fk_Vector	tempSpd(0.0, 0.0, -5.0);

	// GȂԂŉE̕ǂɓƈړ
	if(maxSectionEnemyNum.front() <= 0 && sectionMove_flag == false && (map.isHit_rightWall(boy.getBody()) || map.isHit_rightWall(girl.getBody())))
	{
		if(sectionNum == finalSectionNum)
		{
			stageClear_flag = true;
		}
		else
		{
			sectionMove_flag = true;
			++sectionNum;

			// ŐԂlimitEnemyNumj
			limitEnemyNum.pop_front();

			// SE
			sound.se_on(SE_SECTION_MOVE);
		}
	}

	if(sectionMove_flag)
	{
		// ̕ǂZƕsɂȂ܂ŉ]
		if(map.block.at(map.leftWallIndex)->getInhVec().x < 0)
		{
			map.block.at(map.leftWallIndex)->glRotateWithVec(map.LBPos, fk_Y, -FK_PI * 0.005);
			if(map.block.at(map.leftWallIndex)->getInhVec().x >= 0)
			{
				map.block.at(map.leftWallIndex)->glVec(0.0, 0.0, -1.0);
			}
		}

		// ̕ǂZƕsɂȂĂ
		if(map.block.at(map.leftWallIndex)->getInhVec().x == 0.0 && map.block.at(map.leftWallIndex)->getInhVec().y == 0.0 && map.block.at(map.leftWallIndex)->getInhVec().z == -1.0)
		{
			// ̈ʒu܂ňړ
			if(cameraPoint.getPosition().x < sectionNum * 800.0)	cameraPoint.loTranslate(8.0);
			// ̈ʒuɗ
			else
			{
				// ǂɖ߂
				map.block.at(map.leftWallIndex)->glVec(map.LTPos - map.LBPos);
				map.block.at(map.leftWallIndex)->glMoveTo(map.block.at(map.rightWallIndex)->getPosition().x - map.sectionWallDist, 50.0, map.block.at(map.rightWallIndex)->getPosition().z);

				sectionMove_flag = false;

				maxSectionEnemyNum.pop_front();	// ŐԂmaxSectionEnemyNum̏

				// 
				timer.at(ARROW_TIMER).setTime(-1);
				scene.removeOverlayModel(&arrow);
			}
		}
	}
}

// GtFNg̏
void C_StageBase::procEffect()
{
	for(unsigned int i = 0; i < smokeModel.size(); ++i)
	{
		smokeModel.at(i)->glFocus(camera.getInhPosition());

		//cout << smokeModel.at(i)->getVec().x << "," << smokeModel.at(i)->getVec().y << "," << smokeModel.at(i)->getVec().z << endl;

		if(i == 0 && smokeModel.front()->isLimit())
		{
			scene.removeModel(smokeModel.front());
			SAFE_DELETE(smokeModel.front());
			smokeModel.pop_front();
		}
	}

	for(unsigned int i = 0; i < fireModel.size(); ++i)
	{
		fireModel.at(i)->glFocus(camera.getInhPosition());

		if(i == 0 && fireModel.front()->isLimit())
		{
			scene.removeModel(fireModel.front());
			SAFE_DELETE(fireModel.front());
			fireModel.pop_front();
		}
	}
}

// J̈ړ
void C_StageBase::cameraMove()
{
	// J̒_ړ
	if(boy.getPos().z + girl.getPos().z <= 50)
	{
		cameraPoint.glMoveTo(cameraPoint.getPosition().x, cameraPoint.getPosition().y, (boy.getPos().z + girl.getPos().z) / 2.0);
	}
}

// ^C}[JEg
void C_StageBase::countTimer()
{
	// Xe[W̃^C}[
	for(unsigned int i = 0; i < timer.size(); ++i)		timer.at(i).countTime();

	// boy
	for(unsigned int i = 0; i < boy.timer.size(); ++i)	boy.timer.at(i).countTime();

	// girl
	for(unsigned int i = 0; i < girl.timer.size(); ++i)	girl.timer.at(i).countTime();

	// enemy
	for(unsigned int i = 0; i < enemyArray.size(); ++i)
	{
		for(unsigned int j = 0; j < enemyArray.at(i)->timer.size(); ++j)	enemyArray.at(i)->timer.at(j).countTime();
	}
}

// |[YʂĂ
void C_StageBase::callPause()
{
	if(controller[0].KeyDown(X_GAMEPAD_START))
	{
		pause_flag = true;
		blackScreen.entryFirst(ref_window, &scene, &camera);
		blackScreen.getMaterial()->setAlpha(0.6);

		pause_cursorPos = 0;
		pause_cursor.glMoveTo(-150.0, 50.0 - pause_cursorPos * 50.0, 0.0);
		pause_cursor.entryFirst(ref_window, &scene, &camera);
		for(int i = 0; i < Pause::STR_MAX; ++i)
		{
			pause_str[i].entryFirst(ref_window, &scene, &camera);
		}

		// SE
		sound.se_on(SE_PAUSE_ON);
	}
}

// |[Y̏
int C_StageBase::procPause()
{
	if(controller[0].KeyDown(X_GAMEPAD_LS_DOWN) || controller[0].KeyDown(X_GAMEPAD_DOWN))
	{
		if(pause_cursorPos == Pause::STR_MAX - 1)	pause_cursorPos = 0;
		else											pause_cursorPos++;

		pause_cursor.glMoveTo(-150.0, 50.0 - pause_cursorPos * 50.0, 0.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if(controller[0].KeyDown(X_GAMEPAD_LS_UP) || controller[0].KeyDown(X_GAMEPAD_UP))
	{
		if(pause_cursorPos == 0)	pause_cursorPos = Pause::STR_MAX - 1;
		else						pause_cursorPos--;

		pause_cursor.glMoveTo(-150.0, 50.0 - pause_cursorPos * 50.0, 0.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if(controller[0].KeyDown(X_GAMEPAD_A) || controller[0].KeyDown(X_GAMEPAD_START))
	{
		// SE
		sound.se_on(SE_PAUSE_OFF);

		// ^Cgɖ߂
		if(controller[0].KeyDown(X_GAMEPAD_A) && pause_cursorPos == Pause::RETURN_TITLE)
		{
			return TITLE;
		}

		// 
		pause_flag = false;
		scene.removeOverlayModel(&blackScreen);
		scene.removeOverlayModel(&pause_cursor);
		for(int i = 0; i < Pause::STR_MAX; ++i)
		{
			scene.removeOverlayModel(&pause_str[i]);
		}
	}

	return 0;
}

// Xe[Wʂ̏
int C_StageBase::procCommon()
{
	// |[Ył
	if(pause_flag)
	{
		return procPause();
	}
	// |[YłȂ
	else
	{
		// G̏o
		emergeEnemy();

		// GAI
		for(unsigned int i = 0; i < enemyArray.size(); ++i)
		{
			//cout << enemyArray.at(i)->getIsBoot() << endl;

			// AINĂ
			if(enemyArray.at(i)->getIsBoot())
			{
				enemyArray.at(i)->move();	// G̈ړ
				enemyArray.at(i)->attack();	// G̍U
			}
			// AI܂NĂȂ
			else
			{
				// Gɂ
				if(enemyArray.at(i)->getBody()->getInhPosition().x < cameraPoint.getInhPosition().x)
				{
					enemyArray.at(i)->getBody()->glVec(1.0, 0.0, 0.0);
				}
				// GEɂ
				else
				{
					enemyArray.at(i)->getBody()->glVec(-1.0, 0.0, 0.0);
				}

				fk_Vector	tempSpd(0.0, 0.0, -3.0);
				enemyArray.at(i)->getBody()->loTranslate(tempSpd);

				enemyArray.at(i)->setPos(enemyArray.at(i)->getBody()->getInhPosition());	// ʒuۑ

				// AINp̕ǂɓAIN
				if(map.isHit_bootWall(enemyArray.at(i)->getBody()))	enemyArray.at(i)->setIsBoot(true);
			}

			// HPQ[WJɌ
			//gaugeFocus(&camera);

			// Gm̓蔻
			for(unsigned int j = 0; j < enemyArray.size(); ++j)
			{
				// ȊOłǂ炩isCollisiontrueȂ
				if(j != i && (enemyArray.at(i)->getIsCollision() || enemyArray.at(j)->getIsCollision()))
				{
					enemyArray.at(i)->procHit(enemyArray.at(j)->getBody());
				}
			}
		}

		// vC[̈ړ(Gɉ邱Ƃ邩AG̈ړɈړǂH)
		boy.move();
		girl.move();

		// bNIiȖOɏƂȂƃz[~Oŗj
		girl.lockon();

		// U
		boy.attack();
		girl.attack();

		// 
		boy.heal();
		girl.heal();

		// _[W
		procDamage();

		// G̏ŏ
		vanishEnemy();

		// GtFNg̏
		procEffect();

		// J̈ړ
		cameraMove();

		// |[Y
		callPause();

		// ̃V[
		if(stageClear_flag)	return sceneNum + 1;

		// Q[I[o[ւ̈ڍs
		if(boy.getDeath_flag() && girl.getDeath_flag() && timer.at(GAME_OVER_TIMER).getTime() == -1)
		{
			timer.at(GAME_OVER_TIMER).setTime(120);
		}
		if(timer.at(GAME_OVER_TIMER).getTime() == 0)	return GAME_OVER;

		// ^C}[JEg
		countTimer();
	}

	// fobOʂ
	if(controller[0].KeyDown(X_GAMEPAD_BACK) || ref_event->getSpecialKeyStatus(FK_F9) == FKUT_SW_DOWN)
	{
		sound.se_on(SE_DECISION);
		return DEBUG_MODE;
	}

	if(controller[0].KeyPress(X_GAMEPAD_LPUSH) && controller[0].KeyPress(X_GAMEPAD_RPUSH))
	{
		for(unsigned int i = 0; i < enemyArray.size(); ++i)
		{
			enemyArray.at(i)->setHp(0);
		}
	}

	//if(controller[0].KeyDown(X_GAMEPAD_Y))							camera.deleteParent(true);
	if(ref_event->getSpecialKeyStatus(FK_UP) == FKUT_SW_PRESS)		camera.glTranslate(0.0, 1.0, 0.0);
	if(ref_event->getSpecialKeyStatus(FK_DOWN) == FKUT_SW_PRESS)	camera.glTranslate(0.0, -1.0, 0.0);
	if(ref_event->getKeyStatus('w') == FKUT_SW_PRESS)				camera.glTranslate(0.0, 0.0, -1.0);
	if(ref_event->getKeyStatus('s') == FKUT_SW_PRESS)				camera.glTranslate(0.0, 0.0, 1.0);
	if(ref_event->getKeyStatus('a') == FKUT_SW_PRESS)				camera.glTranslate(-1.0, 0.0, 0.0);
	if(ref_event->getKeyStatus('d') == FKUT_SW_PRESS)				camera.glTranslate(1.0, 0.0, 0.0);
	if(ref_event->getKeyStatus('i') == FKUT_SW_PRESS)				camera.loAngle(0.0, 0.01, 0.0);
	if(ref_event->getKeyStatus('k') == FKUT_SW_PRESS)				camera.loAngle(0.0, -0.01, 0.0);

	/*
	cout << "pos: " << camera.getInhPosition().x << "," << camera.getInhPosition().y << "," << camera.getInhPosition().z << endl;
	cout << "angle: " << camera.getInhAngle().h << "," << camera.getInhAngle().p << "," << camera.getInhAngle().b << endl;
	*/

	return 0;
}