#pragma once
#include <deque>
#include <GL/glew.h>
#include "SceneBase.h"
#include "FKUT/TrackBall.h"
#include "Function.h"
#include "Timer.h"
#include "MapBase.h"
#include "Boy.h"
#include "Girl.h"

#include "Assassin01.h"
#include "AssaultRifle01.h"
#include "Bazooka01.h"
#include "Bomb01.h"
#include "Boss01.h"
#include "Enemy01.h"
#include "Hammer01.h"
#include "Punch01.h"
#include "Rush01.h"
#include "Shield01.h"
#include "Sword01.h"

#include "Smoke.h"
#include "Fire.h"

namespace StageBase
{
	enum Timer
	{
		FREE,
		ARROW_TIMER,
		EMERGE_TIMER,
		GAME_CLEAR_TIMER,
		GAME_OVER_TIMER,
		TIMER_MAX
	};
}

namespace Pause
{
	enum Str
	{
		RETURN_GAME,
		RETURN_TITLE,
		STR_MAX
	};
}

struct EnemyEmergeData
{
	int		section, kind, direction;
	double	posZ;
};

class C_StageBase : public C_SceneBase
{
protected:
	fk_Model			lightModel;
	fk_Light			light;

	fk_Vector			primalCameraPos;	// J̏ʒuۑĂ

	fkut_BlockModel		cameraPoint;
	double				zoomOutDist;

	bool				sectionMove_flag;
	int					sectionNum, finalSectionNum;

	bool				stageClear_flag;

	bool				pause_flag;
	fkut_SpriteModel	pause_cursor;
	int					pause_cursorPos;
	fkut_SpriteModel	pause_str[Pause::STR_MAX];

	C_MapBase			map;
	C_Boy				boy;
	C_Girl				girl;

	deque<unsigned int>				limitEnemyNum;		// ɑ݂łG̏(ՓxAׂɂĒ)
	deque<EnemyEmergeData>			enemyEmergeData;	// G̏of[^
	vector<C_EnemyBase *>			enemyArray;			// G̎
	vector<C_EnemyBase *>::iterator	itEnemyArray;
	deque<int>						maxSectionEnemyNum;	// ̋ԂɏoG̍ő吔(0ɂȂ玟̋Ԃ)
	int								totalEnemyNum;		// G̏o(ID鎞ɗp)

	bool	loadEnemyData(const string &cfgFileName);	// Gf[^̓ǂݍ

	fkut_SpriteModel	arrow;			// ̋Ԃ̕\

	//fk_Model			bgModel, floorModel;	// wiƏp̃f
	//fk_RectTexture		bgRect, floorRect;

	deque<SmokeModel *>	smokeModel;		// GtFNg
	deque<FireModel *>	fireModel;

	vector<C_Timer>		timer;

public:
	C_StageBase(fk_Window *, C_EventManager *);
	virtual ~C_StageBase(void);

	void emergeEnemy();				// G̏o
	void procDamage();				// _[W
	void vanishEnemy();				// G̏ŏ
	void procSectionMove();			// Ԃ̈ړ
	void procEffect();				// GtFNg̏
	virtual void cameraMove();		// J̈ړ
	void countTimer();				// ^C}[JEg
	void callPause();				// |[YʂĂ
	int procPause();				// |[Y̏

	int procCommon();				// Xe[Wʂ̏
};