#include "Boy.h"
#include "Girl.h"
#include "Sword01.h"

using namespace EnemyBase;
using namespace Sword01;

C_Sword01::C_Sword01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	//body.setMaterial(GlossBlack);
	body.setMaterial(White);
	body.getMaterial()->setSpecular(0.8, 0.8, 0.0);
	body.getMaterial()->setShininess(100.0);

	//xfile.load("Data/CG/Character/boss/meka.x", "Data/CG/Character/boss/meka_tex.bmp");
	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_SWORD01].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	//model.setTexUse(true);	// eNX`g[h
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Sword01::~C_Sword01()
{
}

// ړ
void C_Sword01::move()
{
	spd.init();				// ړx0ɖ߂
	updateDistToPlayer();	// vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		// ߂̃vC[_
		lockTarget = lockNear();

		// lockTargetɉčsς
		// ^[QbgboyȂ
		if(lockTarget == BOY)
		{
			// 
			turnToBoy(TURN_SPEED);

			// Ă
			if(distToBoy > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(SWORD_TIME + SWORD_DELAY);
				timer.at(SWORD_TIMER).setTime(SWORD_TIME);
			}
		}
		// ^[QbggirlȂ
		else if(lockTarget == GIRL)
		{
			// 
			turnToGirl(TURN_SPEED);

			// Ă
			if(distToGirl > ATTACK_DIST)	spd.z = -SPEED;	// ߂Â
			// KɋāAƏĂ΍U
			else if(getIsLock())
			{
				timer.at(ATTACK_TIMER).setTime(SWORD_TIME + SWORD_DELAY);
				timer.at(SWORD_TIMER).setTime(SWORD_TIME);
			}
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Sword01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		// 3AU
		if(timer.at(SWORD_TIMER).getTime() == SWORD_TIME || timer.at(SWORD_TIMER).getTime() == SWORD_TIME / 3 * 2 || timer.at(SWORD_TIMER).getTime() == SWORD_TIME / 3)
		{
			atkBlock.push_back(new C_HitBlockModel(30.0, 30.0, 85.0, SWORD_POWER, SWORD_LIMIT, false, ENEMY_SINGLE_ATTACK));
			atkBlock.back()->setMaterial(GlossBlack);
			atkBlock.back()->glMoveTo(pos);
			atkBlock.back()->glVec(body.getVec());
			atkBlock.back()->loTranslate(0.0, 0.0, -60.0);
			scene->entryModel(atkBlock.back());

			//cout << timer.at(SWORD_TIMER).getTime() << endl;

			// SE
			//sound.se_on(SE_ASSASSIN_PUNCH);
		}
	}

	// U̓蔻莞Ԃ𐧌
	if(atkBlock.size() > 0 && atkBlock.back()->cntLimit())
	{
		scene->removeModel(atkBlock.back());		// ubNremove
		SAFE_DELETE(atkBlock.back());
		atkBlock.pop_back();

		// vC[AttackData菜
		boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
		girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
	}
}