#include "XController.h"

C_XController controller[MAX_CONTROLLERS];	// XBOXRg[[NX錾

// RXgN^
C_XController::C_XController()
: vib_flag(true)
, isAuto(false)
, leftVibTimer(0)
, rightVibTimer(0)
{
	for(int i = 0; i < MAX_CONTROLLERS; ++i)
	{
		for(int j = 0; j < X_GAMEPAD_MAX; ++j)
		{
			controller[i].oldKeyState[j] = controller[i].newKeyState[j] = false;
			controller[i].pressCount[j] = 0;
		}
	}
	ZeroMemory( &vibration, sizeof(XINPUT_VIBRATION) );
}

// fXgN^
C_XController::~C_XController()
{
}

//////////Rg[[̏ԂXV//////////
HRESULT C_XController::UpdateControllerState()
{
	DWORD dwResult;
	for(DWORD i = 0; i < MAX_CONTROLLERS; ++i)
	{
		dwResult = XInputGetState(i, &controller[i].state);	// Rg[[̏Ԃ𓾂

		if(dwResult == ERROR_SUCCESS)	controller[i].Connected = true;
		else							controller[i].Connected = false;

		for(int j = 0; j < X_GAMEPAD_MAX; ++j)
		{
			controller[i].oldKeyState[j] = controller[i].newKeyState[j];
			controller[i].newKeyState[j] = false;	// SẴL[͂false
		}

		if(controller[i].Connected == true)	// ڑĂȂ
		{
			WORD padButtonBit = controller[i].state.Gamepad.wButtons;

			if(padButtonBit & XINPUT_GAMEPAD_A)	controller[i].newKeyState[X_GAMEPAD_A] = true;	// A
			if(padButtonBit & XINPUT_GAMEPAD_B)	controller[i].newKeyState[X_GAMEPAD_B] = true;	// B
			if(padButtonBit & XINPUT_GAMEPAD_X)	controller[i].newKeyState[X_GAMEPAD_X] = true;	// X
			if(padButtonBit & XINPUT_GAMEPAD_Y)	controller[i].newKeyState[X_GAMEPAD_Y] = true;	// Y

			if(padButtonBit & XINPUT_GAMEPAD_DPAD_UP)	controller[i].newKeyState[X_GAMEPAD_UP] = true;				// \L[
			else if(padButtonBit & XINPUT_GAMEPAD_DPAD_DOWN)	controller[i].newKeyState[X_GAMEPAD_DOWN] = true;	// \L[
			if(padButtonBit & XINPUT_GAMEPAD_DPAD_LEFT)	controller[i].newKeyState[X_GAMEPAD_LEFT] = true;			// \L[
			else if(padButtonBit & XINPUT_GAMEPAD_DPAD_RIGHT)	controller[i].newKeyState[X_GAMEPAD_RIGHT] = true;	// \L[E
			if(controller[i].newKeyState[X_GAMEPAD_UP] == false && controller[i].newKeyState[X_GAMEPAD_DOWN] == false
				&& controller[i].newKeyState[X_GAMEPAD_LEFT] == false && controller[i].newKeyState[X_GAMEPAD_RIGHT] == false)	
				controller[i].newKeyState[X_GAMEPAD_NEUTRAL] = true;	// \L[j[g

			if(padButtonBit & XINPUT_GAMEPAD_LEFT_SHOULDER)		controller[i].newKeyState[X_GAMEPAD_LB] = true;	// LB
			if(padButtonBit & XINPUT_GAMEPAD_RIGHT_SHOULDER)	controller[i].newKeyState[X_GAMEPAD_RB] = true;	// RB

			if(padButtonBit & XINPUT_GAMEPAD_LEFT_THUMB)	controller[i].newKeyState[X_GAMEPAD_LPUSH] = true;	// XeBbN
			if(padButtonBit & XINPUT_GAMEPAD_RIGHT_THUMB)	controller[i].newKeyState[X_GAMEPAD_RPUSH] = true;	// EXeBbN

			if(padButtonBit & XINPUT_GAMEPAD_BACK)	controller[i].newKeyState[X_GAMEPAD_BACK] = true;	// obN{^
			if(padButtonBit & XINPUT_GAMEPAD_START)	controller[i].newKeyState[X_GAMEPAD_START] = true;	// X^[g{^

			if(controller[i].state.Gamepad.sThumbLY > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_LS_UP] = true;			// XeBbN
			else if(controller[i].state.Gamepad.sThumbLY < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_LS_DOWN] = true;	// XeBbN
			if(controller[i].state.Gamepad.sThumbLX < -XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_LS_LEFT] = true;		// XeBbN
			else if(controller[i].state.Gamepad.sThumbLX > XINPUT_GAMEPAD_LEFT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_LS_RIGHT] = true;	// XeBbNE
			if(controller[i].newKeyState[X_GAMEPAD_LS_UP] == false && controller[i].newKeyState[X_GAMEPAD_LS_DOWN] == false
				&& controller[i].newKeyState[X_GAMEPAD_LS_LEFT] == false && controller[i].newKeyState[X_GAMEPAD_LS_RIGHT] == false)
				controller[i].newKeyState[X_GAMEPAD_LS_NEUTRAL] = true;	// XeBbNj[g

			if(controller[i].state.Gamepad.sThumbRY > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_RS_UP] = true;				// EXeBbN
			else if(controller[i].state.Gamepad.sThumbRY < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_RS_DOWN] = true;	// EXeBbN
			if(controller[i].state.Gamepad.sThumbRX < -XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)	controller[i].newKeyState[X_GAMEPAD_RS_LEFT] = true;			// EXeBbN
			else if(controller[i].state.Gamepad.sThumbRX > XINPUT_GAMEPAD_RIGHT_THUMB_DEADZONE)		controller[i].newKeyState[X_GAMEPAD_RS_RIGHT] = true;	// EXeBbNE
			if(controller[i].newKeyState[X_GAMEPAD_RS_UP] == false && controller[i].newKeyState[X_GAMEPAD_RS_DOWN] == false
				&& controller[i].newKeyState[X_GAMEPAD_RS_LEFT] == false && controller[i].newKeyState[X_GAMEPAD_RS_RIGHT] == false)
				controller[i].newKeyState[X_GAMEPAD_RS_NEUTRAL] = true;	// EXeBbNj[g

			if(controller[i].state.Gamepad.bLeftTrigger > XINPUT_GAMEPAD_TRIGGER_THRESHOLD)		controller[i].newKeyState[X_GAMEPAD_LT] = true;	// LT
			if(controller[i].state.Gamepad.bRightTrigger > XINPUT_GAMEPAD_TRIGGER_THRESHOLD)	controller[i].newKeyState[X_GAMEPAD_RT] = true;	// RT

			// ǂꂭ炢Ă邩
			for(int j = 0; j < X_GAMEPAD_MAX; ++j)
			{
				if(controller[i].KeyPress(j))	// Ă
				{
					if(controller[i].pressCount[j] != INT_MAX)	controller[i].pressCount[j]++;	// JEg𑝂₷
				}
				else	controller[i].pressCount[j] = 0;	// JEgZbg
			}

			XInputSetState( i, &vibration );	// U
			vibControl();	// UԂ𐧌
		}
	}
	return S_OK;
}

///////////////͔///////////////
// u
bool C_XController::KeyDown(int key)
{
	if(oldKeyState[key] == false && newKeyState[key] == true)	return true;
	return false;
}

// Ă
bool C_XController::KeyPress(int key)
{
	if(oldKeyState[key] == true && newKeyState[key] == true)	return true;
	return false;
}

// u
bool C_XController::KeyUp(int key)
{
	if(oldKeyState[key] == true && newKeyState[key] == false)	return true;
	return false;
}

// Ă
bool C_XController::KeyRelease(int key)
{
	if(oldKeyState[key] == false && newKeyState[key] == false)	return true;
	return false;
}

// pressCount擾
int C_XController::getPressCount(int key)
{
	return pressCount[key];
}

// U͂(Ul͈0`65535)
void C_XController::vib_on(int left, int right, int leftTimer, int rightTimer)
{
	if(vib_flag)	// U@\gȂ
	{
		if(0 <= left && left <= 65535)
		{
			// UD
			if(left >= vibration.wLeftMotorSpeed)
			{
				vibration.wLeftMotorSpeed = left;
				leftVibTimer = leftTimer;
			}
		}

		if(0 <= right && right <= 65535)
		{
			// UD
			if(right >= vibration.wRightMotorSpeed)
			{
				vibration.wRightMotorSpeed = right;
				rightVibTimer = rightTimer;
			}
		}
	}
}

// UԂ𐧌䂷
void C_XController::vibControl()
{
	if(leftVibTimer > 0)
	{
		leftVibTimer--;
		if(leftVibTimer == 0)	vibration.wLeftMotorSpeed = 0;
	}

	if(rightVibTimer > 0)
	{
		rightVibTimer--;
		if(rightVibTimer == 0)	vibration.wRightMotorSpeed = 0;
	}
}

// U@\ON/OFF
void C_XController::setVib_flag(bool flag)
{
	vib_flag = flag;
}

// U@\ONȂtrue, OFFȂfalseԂ
bool C_XController::getVib_flag()
{
	return vib_flag;
}

// I[g[hON/OFF
void C_XController::setIsAuto(bool flag)
{
	isAuto = flag;
}

// I[g[hONȂtrue, OFFȂfalseԂ
bool C_XController::getIsAuto()
{
	return isAuto;
}