#include "XFile.h"

//RXgN^𗘗pāAB
C_DX3File::C_DX3File(void)
{
	init();

	return;
}

C_DX3File::~C_DX3File(void)
{
}

void C_DX3File::init(void)
{
	DX3_IFSTexture.init();
	DX3_IFSTexture.setConnectMode(true);
	timeCount = 0.0;
	looptime = 60.0;
	startmotiontime = 0.0;
	loopset = true;
}

void C_DX3File::load(const string &XFileName,const string &TextureFileName)
{
	init();

	/*
	̓eNX`肢B
	eNX`t@C̊gq͂ƂASďœ͂Ă
	t@C̓ǂݍ݂ŉ̃G[i݂ȂAǂݍ߂ȂꍇjꍇAu(gq) File Read Error!vƂȂ܂
	t@C̊gq̎w肪ԈĂꍇuTextureFileName extension Error!vƂȂ܂
	*/

	if(TextureFileName.find(".png") != string::npos)
	{
		if(DX3_IFSTexture.readPNG(TextureFileName) == false)
		{
			fl_alert("%s : PNG File Read Error!",TextureFileName.c_str());
		}
	}
	else if(TextureFileName.find(".bmp") != string::npos)
	{
		if(DX3_IFSTexture.readBMP(TextureFileName) == false)
		{
			fl_alert("%s : BMP File Read Error!",TextureFileName.c_str());
		}
	}
	else if(TextureFileName.find(".jpg") != string::npos)
	{
		if(DX3_IFSTexture.readJPG(TextureFileName) == false)
		{
			fl_alert("%s : JPG File Read Error!",TextureFileName.c_str());
		}
	}
	else
	{
			fl_alert("%s : TextureFileName extension Error!",TextureFileName.c_str());
	}
	
	//Xt@C̒ŁB
	if(DX3_IFSTexture.readD3DXFile(XFileName,"",-1) == false)
	{
		fl_alert("%s : X File Read Error!",XFileName.c_str());
	}
}

void C_DX3File::Motion_loopsetting(const bool lp,const double st,const double mt)
{
	if((mt - st) >= 0)
	{
		loopset = lp;
		startmotiontime = st;
		timeCount = st;
		if(mt > 0)
		{
			looptime = mt;
		}	
	}
	else
	{
		fl_alert("Loop time Error!");
	}
}


void C_DX3File::Motion_play(const double mt)
{
	if(timeCount < looptime)
	{
		DX3_IFSTexture.setAnimationTime(timeCount);
		timeCount += mt;
	}
	else if(loopset == true)
	{
		DX3_IFSTexture.setAnimationTime(timeCount);
		timeCount = startmotiontime;
	}
	else{}
}

void C_DX3File::Motion_set(fk_BVHMotion *BVHName,const bool lp,const double st,const double mt)
{
	DX3_IFSTexture.setBVHMotion(BVHName);
	looptime = BVHName->getFrameLength();
	Motion_loopsetting(lp,st,mt);
}

void C_DX3File::Motion_loadset(const string &BVHFileName,const bool lp,const double st,const double mt)
{
	DX3_BVH.init();
	if(DX3_BVH.readBVHFile(BVHFileName) == false)
	{
		fl_alert("%s : BVH File Read Error!",BVHFileName.c_str());
	}
	else
	{
		DX3_IFSTexture.setBVHMotion(&DX3_BVH);
		looptime = DX3_BVH.getFrameLength();
		Motion_loopsetting(lp,st,mt);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ȉAXt@C̃f𑍊NX

C_XModel xModel;

C_XModel::C_XModel()
{
	init();

	return;
}

C_XModel::~C_XModel()
{
}

void C_XModel::init()
{
	printf("XFile Load Start...");		//fobOpAXt@C̓ǂݍ݂łĂ邩mFB

	model[X_BOY].load("Data/CG/Character/player/boy.x", "Data/CG/Character/player/boy_tex.png");
	model[X_GIRL].load("Data/CG/Character/player/girl.x", "Data/CG/Character/player/girl_tex.png");

	model[X_ASSASSIN01].load("Data/CG/Character/enemy/enemy04.x", "Data/CG/Character/enemy/enemy04.png");
	model[X_ASSAULT_RIFLE01].load("Data/CG/Character/enemy/enemy01.x", "Data/CG/Character/enemy/enemy01.png");
	model[X_BAZOOKA01].load("Data/CG/Character/enemy/enemy01.x", "Data/CG/Character/enemy/enemy01.png");
	model[X_BOMB01].load("Data/CG/Character/enemy/enemy02.x", "Data/CG/Character/enemy/enemy02.png");
	model[X_BOSS01].load("Data/CG/Character/boss/boss01.x", "Data/CG/Character/boss/boss01.png");
	model[X_HAMMER01].load("Data/CG/Character/enemy/enemy03.x", "Data/CG/Character/enemy/enemy03.png");
	model[X_PUNCH01].load("Data/CG/Character/enemy/enemy04.x", "Data/CG/Character/enemy/enemy04.png");
	model[X_RUSH01].load("Data/CG/Character/enemy/enemy04.x", "Data/CG/Character/enemy/enemy04.png");
	model[X_SHIELD01].load("Data/CG/Character/enemy/enemy03.x", "Data/CG/Character/enemy/enemy03.png");
	model[X_SWORD01].load("Data/CG/Character/enemy/enemy03.x", "Data/CG/Character/enemy/enemy03.png");

	printf("Complete!\n");				//fobOpAt[YĂ킯ł͂ȂƂmFB
}